# Source Generated with Decompyle++
# File: in.pyo (Python 2.5)

from libxmlmods import libxml2mod
import types
import sys

class libxmlError(Exception):
    pass


def pos_id(o):
    i = id(o)
    if i < 0:
        return sys.maxint - i
    
    return i


class treeError(libxmlError):
    
    def __init__(self, msg):
        self.msg = msg

    
    def __str__(self):
        return self.msg



class parserError(libxmlError):
    
    def __init__(self, msg):
        self.msg = msg

    
    def __str__(self):
        return self.msg



class uriError(libxmlError):
    
    def __init__(self, msg):
        self.msg = msg

    
    def __str__(self):
        return self.msg



class xpathError(libxmlError):
    
    def __init__(self, msg):
        self.msg = msg

    
    def __str__(self):
        return self.msg



class ioWrapper:
    
    def __init__(self, _obj):
        self._ioWrapper__io = _obj
        self._o = None

    
    def io_close(self):
        if self._ioWrapper__io == None:
            return -1
        
        self._ioWrapper__io.close()
        self._ioWrapper__io = None
        return 0

    
    def io_flush(self):
        if self._ioWrapper__io == None:
            return -1
        
        self._ioWrapper__io.flush()
        return 0

    
    def io_read(self, len = -1):
        if self._ioWrapper__io == None:
            return -1
        
        if len < 0:
            return self._ioWrapper__io.read()
        
        return self._ioWrapper__io.read(len)

    
    def io_write(self, str, len = -1):
        if self._ioWrapper__io == None:
            return -1
        
        if len < 0:
            return self._ioWrapper__io.write(str)
        
        return self._ioWrapper__io.write(str, len)



class ioReadWrapper(ioWrapper):
    
    def __init__(self, _obj, enc = ''):
        ioWrapper.__init__(self, _obj)
        self._o = libxml2mod.xmlCreateInputBuffer(self, enc)

    
    def __del__(self):
        print '__del__'
        self.io_close()
        if self._o != None:
            libxml2mod.xmlFreeParserInputBuffer(self._o)
        
        self._o = None

    
    def close(self):
        self.io_close()
        if self._o != None:
            libxml2mod.xmlFreeParserInputBuffer(self._o)
        
        self._o = None



class ioWriteWrapper(ioWrapper):
    
    def __init__(self, _obj, enc = ''):
        if type(_obj) == type(''):
            print 'write io from a string'
            self.o = None
        elif type(_obj) == types.InstanceType:
            print 'write io from instance of %s' % _obj.__class__
            ioWrapper.__init__(self, _obj)
            self._o = libxml2mod.xmlCreateOutputBuffer(self, enc)
        else:
            file = libxml2mod.outputBufferGetPythonFile(_obj)
            if file != None:
                ioWrapper.__init__(self, file)
            else:
                ioWrapper.__init__(self, _obj)
            self._o = _obj

    
    def __del__(self):
        self.io_close()
        if self._o != None:
            libxml2mod.xmlOutputBufferClose(self._o)
        
        self._o = None

    
    def flush(self):
        self.io_flush()
        if self._o != None:
            libxml2mod.xmlOutputBufferClose(self._o)
        
        self._o = None

    
    def close(self):
        self.io_flush()
        if self._o != None:
            libxml2mod.xmlOutputBufferClose(self._o)
        
        self._o = None



class SAXCallback:
    
    def startDocument(self):
        pass

    
    def endDocument(self):
        pass

    
    def startElement(self, tag, attrs):
        pass

    
    def endElement(self, tag):
        pass

    
    def characters(self, data):
        pass

    
    def cdataBlock(self, data):
        pass

    
    def reference(self, name):
        pass

    
    def ignorableWhitespace(self, data):
        pass

    
    def processingInstruction(self, target, data):
        pass

    
    def comment(self, content):
        pass

    
    def externalSubset(self, name, externalID, systemID):
        pass

    
    def internalSubset(self, name, externalID, systemID):
        pass

    
    def entityDecl(self, name, type, externalID, systemID, content):
        pass

    
    def notationDecl(self, name, externalID, systemID):
        pass

    
    def attributeDecl(self, elem, name, type, defi, defaultValue, nameList):
        pass

    
    def elementDecl(self, name, type, content):
        pass

    
    def entityDecl(self, name, publicId, systemID, notationName):
        pass

    
    def warning(self, msg):
        pass

    
    def error(self, msg):
        raise parserError(msg)

    
    def fatalError(self, msg):
        raise parserError(msg)



class xmlCore:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __eq__(self, other):
        if other == None:
            return False
        
        ret = libxml2mod.compareNodesEqual(self._o, other._o)
        if ret == None:
            return False
        
        return ret == True

    
    def __ne__(self, other):
        if other == None:
            return True
        
        ret = libxml2mod.compareNodesEqual(self._o, other._o)
        return not ret

    
    def __hash__(self):
        ret = libxml2mod.nodeHash(self._o)
        return ret

    
    def __str__(self):
        return self.serialize()

    
    def get_parent(self):
        ret = libxml2mod.parent(self._o)
        if ret == None:
            return None
        
        return xmlNode(_obj = ret)

    
    def get_children(self):
        ret = libxml2mod.children(self._o)
        if ret == None:
            return None
        
        return xmlNode(_obj = ret)

    
    def get_last(self):
        ret = libxml2mod.last(self._o)
        if ret == None:
            return None
        
        return xmlNode(_obj = ret)

    
    def get_next(self):
        ret = libxml2mod.next(self._o)
        if ret == None:
            return None
        
        return xmlNode(_obj = ret)

    
    def get_properties(self):
        ret = libxml2mod.properties(self._o)
        if ret == None:
            return None
        
        return xmlAttr(_obj = ret)

    
    def get_prev(self):
        ret = libxml2mod.prev(self._o)
        if ret == None:
            return None
        
        return xmlNode(_obj = ret)

    
    def get_content(self):
        return libxml2mod.xmlNodeGetContent(self._o)

    getContent = get_content
    
    def get_name(self):
        return libxml2mod.name(self._o)

    
    def get_type(self):
        return libxml2mod.type(self._o)

    
    def get_doc(self):
        ret = libxml2mod.doc(self._o)
        if ret == None:
            if self.type in ('document_xml', 'document_html'):
                return xmlDoc(_obj = self._o)
            else:
                return None
        
        return xmlDoc(_obj = ret)

    import sys
    if float(sys.version[0:3]) < 2.2:
        
        def __getattr__(self, attr):
            if attr == 'parent':
                ret = libxml2mod.parent(self._o)
                if ret == None:
                    return None
                
                return xmlNode(_obj = ret)
            elif attr == 'properties':
                ret = libxml2mod.properties(self._o)
                if ret == None:
                    return None
                
                return xmlAttr(_obj = ret)
            elif attr == 'children':
                ret = libxml2mod.children(self._o)
                if ret == None:
                    return None
                
                return xmlNode(_obj = ret)
            elif attr == 'last':
                ret = libxml2mod.last(self._o)
                if ret == None:
                    return None
                
                return xmlNode(_obj = ret)
            elif attr == 'next':
                ret = libxml2mod.next(self._o)
                if ret == None:
                    return None
                
                return xmlNode(_obj = ret)
            elif attr == 'prev':
                ret = libxml2mod.prev(self._o)
                if ret == None:
                    return None
                
                return xmlNode(_obj = ret)
            elif attr == 'content':
                return libxml2mod.xmlNodeGetContent(self._o)
            elif attr == 'name':
                return libxml2mod.name(self._o)
            elif attr == 'type':
                return libxml2mod.type(self._o)
            elif attr == 'doc':
                ret = libxml2mod.doc(self._o)
                if ret == None:
                    if self.type == 'document_xml' or self.type == 'document_html':
                        return xmlDoc(_obj = self._o)
                    else:
                        return None
                
                return xmlDoc(_obj = ret)
            
            raise AttributeError, attr

    else:
        parent = property(get_parent, None, None, 'Parent node')
        children = property(get_children, None, None, 'First child node')
        last = property(get_last, None, None, 'Last sibling node')
        next = property(get_next, None, None, 'Next sibling node')
        prev = property(get_prev, None, None, 'Previous sibling node')
        properties = property(get_properties, None, None, 'List of properies')
        content = property(get_content, None, None, 'Content of this node')
        name = property(get_name, None, None, 'Node name')
        type = property(get_type, None, None, 'Node type')
        doc = property(get_doc, None, None, 'The document this node belongs to')
    
    def serialize(self, encoding = None, format = 0):
        return libxml2mod.serializeNode(self._o, encoding, format)

    
    def saveTo(self, file, encoding = None, format = 0):
        return libxml2mod.saveNodeTo(self._o, file, encoding, format)

    
    def c14nMemory(self, nodes = None, exclusive = 0, prefixes = None, with_comments = 0):
        if nodes:
            nodes = map((lambda n: n._o), nodes)
        
        return libxml2mod.xmlC14NDocDumpMemory(self.get_doc()._o, nodes, exclusive != 0, prefixes, with_comments != 0)

    
    def c14nSaveTo(self, file, nodes = None, exclusive = 0, prefixes = None, with_comments = 0):
        if nodes:
            nodes = map((lambda n: n._o), nodes)
        
        return libxml2mod.xmlC14NDocSaveTo(self.get_doc()._o, nodes, exclusive != 0, prefixes, with_comments != 0, file)

    
    def xpathEval(self, expr):
        doc = self.doc
        if doc == None:
            return None
        
        ctxt = doc.xpathNewContext()
        ctxt.setContextNode(self)
        res = ctxt.xpathEval(expr)
        ctxt.xpathFreeContext()
        return res

    
    def xpathEval2(self, expr):
        return self.xpathEval(expr)

    
    def removeNsDef(self, href):
        ret = libxml2mod.xmlNodeRemoveNsDef(self._o, href)
        if ret is None:
            return None
        
        _xmlCore__tmp = xmlNs(_obj = ret)
        return _xmlCore__tmp

    
    def walk_depth_first(self):
        return xmlCoreDepthFirstItertor(self)

    
    def walk_breadth_first(self):
        return xmlCoreBreadthFirstItertor(self)

    __iter__ = walk_depth_first
    
    def free(self):
        
        try:
            self.doc._ctxt.xpathFreeContext()
        except:
            pass

        libxml2mod.xmlFreeDoc(self._o)



class xmlCoreDepthFirstItertor:
    
    def __init__(self, node):
        self.node = node
        self.parents = []

    
    def __iter__(self):
        return self

    
    def next(self):
        while self.node:
            ret = self.node
            self.parents.append(self.node)
            self.node = self.node.children
            return ret
        
        try:
            parent = self.parents.pop()
        except IndexError:
            raise StopIteration

        self.node = parent.next
        continue



class xmlCoreBreadthFirstItertor:
    
    def __init__(self, node):
        self.node = node
        self.parents = []

    
    def __iter__(self):
        return self

    
    def next(self):
        while self.node:
            ret = self.node
            self.parents.append(self.node)
            self.node = self.node.next
            return ret
        
        try:
            parent = self.parents.pop()
        except IndexError:
            raise StopIteration

        self.node = parent.children
        continue



def nodeWrap(o):
    name = libxml2mod.type(o)
    if name == 'element' or name == 'text':
        return xmlNode(_obj = o)
    
    if name == 'attribute':
        return xmlAttr(_obj = o)
    
    if name[0:8] == 'document':
        return xmlDoc(_obj = o)
    
    if name == 'namespace':
        return xmlNs(_obj = o)
    
    if name == 'elem_decl':
        return xmlElement(_obj = o)
    
    if name == 'attribute_decl':
        return xmlAttribute(_obj = o)
    
    if name == 'entity_decl':
        return xmlEntity(_obj = o)
    
    if name == 'dtd':
        return xmlDtd(_obj = o)
    
    return xmlNode(_obj = o)


def xpathObjectRet(o):
    otype = type(o)
    if otype == type([]):
        ret = map(xpathObjectRet, o)
        return ret
    elif otype == type(()):
        ret = map(xpathObjectRet, o)
        return tuple(ret)
    elif otype == type('') and otype == type(0) or otype == type(0):
        return o
    else:
        return nodeWrap(o)


def registerXPathFunction(ctxt, name, ns_uri, f):
    ret = libxml2mod.xmlRegisterXPathFunction(ctxt, name, ns_uri, f)

PARSER_LOADDTD = 1
PARSER_DEFAULTATTRS = 2
PARSER_VALIDATE = 3
PARSER_SUBST_ENTITIES = 4
PARSER_SEVERITY_VALIDITY_WARNING = 1
PARSER_SEVERITY_VALIDITY_ERROR = 2
PARSER_SEVERITY_WARNING = 3
PARSER_SEVERITY_ERROR = 4

def registerErrorHandler(f, ctx):
    import sys
    if not sys.modules.has_key('libxslt'):
        ret = libxml2mod.xmlRegisterErrorHandler(f, ctx)
    else:
        import libxslt
        ret = libxslt.registerErrorHandler(f, ctx)
    return ret


class parserCtxtCore:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlFreeParserCtxt(self._o)
        
        self._o = None

    
    def setErrorHandler(self, f, arg):
        libxml2mod.xmlParserCtxtSetErrorHandler(self._o, f, arg)

    
    def getErrorHandler(self):
        return libxml2mod.xmlParserCtxtGetErrorHandler(self._o)

    
    def addLocalCatalog(self, uri):
        return libxml2mod.addLocalCatalog(self._o, uri)



class ValidCtxtCore:
    
    def __init__(self, *args, **kw):
        pass

    
    def setValidityErrorHandler(self, err_func, warn_func, arg = None):
        libxml2mod.xmlSetValidErrors(self._o, err_func, warn_func, arg)



class SchemaValidCtxtCore:
    
    def __init__(self, *args, **kw):
        pass

    
    def setValidityErrorHandler(self, err_func, warn_func, arg = None):
        libxml2mod.xmlSchemaSetValidErrors(self._o, err_func, warn_func, arg)



class relaxNgValidCtxtCore:
    
    def __init__(self, *args, **kw):
        pass

    
    def setValidityErrorHandler(self, err_func, warn_func, arg = None):
        libxml2mod.xmlRelaxNGSetValidErrors(self._o, err_func, warn_func, arg)



def _xmlTextReaderErrorFunc(.0, msg, severity, locator):
    (f, arg) = .0
    return f(arg, msg, severity, xmlTextReaderLocator(locator))


class xmlTextReaderCore:
    
    def __init__(self, _obj = None):
        self.input = None
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlFreeTextReader(self._o)
        
        self._o = None

    
    def SetErrorHandler(self, f, arg):
        if f is None:
            libxml2mod.xmlTextReaderSetErrorHandler(self._o, None, None)
        else:
            libxml2mod.xmlTextReaderSetErrorHandler(self._o, _xmlTextReaderErrorFunc, (f, arg))

    
    def GetErrorHandler(self):
        (f, arg) = libxml2mod.xmlTextReaderGetErrorHandler(self._o)
        if f is None:
            return (None, None)
        else:
            return arg



def cleanupParser():
    libxml2mod.xmlPythonCleanupParser()


def htmlCreateMemoryParserCtxt(buffer, size):
    ret = libxml2mod.htmlCreateMemoryParserCtxt(buffer, size)
    if ret is None:
        raise parserError('htmlCreateMemoryParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def htmlHandleOmittedElem(val):
    ret = libxml2mod.htmlHandleOmittedElem(val)
    return ret


def htmlIsScriptAttribute(name):
    ret = libxml2mod.htmlIsScriptAttribute(name)
    return ret


def htmlNewParserCtxt():
    ret = libxml2mod.htmlNewParserCtxt()
    if ret is None:
        raise parserError('htmlNewParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def htmlParseDoc(cur, encoding):
    ret = libxml2mod.htmlParseDoc(cur, encoding)
    if ret is None:
        raise parserError('htmlParseDoc() failed')
    
    return xmlDoc(_obj = ret)


def htmlParseFile(filename, encoding):
    ret = libxml2mod.htmlParseFile(filename, encoding)
    if ret is None:
        raise parserError('htmlParseFile() failed')
    
    return xmlDoc(_obj = ret)


def htmlReadDoc(cur, URL, encoding, options):
    ret = libxml2mod.htmlReadDoc(cur, URL, encoding, options)
    if ret is None:
        raise treeError('htmlReadDoc() failed')
    
    return xmlDoc(_obj = ret)


def htmlReadFd(fd, URL, encoding, options):
    ret = libxml2mod.htmlReadFd(fd, URL, encoding, options)
    if ret is None:
        raise treeError('htmlReadFd() failed')
    
    return xmlDoc(_obj = ret)


def htmlReadFile(filename, encoding, options):
    ret = libxml2mod.htmlReadFile(filename, encoding, options)
    if ret is None:
        raise treeError('htmlReadFile() failed')
    
    return xmlDoc(_obj = ret)


def htmlReadMemory(buffer, size, URL, encoding, options):
    ret = libxml2mod.htmlReadMemory(buffer, size, URL, encoding, options)
    if ret is None:
        raise treeError('htmlReadMemory() failed')
    
    return xmlDoc(_obj = ret)


def htmlIsBooleanAttr(name):
    ret = libxml2mod.htmlIsBooleanAttr(name)
    return ret


def htmlNewDoc(URI, ExternalID):
    ret = libxml2mod.htmlNewDoc(URI, ExternalID)
    if ret is None:
        raise treeError('htmlNewDoc() failed')
    
    return xmlDoc(_obj = ret)


def htmlNewDocNoDtD(URI, ExternalID):
    ret = libxml2mod.htmlNewDocNoDtD(URI, ExternalID)
    if ret is None:
        raise treeError('htmlNewDocNoDtD() failed')
    
    return xmlDoc(_obj = ret)


def SAXDefaultVersion(version):
    ret = libxml2mod.xmlSAXDefaultVersion(version)
    return ret


def defaultSAXHandlerInit():
    libxml2mod.xmlDefaultSAXHandlerInit()


def docbDefaultSAXHandlerInit():
    libxml2mod.docbDefaultSAXHandlerInit()


def htmlDefaultSAXHandlerInit():
    libxml2mod.htmlDefaultSAXHandlerInit()


def catalogAdd(type, orig, replace):
    ret = libxml2mod.xmlCatalogAdd(type, orig, replace)
    return ret


def catalogCleanup():
    libxml2mod.xmlCatalogCleanup()


def catalogConvert():
    ret = libxml2mod.xmlCatalogConvert()
    return ret


def catalogDump(out):
    libxml2mod.xmlCatalogDump(out)


def catalogGetPublic(pubID):
    ret = libxml2mod.xmlCatalogGetPublic(pubID)
    return ret


def catalogGetSystem(sysID):
    ret = libxml2mod.xmlCatalogGetSystem(sysID)
    return ret


def catalogRemove(value):
    ret = libxml2mod.xmlCatalogRemove(value)
    return ret


def catalogResolve(pubID, sysID):
    ret = libxml2mod.xmlCatalogResolve(pubID, sysID)
    return ret


def catalogResolvePublic(pubID):
    ret = libxml2mod.xmlCatalogResolvePublic(pubID)
    return ret


def catalogResolveSystem(sysID):
    ret = libxml2mod.xmlCatalogResolveSystem(sysID)
    return ret


def catalogResolveURI(URI):
    ret = libxml2mod.xmlCatalogResolveURI(URI)
    return ret


def catalogSetDebug(level):
    ret = libxml2mod.xmlCatalogSetDebug(level)
    return ret


def initializeCatalog():
    libxml2mod.xmlInitializeCatalog()


def loadACatalog(filename):
    ret = libxml2mod.xmlLoadACatalog(filename)
    if ret is None:
        raise treeError('xmlLoadACatalog() failed')
    
    return catalog(_obj = ret)


def loadCatalog(filename):
    ret = libxml2mod.xmlLoadCatalog(filename)
    return ret


def loadCatalogs(pathss):
    libxml2mod.xmlLoadCatalogs(pathss)


def loadSGMLSuperCatalog(filename):
    ret = libxml2mod.xmlLoadSGMLSuperCatalog(filename)
    if ret is None:
        raise treeError('xmlLoadSGMLSuperCatalog() failed')
    
    return catalog(_obj = ret)


def newCatalog(sgml):
    ret = libxml2mod.xmlNewCatalog(sgml)
    if ret is None:
        raise treeError('xmlNewCatalog() failed')
    
    return catalog(_obj = ret)


def parseCatalogFile(filename):
    ret = libxml2mod.xmlParseCatalogFile(filename)
    if ret is None:
        raise parserError('xmlParseCatalogFile() failed')
    
    return xmlDoc(_obj = ret)


def isBaseChar(ch):
    ret = libxml2mod.xmlIsBaseChar(ch)
    return ret


def isBlank(ch):
    ret = libxml2mod.xmlIsBlank(ch)
    return ret


def isChar(ch):
    ret = libxml2mod.xmlIsChar(ch)
    return ret


def isCombining(ch):
    ret = libxml2mod.xmlIsCombining(ch)
    return ret


def isDigit(ch):
    ret = libxml2mod.xmlIsDigit(ch)
    return ret


def isExtender(ch):
    ret = libxml2mod.xmlIsExtender(ch)
    return ret


def isIdeographic(ch):
    ret = libxml2mod.xmlIsIdeographic(ch)
    return ret


def isPubidChar(ch):
    ret = libxml2mod.xmlIsPubidChar(ch)
    return ret


def boolToText(boolval):
    ret = libxml2mod.xmlBoolToText(boolval)
    return ret


def debugDumpString(output, str):
    libxml2mod.xmlDebugDumpString(output, str)


def shellPrintXPathError(errorType, arg):
    libxml2mod.xmlShellPrintXPathError(errorType, arg)


def dictCleanup():
    libxml2mod.xmlDictCleanup()


def addEncodingAlias(name, alias):
    ret = libxml2mod.xmlAddEncodingAlias(name, alias)
    return ret


def cleanupCharEncodingHandlers():
    libxml2mod.xmlCleanupCharEncodingHandlers()


def cleanupEncodingAliases():
    libxml2mod.xmlCleanupEncodingAliases()


def delEncodingAlias(alias):
    ret = libxml2mod.xmlDelEncodingAlias(alias)
    return ret


def encodingAlias(alias):
    ret = libxml2mod.xmlGetEncodingAlias(alias)
    return ret


def initCharEncodingHandlers():
    libxml2mod.xmlInitCharEncodingHandlers()


def cleanupPredefinedEntities():
    libxml2mod.xmlCleanupPredefinedEntities()


def initializePredefinedEntities():
    libxml2mod.xmlInitializePredefinedEntities()


def predefinedEntity(name):
    ret = libxml2mod.xmlGetPredefinedEntity(name)
    if ret is None:
        raise treeError('xmlGetPredefinedEntity() failed')
    
    return xmlEntity(_obj = ret)


def cleanupGlobals():
    libxml2mod.xmlCleanupGlobals()


def initGlobals():
    libxml2mod.xmlInitGlobals()


def thrDefDefaultBufferSize(v):
    ret = libxml2mod.xmlThrDefDefaultBufferSize(v)
    return ret


def thrDefDoValidityCheckingDefaultValue(v):
    ret = libxml2mod.xmlThrDefDoValidityCheckingDefaultValue(v)
    return ret


def thrDefGetWarningsDefaultValue(v):
    ret = libxml2mod.xmlThrDefGetWarningsDefaultValue(v)
    return ret


def thrDefIndentTreeOutput(v):
    ret = libxml2mod.xmlThrDefIndentTreeOutput(v)
    return ret


def thrDefKeepBlanksDefaultValue(v):
    ret = libxml2mod.xmlThrDefKeepBlanksDefaultValue(v)
    return ret


def thrDefLineNumbersDefaultValue(v):
    ret = libxml2mod.xmlThrDefLineNumbersDefaultValue(v)
    return ret


def thrDefLoadExtDtdDefaultValue(v):
    ret = libxml2mod.xmlThrDefLoadExtDtdDefaultValue(v)
    return ret


def thrDefParserDebugEntities(v):
    ret = libxml2mod.xmlThrDefParserDebugEntities(v)
    return ret


def thrDefPedanticParserDefaultValue(v):
    ret = libxml2mod.xmlThrDefPedanticParserDefaultValue(v)
    return ret


def thrDefSaveNoEmptyTags(v):
    ret = libxml2mod.xmlThrDefSaveNoEmptyTags(v)
    return ret


def thrDefSubstituteEntitiesDefaultValue(v):
    ret = libxml2mod.xmlThrDefSubstituteEntitiesDefaultValue(v)
    return ret


def thrDefTreeIndentString(v):
    ret = libxml2mod.xmlThrDefTreeIndentString(v)
    return ret


def nanoFTPCleanup():
    libxml2mod.xmlNanoFTPCleanup()


def nanoFTPInit():
    libxml2mod.xmlNanoFTPInit()


def nanoFTPProxy(host, port, user, passwd, type):
    libxml2mod.xmlNanoFTPProxy(host, port, user, passwd, type)


def nanoFTPScanProxy(URL):
    libxml2mod.xmlNanoFTPScanProxy(URL)


def nanoHTTPCleanup():
    libxml2mod.xmlNanoHTTPCleanup()


def nanoHTTPInit():
    libxml2mod.xmlNanoHTTPInit()


def nanoHTTPScanProxy(URL):
    libxml2mod.xmlNanoHTTPScanProxy(URL)


def createDocParserCtxt(cur):
    ret = libxml2mod.xmlCreateDocParserCtxt(cur)
    if ret is None:
        raise parserError('xmlCreateDocParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def initParser():
    libxml2mod.xmlInitParser()


def keepBlanksDefault(val):
    ret = libxml2mod.xmlKeepBlanksDefault(val)
    return ret


def lineNumbersDefault(val):
    ret = libxml2mod.xmlLineNumbersDefault(val)
    return ret


def newParserCtxt():
    ret = libxml2mod.xmlNewParserCtxt()
    if ret is None:
        raise parserError('xmlNewParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def parseDTD(ExternalID, SystemID):
    ret = libxml2mod.xmlParseDTD(ExternalID, SystemID)
    if ret is None:
        raise parserError('xmlParseDTD() failed')
    
    return xmlDtd(_obj = ret)


def parseDoc(cur):
    ret = libxml2mod.xmlParseDoc(cur)
    if ret is None:
        raise parserError('xmlParseDoc() failed')
    
    return xmlDoc(_obj = ret)


def parseEntity(filename):
    ret = libxml2mod.xmlParseEntity(filename)
    if ret is None:
        raise parserError('xmlParseEntity() failed')
    
    return xmlDoc(_obj = ret)


def parseFile(filename):
    ret = libxml2mod.xmlParseFile(filename)
    if ret is None:
        raise parserError('xmlParseFile() failed')
    
    return xmlDoc(_obj = ret)


def parseMemory(buffer, size):
    ret = libxml2mod.xmlParseMemory(buffer, size)
    if ret is None:
        raise parserError('xmlParseMemory() failed')
    
    return xmlDoc(_obj = ret)


def pedanticParserDefault(val):
    ret = libxml2mod.xmlPedanticParserDefault(val)
    return ret


def readDoc(cur, URL, encoding, options):
    ret = libxml2mod.xmlReadDoc(cur, URL, encoding, options)
    if ret is None:
        raise treeError('xmlReadDoc() failed')
    
    return xmlDoc(_obj = ret)


def readFd(fd, URL, encoding, options):
    ret = libxml2mod.xmlReadFd(fd, URL, encoding, options)
    if ret is None:
        raise treeError('xmlReadFd() failed')
    
    return xmlDoc(_obj = ret)


def readFile(filename, encoding, options):
    ret = libxml2mod.xmlReadFile(filename, encoding, options)
    if ret is None:
        raise treeError('xmlReadFile() failed')
    
    return xmlDoc(_obj = ret)


def readMemory(buffer, size, URL, encoding, options):
    ret = libxml2mod.xmlReadMemory(buffer, size, URL, encoding, options)
    if ret is None:
        raise treeError('xmlReadMemory() failed')
    
    return xmlDoc(_obj = ret)


def recoverDoc(cur):
    ret = libxml2mod.xmlRecoverDoc(cur)
    if ret is None:
        raise treeError('xmlRecoverDoc() failed')
    
    return xmlDoc(_obj = ret)


def recoverFile(filename):
    ret = libxml2mod.xmlRecoverFile(filename)
    if ret is None:
        raise treeError('xmlRecoverFile() failed')
    
    return xmlDoc(_obj = ret)


def recoverMemory(buffer, size):
    ret = libxml2mod.xmlRecoverMemory(buffer, size)
    if ret is None:
        raise treeError('xmlRecoverMemory() failed')
    
    return xmlDoc(_obj = ret)


def substituteEntitiesDefault(val):
    ret = libxml2mod.xmlSubstituteEntitiesDefault(val)
    return ret


def checkLanguageID(lang):
    ret = libxml2mod.xmlCheckLanguageID(lang)
    return ret


def copyChar(len, out, val):
    ret = libxml2mod.xmlCopyChar(len, out, val)
    return ret


def copyCharMultiByte(out, val):
    ret = libxml2mod.xmlCopyCharMultiByte(out, val)
    return ret


def createEntityParserCtxt(URL, ID, base):
    ret = libxml2mod.xmlCreateEntityParserCtxt(URL, ID, base)
    if ret is None:
        raise parserError('xmlCreateEntityParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def createFileParserCtxt(filename):
    ret = libxml2mod.xmlCreateFileParserCtxt(filename)
    if ret is None:
        raise parserError('xmlCreateFileParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def createMemoryParserCtxt(buffer, size):
    ret = libxml2mod.xmlCreateMemoryParserCtxt(buffer, size)
    if ret is None:
        raise parserError('xmlCreateMemoryParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def createURLParserCtxt(filename, options):
    ret = libxml2mod.xmlCreateURLParserCtxt(filename, options)
    if ret is None:
        raise parserError('xmlCreateURLParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def htmlCreateFileParserCtxt(filename, encoding):
    ret = libxml2mod.htmlCreateFileParserCtxt(filename, encoding)
    if ret is None:
        raise parserError('htmlCreateFileParserCtxt() failed')
    
    return parserCtxt(_obj = ret)


def htmlInitAutoClose():
    libxml2mod.htmlInitAutoClose()


def isLetter(c):
    ret = libxml2mod.xmlIsLetter(c)
    return ret


def namePop(ctxt):
    if ctxt is None:
        ctxt__o = None
    else:
        ctxt__o = ctxt._o
    ret = libxml2mod.namePop(ctxt__o)
    return ret


def namePush(ctxt, value):
    if ctxt is None:
        ctxt__o = None
    else:
        ctxt__o = ctxt._o
    ret = libxml2mod.namePush(ctxt__o, value)
    return ret


def nodePop(ctxt):
    if ctxt is None:
        ctxt__o = None
    else:
        ctxt__o = ctxt._o
    ret = libxml2mod.nodePop(ctxt__o)
    if ret is None:
        raise treeError('nodePop() failed')
    
    return xmlNode(_obj = ret)


def nodePush(ctxt, value):
    if ctxt is None:
        ctxt__o = None
    else:
        ctxt__o = ctxt._o
    if value is None:
        value__o = None
    else:
        value__o = value._o
    ret = libxml2mod.nodePush(ctxt__o, value__o)
    return ret


def SAXParseFile(SAX, URI, recover):
    libxml2mod.xmlSAXParseFile(SAX, URI, recover)


def createInputBuffer(file, encoding):
    ret = libxml2mod.xmlCreateInputBuffer(file, encoding)
    if ret is None:
        raise treeError('xmlCreateInputBuffer() failed')
    
    return inputBuffer(_obj = ret)


def createOutputBuffer(file, encoding):
    ret = libxml2mod.xmlCreateOutputBuffer(file, encoding)
    if ret is None:
        raise treeError('xmlCreateOutputBuffer() failed')
    
    return outputBuffer(_obj = ret)


def createPushParser(SAX, chunk, size, URI):
    ret = libxml2mod.xmlCreatePushParser(SAX, chunk, size, URI)
    if ret is None:
        raise parserError('xmlCreatePushParser() failed')
    
    return parserCtxt(_obj = ret)


def debugMemory(activate):
    ret = libxml2mod.xmlDebugMemory(activate)
    return ret


def dumpMemory():
    libxml2mod.xmlDumpMemory()


def htmlCreatePushParser(SAX, chunk, size, URI):
    ret = libxml2mod.htmlCreatePushParser(SAX, chunk, size, URI)
    if ret is None:
        raise parserError('htmlCreatePushParser() failed')
    
    return parserCtxt(_obj = ret)


def htmlSAXParseFile(SAX, URI, encoding):
    libxml2mod.htmlSAXParseFile(SAX, URI, encoding)


def memoryUsed():
    ret = libxml2mod.xmlMemoryUsed()
    return ret


def newNode(name):
    ret = libxml2mod.xmlNewNode(name)
    if ret is None:
        raise treeError('xmlNewNode() failed')
    
    return xmlNode(_obj = ret)


def pythonCleanupParser():
    libxml2mod.xmlPythonCleanupParser()


def setEntityLoader(resolver):
    ret = libxml2mod.xmlSetEntityLoader(resolver)
    return ret


def relaxNGCleanupTypes():
    libxml2mod.xmlRelaxNGCleanupTypes()


def relaxNGInitTypes():
    ret = libxml2mod.xmlRelaxNGInitTypes()
    return ret


def relaxNGNewMemParserCtxt(buffer, size):
    ret = libxml2mod.xmlRelaxNGNewMemParserCtxt(buffer, size)
    if ret is None:
        raise parserError('xmlRelaxNGNewMemParserCtxt() failed')
    
    return relaxNgParserCtxt(_obj = ret)


def relaxNGNewParserCtxt(URL):
    ret = libxml2mod.xmlRelaxNGNewParserCtxt(URL)
    if ret is None:
        raise parserError('xmlRelaxNGNewParserCtxt() failed')
    
    return relaxNgParserCtxt(_obj = ret)


def buildQName(ncname, prefix, memory, len):
    ret = libxml2mod.xmlBuildQName(ncname, prefix, memory, len)
    return ret


def compressMode():
    ret = libxml2mod.xmlGetCompressMode()
    return ret


def isXHTML(systemID, publicID):
    ret = libxml2mod.xmlIsXHTML(systemID, publicID)
    return ret


def newComment(content):
    ret = libxml2mod.xmlNewComment(content)
    if ret is None:
        raise treeError('xmlNewComment() failed')
    
    return xmlNode(_obj = ret)


def newDoc(version):
    ret = libxml2mod.xmlNewDoc(version)
    if ret is None:
        raise treeError('xmlNewDoc() failed')
    
    return xmlDoc(_obj = ret)


def newPI(name, content):
    ret = libxml2mod.xmlNewPI(name, content)
    if ret is None:
        raise treeError('xmlNewPI() failed')
    
    return xmlNode(_obj = ret)


def newText(content):
    ret = libxml2mod.xmlNewText(content)
    if ret is None:
        raise treeError('xmlNewText() failed')
    
    return xmlNode(_obj = ret)


def newTextLen(content, len):
    ret = libxml2mod.xmlNewTextLen(content, len)
    if ret is None:
        raise treeError('xmlNewTextLen() failed')
    
    return xmlNode(_obj = ret)


def setCompressMode(mode):
    libxml2mod.xmlSetCompressMode(mode)


def validateNCName(value, space):
    ret = libxml2mod.xmlValidateNCName(value, space)
    return ret


def validateNMToken(value, space):
    ret = libxml2mod.xmlValidateNMToken(value, space)
    return ret


def validateName(value, space):
    ret = libxml2mod.xmlValidateName(value, space)
    return ret


def validateQName(value, space):
    ret = libxml2mod.xmlValidateQName(value, space)
    return ret


def URIEscape(str):
    ret = libxml2mod.xmlURIEscape(str)
    return ret


def URIEscapeStr(str, list):
    ret = libxml2mod.xmlURIEscapeStr(str, list)
    return ret


def URIUnescapeString(str, len, target):
    ret = libxml2mod.xmlURIUnescapeString(str, len, target)
    return ret


def buildRelativeURI(URI, base):
    ret = libxml2mod.xmlBuildRelativeURI(URI, base)
    return ret


def buildURI(URI, base):
    ret = libxml2mod.xmlBuildURI(URI, base)
    return ret


def canonicPath(path):
    ret = libxml2mod.xmlCanonicPath(path)
    return ret


def createURI():
    ret = libxml2mod.xmlCreateURI()
    if ret is None:
        raise uriError('xmlCreateURI() failed')
    
    return URI(_obj = ret)


def normalizeURIPath(path):
    ret = libxml2mod.xmlNormalizeURIPath(path)
    return ret


def parseURI(str):
    ret = libxml2mod.xmlParseURI(str)
    if ret is None:
        raise uriError('xmlParseURI() failed')
    
    return URI(_obj = ret)


def parseURIRaw(str, raw):
    ret = libxml2mod.xmlParseURIRaw(str, raw)
    if ret is None:
        raise uriError('xmlParseURIRaw() failed')
    
    return URI(_obj = ret)


def pathToURI(path):
    ret = libxml2mod.xmlPathToURI(path)
    return ret


def newValidCtxt():
    ret = libxml2mod.xmlNewValidCtxt()
    if ret is None:
        raise treeError('xmlNewValidCtxt() failed')
    
    return ValidCtxt(_obj = ret)


def validateNameValue(value):
    ret = libxml2mod.xmlValidateNameValue(value)
    return ret


def validateNamesValue(value):
    ret = libxml2mod.xmlValidateNamesValue(value)
    return ret


def validateNmtokenValue(value):
    ret = libxml2mod.xmlValidateNmtokenValue(value)
    return ret


def validateNmtokensValue(value):
    ret = libxml2mod.xmlValidateNmtokensValue(value)
    return ret


def checkFilename(path):
    ret = libxml2mod.xmlCheckFilename(path)
    return ret


def cleanupInputCallbacks():
    libxml2mod.xmlCleanupInputCallbacks()


def cleanupOutputCallbacks():
    libxml2mod.xmlCleanupOutputCallbacks()


def fileMatch(filename):
    ret = libxml2mod.xmlFileMatch(filename)
    return ret


def iOFTPMatch(filename):
    ret = libxml2mod.xmlIOFTPMatch(filename)
    return ret


def iOHTTPMatch(filename):
    ret = libxml2mod.xmlIOHTTPMatch(filename)
    return ret


def normalizeWindowsPath(path):
    ret = libxml2mod.xmlNormalizeWindowsPath(path)
    return ret


def parserGetDirectory(filename):
    ret = libxml2mod.xmlParserGetDirectory(filename)
    return ret


def popInputCallbacks():
    ret = libxml2mod.xmlPopInputCallbacks()
    return ret


def registerDefaultInputCallbacks():
    libxml2mod.xmlRegisterDefaultInputCallbacks()


def registerDefaultOutputCallbacks():
    libxml2mod.xmlRegisterDefaultOutputCallbacks()


def registerHTTPPostCallbacks():
    libxml2mod.xmlRegisterHTTPPostCallbacks()


def lastError():
    ret = libxml2mod.xmlGetLastError()
    if ret is None:
        raise treeError('xmlGetLastError() failed')
    
    return Error(_obj = ret)


def resetLastError():
    libxml2mod.xmlResetLastError()


def newTextReaderFilename(URI):
    ret = libxml2mod.xmlNewTextReaderFilename(URI)
    if ret is None:
        raise treeError('xmlNewTextReaderFilename() failed')
    
    return xmlTextReader(_obj = ret)


def readerForDoc(cur, URL, encoding, options):
    ret = libxml2mod.xmlReaderForDoc(cur, URL, encoding, options)
    if ret is None:
        raise treeError('xmlReaderForDoc() failed')
    
    return xmlTextReader(_obj = ret)


def readerForFd(fd, URL, encoding, options):
    ret = libxml2mod.xmlReaderForFd(fd, URL, encoding, options)
    if ret is None:
        raise treeError('xmlReaderForFd() failed')
    
    return xmlTextReader(_obj = ret)


def readerForFile(filename, encoding, options):
    ret = libxml2mod.xmlReaderForFile(filename, encoding, options)
    if ret is None:
        raise treeError('xmlReaderForFile() failed')
    
    return xmlTextReader(_obj = ret)


def readerForMemory(buffer, size, URL, encoding, options):
    ret = libxml2mod.xmlReaderForMemory(buffer, size, URL, encoding, options)
    if ret is None:
        raise treeError('xmlReaderForMemory() failed')
    
    return xmlTextReader(_obj = ret)


def regexpCompile(regexp):
    ret = libxml2mod.xmlRegexpCompile(regexp)
    if ret is None:
        raise treeError('xmlRegexpCompile() failed')
    
    return xmlReg(_obj = ret)


def schemaNewMemParserCtxt(buffer, size):
    ret = libxml2mod.xmlSchemaNewMemParserCtxt(buffer, size)
    if ret is None:
        raise parserError('xmlSchemaNewMemParserCtxt() failed')
    
    return SchemaParserCtxt(_obj = ret)


def schemaNewParserCtxt(URL):
    ret = libxml2mod.xmlSchemaNewParserCtxt(URL)
    if ret is None:
        raise parserError('xmlSchemaNewParserCtxt() failed')
    
    return SchemaParserCtxt(_obj = ret)


def schemaCleanupTypes():
    libxml2mod.xmlSchemaCleanupTypes()


def schemaCollapseString(value):
    ret = libxml2mod.xmlSchemaCollapseString(value)
    return ret


def schemaInitTypes():
    libxml2mod.xmlSchemaInitTypes()


def schemaWhiteSpaceReplace(value):
    ret = libxml2mod.xmlSchemaWhiteSpaceReplace(value)
    return ret


def UTF8Charcmp(utf1, utf2):
    ret = libxml2mod.xmlUTF8Charcmp(utf1, utf2)
    return ret


def UTF8Size(utf):
    ret = libxml2mod.xmlUTF8Size(utf)
    return ret


def UTF8Strlen(utf):
    ret = libxml2mod.xmlUTF8Strlen(utf)
    return ret


def UTF8Strloc(utf, utfchar):
    ret = libxml2mod.xmlUTF8Strloc(utf, utfchar)
    return ret


def UTF8Strndup(utf, len):
    ret = libxml2mod.xmlUTF8Strndup(utf, len)
    return ret


def UTF8Strpos(utf, pos):
    ret = libxml2mod.xmlUTF8Strpos(utf, pos)
    return ret


def UTF8Strsize(utf, len):
    ret = libxml2mod.xmlUTF8Strsize(utf, len)
    return ret


def UTF8Strsub(utf, start, len):
    ret = libxml2mod.xmlUTF8Strsub(utf, start, len)
    return ret


def checkUTF8(utf):
    ret = libxml2mod.xmlCheckUTF8(utf)
    return ret


def uCSIsAegeanNumbers(code):
    ret = libxml2mod.xmlUCSIsAegeanNumbers(code)
    return ret


def uCSIsAlphabeticPresentationForms(code):
    ret = libxml2mod.xmlUCSIsAlphabeticPresentationForms(code)
    return ret


def uCSIsArabic(code):
    ret = libxml2mod.xmlUCSIsArabic(code)
    return ret


def uCSIsArabicPresentationFormsA(code):
    ret = libxml2mod.xmlUCSIsArabicPresentationFormsA(code)
    return ret


def uCSIsArabicPresentationFormsB(code):
    ret = libxml2mod.xmlUCSIsArabicPresentationFormsB(code)
    return ret


def uCSIsArmenian(code):
    ret = libxml2mod.xmlUCSIsArmenian(code)
    return ret


def uCSIsArrows(code):
    ret = libxml2mod.xmlUCSIsArrows(code)
    return ret


def uCSIsBasicLatin(code):
    ret = libxml2mod.xmlUCSIsBasicLatin(code)
    return ret


def uCSIsBengali(code):
    ret = libxml2mod.xmlUCSIsBengali(code)
    return ret


def uCSIsBlock(code, block):
    ret = libxml2mod.xmlUCSIsBlock(code, block)
    return ret


def uCSIsBlockElements(code):
    ret = libxml2mod.xmlUCSIsBlockElements(code)
    return ret


def uCSIsBopomofo(code):
    ret = libxml2mod.xmlUCSIsBopomofo(code)
    return ret


def uCSIsBopomofoExtended(code):
    ret = libxml2mod.xmlUCSIsBopomofoExtended(code)
    return ret


def uCSIsBoxDrawing(code):
    ret = libxml2mod.xmlUCSIsBoxDrawing(code)
    return ret


def uCSIsBraillePatterns(code):
    ret = libxml2mod.xmlUCSIsBraillePatterns(code)
    return ret


def uCSIsBuhid(code):
    ret = libxml2mod.xmlUCSIsBuhid(code)
    return ret


def uCSIsByzantineMusicalSymbols(code):
    ret = libxml2mod.xmlUCSIsByzantineMusicalSymbols(code)
    return ret


def uCSIsCJKCompatibility(code):
    ret = libxml2mod.xmlUCSIsCJKCompatibility(code)
    return ret


def uCSIsCJKCompatibilityForms(code):
    ret = libxml2mod.xmlUCSIsCJKCompatibilityForms(code)
    return ret


def uCSIsCJKCompatibilityIdeographs(code):
    ret = libxml2mod.xmlUCSIsCJKCompatibilityIdeographs(code)
    return ret


def uCSIsCJKCompatibilityIdeographsSupplement(code):
    ret = libxml2mod.xmlUCSIsCJKCompatibilityIdeographsSupplement(code)
    return ret


def uCSIsCJKRadicalsSupplement(code):
    ret = libxml2mod.xmlUCSIsCJKRadicalsSupplement(code)
    return ret


def uCSIsCJKSymbolsandPunctuation(code):
    ret = libxml2mod.xmlUCSIsCJKSymbolsandPunctuation(code)
    return ret


def uCSIsCJKUnifiedIdeographs(code):
    ret = libxml2mod.xmlUCSIsCJKUnifiedIdeographs(code)
    return ret


def uCSIsCJKUnifiedIdeographsExtensionA(code):
    ret = libxml2mod.xmlUCSIsCJKUnifiedIdeographsExtensionA(code)
    return ret


def uCSIsCJKUnifiedIdeographsExtensionB(code):
    ret = libxml2mod.xmlUCSIsCJKUnifiedIdeographsExtensionB(code)
    return ret


def uCSIsCat(code, cat):
    ret = libxml2mod.xmlUCSIsCat(code, cat)
    return ret


def uCSIsCatC(code):
    ret = libxml2mod.xmlUCSIsCatC(code)
    return ret


def uCSIsCatCc(code):
    ret = libxml2mod.xmlUCSIsCatCc(code)
    return ret


def uCSIsCatCf(code):
    ret = libxml2mod.xmlUCSIsCatCf(code)
    return ret


def uCSIsCatCo(code):
    ret = libxml2mod.xmlUCSIsCatCo(code)
    return ret


def uCSIsCatCs(code):
    ret = libxml2mod.xmlUCSIsCatCs(code)
    return ret


def uCSIsCatL(code):
    ret = libxml2mod.xmlUCSIsCatL(code)
    return ret


def uCSIsCatLl(code):
    ret = libxml2mod.xmlUCSIsCatLl(code)
    return ret


def uCSIsCatLm(code):
    ret = libxml2mod.xmlUCSIsCatLm(code)
    return ret


def uCSIsCatLo(code):
    ret = libxml2mod.xmlUCSIsCatLo(code)
    return ret


def uCSIsCatLt(code):
    ret = libxml2mod.xmlUCSIsCatLt(code)
    return ret


def uCSIsCatLu(code):
    ret = libxml2mod.xmlUCSIsCatLu(code)
    return ret


def uCSIsCatM(code):
    ret = libxml2mod.xmlUCSIsCatM(code)
    return ret


def uCSIsCatMc(code):
    ret = libxml2mod.xmlUCSIsCatMc(code)
    return ret


def uCSIsCatMe(code):
    ret = libxml2mod.xmlUCSIsCatMe(code)
    return ret


def uCSIsCatMn(code):
    ret = libxml2mod.xmlUCSIsCatMn(code)
    return ret


def uCSIsCatN(code):
    ret = libxml2mod.xmlUCSIsCatN(code)
    return ret


def uCSIsCatNd(code):
    ret = libxml2mod.xmlUCSIsCatNd(code)
    return ret


def uCSIsCatNl(code):
    ret = libxml2mod.xmlUCSIsCatNl(code)
    return ret


def uCSIsCatNo(code):
    ret = libxml2mod.xmlUCSIsCatNo(code)
    return ret


def uCSIsCatP(code):
    ret = libxml2mod.xmlUCSIsCatP(code)
    return ret


def uCSIsCatPc(code):
    ret = libxml2mod.xmlUCSIsCatPc(code)
    return ret


def uCSIsCatPd(code):
    ret = libxml2mod.xmlUCSIsCatPd(code)
    return ret


def uCSIsCatPe(code):
    ret = libxml2mod.xmlUCSIsCatPe(code)
    return ret


def uCSIsCatPf(code):
    ret = libxml2mod.xmlUCSIsCatPf(code)
    return ret


def uCSIsCatPi(code):
    ret = libxml2mod.xmlUCSIsCatPi(code)
    return ret


def uCSIsCatPo(code):
    ret = libxml2mod.xmlUCSIsCatPo(code)
    return ret


def uCSIsCatPs(code):
    ret = libxml2mod.xmlUCSIsCatPs(code)
    return ret


def uCSIsCatS(code):
    ret = libxml2mod.xmlUCSIsCatS(code)
    return ret


def uCSIsCatSc(code):
    ret = libxml2mod.xmlUCSIsCatSc(code)
    return ret


def uCSIsCatSk(code):
    ret = libxml2mod.xmlUCSIsCatSk(code)
    return ret


def uCSIsCatSm(code):
    ret = libxml2mod.xmlUCSIsCatSm(code)
    return ret


def uCSIsCatSo(code):
    ret = libxml2mod.xmlUCSIsCatSo(code)
    return ret


def uCSIsCatZ(code):
    ret = libxml2mod.xmlUCSIsCatZ(code)
    return ret


def uCSIsCatZl(code):
    ret = libxml2mod.xmlUCSIsCatZl(code)
    return ret


def uCSIsCatZp(code):
    ret = libxml2mod.xmlUCSIsCatZp(code)
    return ret


def uCSIsCatZs(code):
    ret = libxml2mod.xmlUCSIsCatZs(code)
    return ret


def uCSIsCherokee(code):
    ret = libxml2mod.xmlUCSIsCherokee(code)
    return ret


def uCSIsCombiningDiacriticalMarks(code):
    ret = libxml2mod.xmlUCSIsCombiningDiacriticalMarks(code)
    return ret


def uCSIsCombiningDiacriticalMarksforSymbols(code):
    ret = libxml2mod.xmlUCSIsCombiningDiacriticalMarksforSymbols(code)
    return ret


def uCSIsCombiningHalfMarks(code):
    ret = libxml2mod.xmlUCSIsCombiningHalfMarks(code)
    return ret


def uCSIsCombiningMarksforSymbols(code):
    ret = libxml2mod.xmlUCSIsCombiningMarksforSymbols(code)
    return ret


def uCSIsControlPictures(code):
    ret = libxml2mod.xmlUCSIsControlPictures(code)
    return ret


def uCSIsCurrencySymbols(code):
    ret = libxml2mod.xmlUCSIsCurrencySymbols(code)
    return ret


def uCSIsCypriotSyllabary(code):
    ret = libxml2mod.xmlUCSIsCypriotSyllabary(code)
    return ret


def uCSIsCyrillic(code):
    ret = libxml2mod.xmlUCSIsCyrillic(code)
    return ret


def uCSIsCyrillicSupplement(code):
    ret = libxml2mod.xmlUCSIsCyrillicSupplement(code)
    return ret


def uCSIsDeseret(code):
    ret = libxml2mod.xmlUCSIsDeseret(code)
    return ret


def uCSIsDevanagari(code):
    ret = libxml2mod.xmlUCSIsDevanagari(code)
    return ret


def uCSIsDingbats(code):
    ret = libxml2mod.xmlUCSIsDingbats(code)
    return ret


def uCSIsEnclosedAlphanumerics(code):
    ret = libxml2mod.xmlUCSIsEnclosedAlphanumerics(code)
    return ret


def uCSIsEnclosedCJKLettersandMonths(code):
    ret = libxml2mod.xmlUCSIsEnclosedCJKLettersandMonths(code)
    return ret


def uCSIsEthiopic(code):
    ret = libxml2mod.xmlUCSIsEthiopic(code)
    return ret


def uCSIsGeneralPunctuation(code):
    ret = libxml2mod.xmlUCSIsGeneralPunctuation(code)
    return ret


def uCSIsGeometricShapes(code):
    ret = libxml2mod.xmlUCSIsGeometricShapes(code)
    return ret


def uCSIsGeorgian(code):
    ret = libxml2mod.xmlUCSIsGeorgian(code)
    return ret


def uCSIsGothic(code):
    ret = libxml2mod.xmlUCSIsGothic(code)
    return ret


def uCSIsGreek(code):
    ret = libxml2mod.xmlUCSIsGreek(code)
    return ret


def uCSIsGreekExtended(code):
    ret = libxml2mod.xmlUCSIsGreekExtended(code)
    return ret


def uCSIsGreekandCoptic(code):
    ret = libxml2mod.xmlUCSIsGreekandCoptic(code)
    return ret


def uCSIsGujarati(code):
    ret = libxml2mod.xmlUCSIsGujarati(code)
    return ret


def uCSIsGurmukhi(code):
    ret = libxml2mod.xmlUCSIsGurmukhi(code)
    return ret


def uCSIsHalfwidthandFullwidthForms(code):
    ret = libxml2mod.xmlUCSIsHalfwidthandFullwidthForms(code)
    return ret


def uCSIsHangulCompatibilityJamo(code):
    ret = libxml2mod.xmlUCSIsHangulCompatibilityJamo(code)
    return ret


def uCSIsHangulJamo(code):
    ret = libxml2mod.xmlUCSIsHangulJamo(code)
    return ret


def uCSIsHangulSyllables(code):
    ret = libxml2mod.xmlUCSIsHangulSyllables(code)
    return ret


def uCSIsHanunoo(code):
    ret = libxml2mod.xmlUCSIsHanunoo(code)
    return ret


def uCSIsHebrew(code):
    ret = libxml2mod.xmlUCSIsHebrew(code)
    return ret


def uCSIsHighPrivateUseSurrogates(code):
    ret = libxml2mod.xmlUCSIsHighPrivateUseSurrogates(code)
    return ret


def uCSIsHighSurrogates(code):
    ret = libxml2mod.xmlUCSIsHighSurrogates(code)
    return ret


def uCSIsHiragana(code):
    ret = libxml2mod.xmlUCSIsHiragana(code)
    return ret


def uCSIsIPAExtensions(code):
    ret = libxml2mod.xmlUCSIsIPAExtensions(code)
    return ret


def uCSIsIdeographicDescriptionCharacters(code):
    ret = libxml2mod.xmlUCSIsIdeographicDescriptionCharacters(code)
    return ret


def uCSIsKanbun(code):
    ret = libxml2mod.xmlUCSIsKanbun(code)
    return ret


def uCSIsKangxiRadicals(code):
    ret = libxml2mod.xmlUCSIsKangxiRadicals(code)
    return ret


def uCSIsKannada(code):
    ret = libxml2mod.xmlUCSIsKannada(code)
    return ret


def uCSIsKatakana(code):
    ret = libxml2mod.xmlUCSIsKatakana(code)
    return ret


def uCSIsKatakanaPhoneticExtensions(code):
    ret = libxml2mod.xmlUCSIsKatakanaPhoneticExtensions(code)
    return ret


def uCSIsKhmer(code):
    ret = libxml2mod.xmlUCSIsKhmer(code)
    return ret


def uCSIsKhmerSymbols(code):
    ret = libxml2mod.xmlUCSIsKhmerSymbols(code)
    return ret


def uCSIsLao(code):
    ret = libxml2mod.xmlUCSIsLao(code)
    return ret


def uCSIsLatin1Supplement(code):
    ret = libxml2mod.xmlUCSIsLatin1Supplement(code)
    return ret


def uCSIsLatinExtendedA(code):
    ret = libxml2mod.xmlUCSIsLatinExtendedA(code)
    return ret


def uCSIsLatinExtendedAdditional(code):
    ret = libxml2mod.xmlUCSIsLatinExtendedAdditional(code)
    return ret


def uCSIsLatinExtendedB(code):
    ret = libxml2mod.xmlUCSIsLatinExtendedB(code)
    return ret


def uCSIsLetterlikeSymbols(code):
    ret = libxml2mod.xmlUCSIsLetterlikeSymbols(code)
    return ret


def uCSIsLimbu(code):
    ret = libxml2mod.xmlUCSIsLimbu(code)
    return ret


def uCSIsLinearBIdeograms(code):
    ret = libxml2mod.xmlUCSIsLinearBIdeograms(code)
    return ret


def uCSIsLinearBSyllabary(code):
    ret = libxml2mod.xmlUCSIsLinearBSyllabary(code)
    return ret


def uCSIsLowSurrogates(code):
    ret = libxml2mod.xmlUCSIsLowSurrogates(code)
    return ret


def uCSIsMalayalam(code):
    ret = libxml2mod.xmlUCSIsMalayalam(code)
    return ret


def uCSIsMathematicalAlphanumericSymbols(code):
    ret = libxml2mod.xmlUCSIsMathematicalAlphanumericSymbols(code)
    return ret


def uCSIsMathematicalOperators(code):
    ret = libxml2mod.xmlUCSIsMathematicalOperators(code)
    return ret


def uCSIsMiscellaneousMathematicalSymbolsA(code):
    ret = libxml2mod.xmlUCSIsMiscellaneousMathematicalSymbolsA(code)
    return ret


def uCSIsMiscellaneousMathematicalSymbolsB(code):
    ret = libxml2mod.xmlUCSIsMiscellaneousMathematicalSymbolsB(code)
    return ret


def uCSIsMiscellaneousSymbols(code):
    ret = libxml2mod.xmlUCSIsMiscellaneousSymbols(code)
    return ret


def uCSIsMiscellaneousSymbolsandArrows(code):
    ret = libxml2mod.xmlUCSIsMiscellaneousSymbolsandArrows(code)
    return ret


def uCSIsMiscellaneousTechnical(code):
    ret = libxml2mod.xmlUCSIsMiscellaneousTechnical(code)
    return ret


def uCSIsMongolian(code):
    ret = libxml2mod.xmlUCSIsMongolian(code)
    return ret


def uCSIsMusicalSymbols(code):
    ret = libxml2mod.xmlUCSIsMusicalSymbols(code)
    return ret


def uCSIsMyanmar(code):
    ret = libxml2mod.xmlUCSIsMyanmar(code)
    return ret


def uCSIsNumberForms(code):
    ret = libxml2mod.xmlUCSIsNumberForms(code)
    return ret


def uCSIsOgham(code):
    ret = libxml2mod.xmlUCSIsOgham(code)
    return ret


def uCSIsOldItalic(code):
    ret = libxml2mod.xmlUCSIsOldItalic(code)
    return ret


def uCSIsOpticalCharacterRecognition(code):
    ret = libxml2mod.xmlUCSIsOpticalCharacterRecognition(code)
    return ret


def uCSIsOriya(code):
    ret = libxml2mod.xmlUCSIsOriya(code)
    return ret


def uCSIsOsmanya(code):
    ret = libxml2mod.xmlUCSIsOsmanya(code)
    return ret


def uCSIsPhoneticExtensions(code):
    ret = libxml2mod.xmlUCSIsPhoneticExtensions(code)
    return ret


def uCSIsPrivateUse(code):
    ret = libxml2mod.xmlUCSIsPrivateUse(code)
    return ret


def uCSIsPrivateUseArea(code):
    ret = libxml2mod.xmlUCSIsPrivateUseArea(code)
    return ret


def uCSIsRunic(code):
    ret = libxml2mod.xmlUCSIsRunic(code)
    return ret


def uCSIsShavian(code):
    ret = libxml2mod.xmlUCSIsShavian(code)
    return ret


def uCSIsSinhala(code):
    ret = libxml2mod.xmlUCSIsSinhala(code)
    return ret


def uCSIsSmallFormVariants(code):
    ret = libxml2mod.xmlUCSIsSmallFormVariants(code)
    return ret


def uCSIsSpacingModifierLetters(code):
    ret = libxml2mod.xmlUCSIsSpacingModifierLetters(code)
    return ret


def uCSIsSpecials(code):
    ret = libxml2mod.xmlUCSIsSpecials(code)
    return ret


def uCSIsSuperscriptsandSubscripts(code):
    ret = libxml2mod.xmlUCSIsSuperscriptsandSubscripts(code)
    return ret


def uCSIsSupplementalArrowsA(code):
    ret = libxml2mod.xmlUCSIsSupplementalArrowsA(code)
    return ret


def uCSIsSupplementalArrowsB(code):
    ret = libxml2mod.xmlUCSIsSupplementalArrowsB(code)
    return ret


def uCSIsSupplementalMathematicalOperators(code):
    ret = libxml2mod.xmlUCSIsSupplementalMathematicalOperators(code)
    return ret


def uCSIsSupplementaryPrivateUseAreaA(code):
    ret = libxml2mod.xmlUCSIsSupplementaryPrivateUseAreaA(code)
    return ret


def uCSIsSupplementaryPrivateUseAreaB(code):
    ret = libxml2mod.xmlUCSIsSupplementaryPrivateUseAreaB(code)
    return ret


def uCSIsSyriac(code):
    ret = libxml2mod.xmlUCSIsSyriac(code)
    return ret


def uCSIsTagalog(code):
    ret = libxml2mod.xmlUCSIsTagalog(code)
    return ret


def uCSIsTagbanwa(code):
    ret = libxml2mod.xmlUCSIsTagbanwa(code)
    return ret


def uCSIsTags(code):
    ret = libxml2mod.xmlUCSIsTags(code)
    return ret


def uCSIsTaiLe(code):
    ret = libxml2mod.xmlUCSIsTaiLe(code)
    return ret


def uCSIsTaiXuanJingSymbols(code):
    ret = libxml2mod.xmlUCSIsTaiXuanJingSymbols(code)
    return ret


def uCSIsTamil(code):
    ret = libxml2mod.xmlUCSIsTamil(code)
    return ret


def uCSIsTelugu(code):
    ret = libxml2mod.xmlUCSIsTelugu(code)
    return ret


def uCSIsThaana(code):
    ret = libxml2mod.xmlUCSIsThaana(code)
    return ret


def uCSIsThai(code):
    ret = libxml2mod.xmlUCSIsThai(code)
    return ret


def uCSIsTibetan(code):
    ret = libxml2mod.xmlUCSIsTibetan(code)
    return ret


def uCSIsUgaritic(code):
    ret = libxml2mod.xmlUCSIsUgaritic(code)
    return ret


def uCSIsUnifiedCanadianAboriginalSyllabics(code):
    ret = libxml2mod.xmlUCSIsUnifiedCanadianAboriginalSyllabics(code)
    return ret


def uCSIsVariationSelectors(code):
    ret = libxml2mod.xmlUCSIsVariationSelectors(code)
    return ret


def uCSIsVariationSelectorsSupplement(code):
    ret = libxml2mod.xmlUCSIsVariationSelectorsSupplement(code)
    return ret


def uCSIsYiRadicals(code):
    ret = libxml2mod.xmlUCSIsYiRadicals(code)
    return ret


def uCSIsYiSyllables(code):
    ret = libxml2mod.xmlUCSIsYiSyllables(code)
    return ret


def uCSIsYijingHexagramSymbols(code):
    ret = libxml2mod.xmlUCSIsYijingHexagramSymbols(code)
    return ret


def checkVersion(version):
    libxml2mod.xmlCheckVersion(version)


def valuePop(ctxt):
    if ctxt is None:
        ctxt__o = None
    else:
        ctxt__o = ctxt._o
    ret = libxml2mod.valuePop(ctxt__o)
    return ret


class xmlNode(xmlCore):
    
    def __init__(self, _obj = None):
        if type(_obj).__name__ != 'PyCObject':
            raise TypeError, 'xmlNode needs a PyCObject argument'
        
        self._o = _obj
        xmlCore.__init__(self, _obj = _obj)

    
    def __repr__(self):
        return '<xmlNode object at 0x%x>' % long(pos_id(self))

    
    def ns(self):
        ret = libxml2mod.xmlNodeGetNs(self._o)
        if ret is None:
            return None
        
        _xmlNode__tmp = xmlNs(_obj = ret)
        return _xmlNode__tmp

    
    def nsDefs(self):
        ret = libxml2mod.xmlNodeGetNsDefs(self._o)
        if ret is None:
            return None
        
        _xmlNode__tmp = xmlNs(_obj = ret)
        return _xmlNode__tmp

    
    def debugDumpNode(self, output, depth):
        libxml2mod.xmlDebugDumpNode(output, self._o, depth)

    
    def debugDumpNodeList(self, output, depth):
        libxml2mod.xmlDebugDumpNodeList(output, self._o, depth)

    
    def debugDumpOneNode(self, output, depth):
        libxml2mod.xmlDebugDumpOneNode(output, self._o, depth)

    
    def lsCountNode(self):
        ret = libxml2mod.xmlLsCountNode(self._o)
        return ret

    
    def lsOneNode(self, output):
        libxml2mod.xmlLsOneNode(output, self._o)

    
    def shellPrintNode(self):
        libxml2mod.xmlShellPrintNode(self._o)

    
    def addChild(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlAddChild(self._o, cur__o)
        if ret is None:
            raise treeError('xmlAddChild() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def addChildList(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlAddChildList(self._o, cur__o)
        if ret is None:
            raise treeError('xmlAddChildList() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def addContent(self, content):
        libxml2mod.xmlNodeAddContent(self._o, content)

    
    def addContentLen(self, content, len):
        libxml2mod.xmlNodeAddContentLen(self._o, content, len)

    
    def addNextSibling(self, elem):
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlAddNextSibling(self._o, elem__o)
        if ret is None:
            raise treeError('xmlAddNextSibling() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def addPrevSibling(self, elem):
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlAddPrevSibling(self._o, elem__o)
        if ret is None:
            raise treeError('xmlAddPrevSibling() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def addSibling(self, elem):
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlAddSibling(self._o, elem__o)
        if ret is None:
            raise treeError('xmlAddSibling() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def copyNode(self, extended):
        ret = libxml2mod.xmlCopyNode(self._o, extended)
        if ret is None:
            raise treeError('xmlCopyNode() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def copyNodeList(self):
        ret = libxml2mod.xmlCopyNodeList(self._o)
        if ret is None:
            raise treeError('xmlCopyNodeList() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def copyProp(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlCopyProp(self._o, cur__o)
        if ret is None:
            raise treeError('xmlCopyProp() failed')
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def copyPropList(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlCopyPropList(self._o, cur__o)
        if ret is None:
            raise treeError('xmlCopyPropList() failed')
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def docCopyNode(self, doc, extended):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlDocCopyNode(self._o, doc__o, extended)
        if ret is None:
            raise treeError('xmlDocCopyNode() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def docCopyNodeList(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlDocCopyNodeList(doc__o, self._o)
        if ret is None:
            raise treeError('xmlDocCopyNodeList() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def docSetRootElement(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlDocSetRootElement(doc__o, self._o)
        if ret is None:
            return None
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def freeNode(self):
        libxml2mod.xmlFreeNode(self._o)

    
    def freeNodeList(self):
        libxml2mod.xmlFreeNodeList(self._o)

    
    def getBase(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlNodeGetBase(doc__o, self._o)
        return ret

    
    def getContent(self):
        ret = libxml2mod.xmlNodeGetContent(self._o)
        return ret

    
    def getLang(self):
        ret = libxml2mod.xmlNodeGetLang(self._o)
        return ret

    
    def getSpacePreserve(self):
        ret = libxml2mod.xmlNodeGetSpacePreserve(self._o)
        return ret

    
    def hasNsProp(self, name, nameSpace):
        ret = libxml2mod.xmlHasNsProp(self._o, name, nameSpace)
        if ret is None:
            return None
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def hasProp(self, name):
        ret = libxml2mod.xmlHasProp(self._o, name)
        if ret is None:
            return None
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def isBlankNode(self):
        ret = libxml2mod.xmlIsBlankNode(self._o)
        return ret

    
    def isText(self):
        ret = libxml2mod.xmlNodeIsText(self._o)
        return ret

    
    def lastChild(self):
        ret = libxml2mod.xmlGetLastChild(self._o)
        if ret is None:
            raise treeError('xmlGetLastChild() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def lineNo(self):
        ret = libxml2mod.xmlGetLineNo(self._o)
        return ret

    
    def listGetRawString(self, doc, inLine):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlNodeListGetRawString(doc__o, self._o, inLine)
        return ret

    
    def listGetString(self, doc, inLine):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlNodeListGetString(doc__o, self._o, inLine)
        return ret

    
    def newChild(self, ns, name, content):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlNewChild(self._o, ns__o, name, content)
        if ret is None:
            raise treeError('xmlNewChild() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def newNs(self, href, prefix):
        ret = libxml2mod.xmlNewNs(self._o, href, prefix)
        if ret is None:
            raise treeError('xmlNewNs() failed')
        
        _xmlNode__tmp = xmlNs(_obj = ret)
        return _xmlNode__tmp

    
    def newNsProp(self, ns, name, value):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlNewNsProp(self._o, ns__o, name, value)
        if ret is None:
            raise treeError('xmlNewNsProp() failed')
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def newNsPropEatName(self, ns, name, value):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlNewNsPropEatName(self._o, ns__o, name, value)
        if ret is None:
            raise treeError('xmlNewNsPropEatName() failed')
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def newProp(self, name, value):
        ret = libxml2mod.xmlNewProp(self._o, name, value)
        if ret is None:
            raise treeError('xmlNewProp() failed')
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def newTextChild(self, ns, name, content):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlNewTextChild(self._o, ns__o, name, content)
        if ret is None:
            raise treeError('xmlNewTextChild() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def noNsProp(self, name):
        ret = libxml2mod.xmlGetNoNsProp(self._o, name)
        return ret

    
    def nodePath(self):
        ret = libxml2mod.xmlGetNodePath(self._o)
        return ret

    
    def nsProp(self, name, nameSpace):
        ret = libxml2mod.xmlGetNsProp(self._o, name, nameSpace)
        return ret

    
    def prop(self, name):
        ret = libxml2mod.xmlGetProp(self._o, name)
        return ret

    
    def reconciliateNs(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlReconciliateNs(doc__o, self._o)
        return ret

    
    def replaceNode(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlReplaceNode(self._o, cur__o)
        if ret is None:
            raise treeError('xmlReplaceNode() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def searchNs(self, doc, nameSpace):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlSearchNs(doc__o, self._o, nameSpace)
        if ret is None:
            raise treeError('xmlSearchNs() failed')
        
        _xmlNode__tmp = xmlNs(_obj = ret)
        return _xmlNode__tmp

    
    def searchNsByHref(self, doc, href):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlSearchNsByHref(doc__o, self._o, href)
        if ret is None:
            raise treeError('xmlSearchNsByHref() failed')
        
        _xmlNode__tmp = xmlNs(_obj = ret)
        return _xmlNode__tmp

    
    def setBase(self, uri):
        libxml2mod.xmlNodeSetBase(self._o, uri)

    
    def setContent(self, content):
        libxml2mod.xmlNodeSetContent(self._o, content)

    
    def setContentLen(self, content, len):
        libxml2mod.xmlNodeSetContentLen(self._o, content, len)

    
    def setLang(self, lang):
        libxml2mod.xmlNodeSetLang(self._o, lang)

    
    def setListDoc(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        libxml2mod.xmlSetListDoc(self._o, doc__o)

    
    def setName(self, name):
        libxml2mod.xmlNodeSetName(self._o, name)

    
    def setNs(self, ns):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        libxml2mod.xmlSetNs(self._o, ns__o)

    
    def setNsProp(self, ns, name, value):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlSetNsProp(self._o, ns__o, name, value)
        if ret is None:
            raise treeError('xmlSetNsProp() failed')
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def setProp(self, name, value):
        ret = libxml2mod.xmlSetProp(self._o, name, value)
        if ret is None:
            raise treeError('xmlSetProp() failed')
        
        _xmlNode__tmp = xmlAttr(_obj = ret)
        return _xmlNode__tmp

    
    def setSpacePreserve(self, val):
        libxml2mod.xmlNodeSetSpacePreserve(self._o, val)

    
    def setTreeDoc(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        libxml2mod.xmlSetTreeDoc(self._o, doc__o)

    
    def textConcat(self, content, len):
        ret = libxml2mod.xmlTextConcat(self._o, content, len)
        return ret

    
    def textMerge(self, second):
        if second is None:
            second__o = None
        else:
            second__o = second._o
        ret = libxml2mod.xmlTextMerge(self._o, second__o)
        if ret is None:
            raise treeError('xmlTextMerge() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def unlinkNode(self):
        libxml2mod.xmlUnlinkNode(self._o)

    
    def unsetNsProp(self, ns, name):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlUnsetNsProp(self._o, ns__o, name)
        return ret

    
    def unsetProp(self, name):
        ret = libxml2mod.xmlUnsetProp(self._o, name)
        return ret

    
    def isID(self, doc, attr):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if attr is None:
            attr__o = None
        else:
            attr__o = attr._o
        ret = libxml2mod.xmlIsID(doc__o, self._o, attr__o)
        return ret

    
    def isRef(self, doc, attr):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if attr is None:
            attr__o = None
        else:
            attr__o = attr._o
        ret = libxml2mod.xmlIsRef(doc__o, self._o, attr__o)
        return ret

    
    def validNormalizeAttributeValue(self, doc, name, value):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlValidNormalizeAttributeValue(doc__o, self._o, name, value)
        return ret

    
    def xincludeProcessTree(self):
        ret = libxml2mod.xmlXIncludeProcessTree(self._o)
        return ret

    
    def xincludeProcessTreeFlags(self, flags):
        ret = libxml2mod.xmlXIncludeProcessTreeFlags(self._o, flags)
        return ret

    
    def schemaValidateOneElement(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlSchemaValidateOneElement(ctxt__o, self._o)
        return ret

    
    def xpathCastNodeToNumber(self):
        ret = libxml2mod.xmlXPathCastNodeToNumber(self._o)
        return ret

    
    def xpathCastNodeToString(self):
        ret = libxml2mod.xmlXPathCastNodeToString(self._o)
        return ret

    
    def xpathCmpNodes(self, node2):
        if node2 is None:
            node2__o = None
        else:
            node2__o = node2._o
        ret = libxml2mod.xmlXPathCmpNodes(self._o, node2__o)
        return ret

    
    def xpathNewNodeSet(self):
        ret = libxml2mod.xmlXPathNewNodeSet(self._o)
        if ret is None:
            raise xpathError('xmlXPathNewNodeSet() failed')
        
        return xpathObjectRet(ret)

    
    def xpathNewValueTree(self):
        ret = libxml2mod.xmlXPathNewValueTree(self._o)
        if ret is None:
            raise xpathError('xmlXPathNewValueTree() failed')
        
        return xpathObjectRet(ret)

    
    def xpathNextAncestor(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextAncestor(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextAncestor() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextAncestorOrSelf(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextAncestorOrSelf(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextAncestorOrSelf() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextAttribute(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextAttribute(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextAttribute() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextChild(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextChild(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextChild() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextDescendant(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextDescendant(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextDescendant() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextDescendantOrSelf(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextDescendantOrSelf(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextDescendantOrSelf() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextFollowing(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextFollowing(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextFollowing() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextFollowingSibling(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextFollowingSibling(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextFollowingSibling() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextNamespace(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextNamespace(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextNamespace() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextParent(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextParent(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextParent() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextPreceding(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextPreceding(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextPreceding() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextPrecedingSibling(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextPrecedingSibling(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextPrecedingSibling() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpathNextSelf(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlXPathNextSelf(ctxt__o, self._o)
        if ret is None:
            raise xpathError('xmlXPathNextSelf() failed')
        
        _xmlNode__tmp = xmlNode(_obj = ret)
        return _xmlNode__tmp

    
    def xpointerNewCollapsedRange(self):
        ret = libxml2mod.xmlXPtrNewCollapsedRange(self._o)
        if ret is None:
            raise treeError('xmlXPtrNewCollapsedRange() failed')
        
        return xpathObjectRet(ret)

    
    def xpointerNewContext(self, doc, origin):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if origin is None:
            origin__o = None
        else:
            origin__o = origin._o
        ret = libxml2mod.xmlXPtrNewContext(doc__o, self._o, origin__o)
        if ret is None:
            raise treeError('xmlXPtrNewContext() failed')
        
        _xmlNode__tmp = xpathContext(_obj = ret)
        return _xmlNode__tmp

    
    def xpointerNewLocationSetNodes(self, end):
        if end is None:
            end__o = None
        else:
            end__o = end._o
        ret = libxml2mod.xmlXPtrNewLocationSetNodes(self._o, end__o)
        if ret is None:
            raise treeError('xmlXPtrNewLocationSetNodes() failed')
        
        return xpathObjectRet(ret)

    
    def xpointerNewRange(self, startindex, end, endindex):
        if end is None:
            end__o = None
        else:
            end__o = end._o
        ret = libxml2mod.xmlXPtrNewRange(self._o, startindex, end__o, endindex)
        if ret is None:
            raise treeError('xmlXPtrNewRange() failed')
        
        return xpathObjectRet(ret)

    
    def xpointerNewRangeNodes(self, end):
        if end is None:
            end__o = None
        else:
            end__o = end._o
        ret = libxml2mod.xmlXPtrNewRangeNodes(self._o, end__o)
        if ret is None:
            raise treeError('xmlXPtrNewRangeNodes() failed')
        
        return xpathObjectRet(ret)



class xmlDoc(xmlNode):
    
    def __init__(self, _obj = None):
        if type(_obj).__name__ != 'PyCObject':
            raise TypeError, 'xmlDoc needs a PyCObject argument'
        
        self._o = _obj
        xmlNode.__init__(self, _obj = _obj)

    
    def __repr__(self):
        return '<xmlDoc object at 0x%x>' % long(pos_id(self))

    
    def htmlAutoCloseTag(self, name, elem):
        ret = libxml2mod.htmlAutoCloseTag(self._o, name, elem)
        return ret

    
    def htmlIsAutoClosed(self, elem):
        ret = libxml2mod.htmlIsAutoClosed(self._o, elem)
        return ret

    
    def htmlDocContentDumpFormatOutput(self, buf, encoding, format):
        if buf is None:
            buf__o = None
        else:
            buf__o = buf._o
        libxml2mod.htmlDocContentDumpFormatOutput(buf__o, self._o, encoding, format)

    
    def htmlDocContentDumpOutput(self, buf, encoding):
        if buf is None:
            buf__o = None
        else:
            buf__o = buf._o
        libxml2mod.htmlDocContentDumpOutput(buf__o, self._o, encoding)

    
    def htmlDocDump(self, f):
        ret = libxml2mod.htmlDocDump(f, self._o)
        return ret

    
    def htmlGetMetaEncoding(self):
        ret = libxml2mod.htmlGetMetaEncoding(self._o)
        return ret

    
    def htmlNodeDumpFile(self, out, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.htmlNodeDumpFile(out, self._o, cur__o)

    
    def htmlNodeDumpFileFormat(self, out, cur, encoding, format):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.htmlNodeDumpFileFormat(out, self._o, cur__o, encoding, format)
        return ret

    
    def htmlNodeDumpFormatOutput(self, buf, cur, encoding, format):
        if buf is None:
            buf__o = None
        else:
            buf__o = buf._o
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.htmlNodeDumpFormatOutput(buf__o, self._o, cur__o, encoding, format)

    
    def htmlNodeDumpOutput(self, buf, cur, encoding):
        if buf is None:
            buf__o = None
        else:
            buf__o = buf._o
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.htmlNodeDumpOutput(buf__o, self._o, cur__o, encoding)

    
    def htmlSaveFile(self, filename):
        ret = libxml2mod.htmlSaveFile(filename, self._o)
        return ret

    
    def htmlSaveFileEnc(self, filename, encoding):
        ret = libxml2mod.htmlSaveFileEnc(filename, self._o, encoding)
        return ret

    
    def htmlSaveFileFormat(self, filename, encoding, format):
        ret = libxml2mod.htmlSaveFileFormat(filename, self._o, encoding, format)
        return ret

    
    def htmlSetMetaEncoding(self, encoding):
        ret = libxml2mod.htmlSetMetaEncoding(self._o, encoding)
        return ret

    
    def debugCheckDocument(self, output):
        ret = libxml2mod.xmlDebugCheckDocument(output, self._o)
        return ret

    
    def debugDumpDocument(self, output):
        libxml2mod.xmlDebugDumpDocument(output, self._o)

    
    def debugDumpDocumentHead(self, output):
        libxml2mod.xmlDebugDumpDocumentHead(output, self._o)

    
    def debugDumpEntities(self, output):
        libxml2mod.xmlDebugDumpEntities(output, self._o)

    
    def addDocEntity(self, name, type, ExternalID, SystemID, content):
        ret = libxml2mod.xmlAddDocEntity(self._o, name, type, ExternalID, SystemID, content)
        if ret is None:
            raise treeError('xmlAddDocEntity() failed')
        
        _xmlDoc__tmp = xmlEntity(_obj = ret)
        return _xmlDoc__tmp

    
    def addDtdEntity(self, name, type, ExternalID, SystemID, content):
        ret = libxml2mod.xmlAddDtdEntity(self._o, name, type, ExternalID, SystemID, content)
        if ret is None:
            raise treeError('xmlAddDtdEntity() failed')
        
        _xmlDoc__tmp = xmlEntity(_obj = ret)
        return _xmlDoc__tmp

    
    def docEntity(self, name):
        ret = libxml2mod.xmlGetDocEntity(self._o, name)
        if ret is None:
            raise treeError('xmlGetDocEntity() failed')
        
        _xmlDoc__tmp = xmlEntity(_obj = ret)
        return _xmlDoc__tmp

    
    def dtdEntity(self, name):
        ret = libxml2mod.xmlGetDtdEntity(self._o, name)
        if ret is None:
            raise treeError('xmlGetDtdEntity() failed')
        
        _xmlDoc__tmp = xmlEntity(_obj = ret)
        return _xmlDoc__tmp

    
    def encodeEntities(self, input):
        ret = libxml2mod.xmlEncodeEntities(self._o, input)
        return ret

    
    def encodeEntitiesReentrant(self, input):
        ret = libxml2mod.xmlEncodeEntitiesReentrant(self._o, input)
        return ret

    
    def encodeSpecialChars(self, input):
        ret = libxml2mod.xmlEncodeSpecialChars(self._o, input)
        return ret

    
    def parameterEntity(self, name):
        ret = libxml2mod.xmlGetParameterEntity(self._o, name)
        if ret is None:
            raise treeError('xmlGetParameterEntity() failed')
        
        _xmlDoc__tmp = xmlEntity(_obj = ret)
        return _xmlDoc__tmp

    
    def relaxNGNewDocParserCtxt(self):
        ret = libxml2mod.xmlRelaxNGNewDocParserCtxt(self._o)
        if ret is None:
            raise parserError('xmlRelaxNGNewDocParserCtxt() failed')
        
        _xmlDoc__tmp = relaxNgParserCtxt(_obj = ret)
        return _xmlDoc__tmp

    
    def relaxNGValidateDoc(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlRelaxNGValidateDoc(ctxt__o, self._o)
        return ret

    
    def relaxNGValidateFullElement(self, ctxt, elem):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlRelaxNGValidateFullElement(ctxt__o, self._o, elem__o)
        return ret

    
    def relaxNGValidatePopElement(self, ctxt, elem):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlRelaxNGValidatePopElement(ctxt__o, self._o, elem__o)
        return ret

    
    def relaxNGValidatePushElement(self, ctxt, elem):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlRelaxNGValidatePushElement(ctxt__o, self._o, elem__o)
        return ret

    
    def copyDoc(self, recursive):
        ret = libxml2mod.xmlCopyDoc(self._o, recursive)
        if ret is None:
            raise treeError('xmlCopyDoc() failed')
        
        _xmlDoc__tmp = xmlDoc(_obj = ret)
        return _xmlDoc__tmp

    
    def copyNode(self, node, extended):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        ret = libxml2mod.xmlDocCopyNode(node__o, self._o, extended)
        if ret is None:
            raise treeError('xmlDocCopyNode() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def copyNodeList(self, node):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        ret = libxml2mod.xmlDocCopyNodeList(self._o, node__o)
        if ret is None:
            raise treeError('xmlDocCopyNodeList() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def createIntSubset(self, name, ExternalID, SystemID):
        ret = libxml2mod.xmlCreateIntSubset(self._o, name, ExternalID, SystemID)
        if ret is None:
            raise treeError('xmlCreateIntSubset() failed')
        
        _xmlDoc__tmp = xmlDtd(_obj = ret)
        return _xmlDoc__tmp

    
    def docCompressMode(self):
        ret = libxml2mod.xmlGetDocCompressMode(self._o)
        return ret

    
    def dump(self, f):
        ret = libxml2mod.xmlDocDump(f, self._o)
        return ret

    
    def elemDump(self, f, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.xmlElemDump(f, self._o, cur__o)

    
    def formatDump(self, f, format):
        ret = libxml2mod.xmlDocFormatDump(f, self._o, format)
        return ret

    
    def freeDoc(self):
        libxml2mod.xmlFreeDoc(self._o)

    
    def getRootElement(self):
        ret = libxml2mod.xmlDocGetRootElement(self._o)
        if ret is None:
            raise treeError('xmlDocGetRootElement() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def intSubset(self):
        ret = libxml2mod.xmlGetIntSubset(self._o)
        if ret is None:
            raise treeError('xmlGetIntSubset() failed')
        
        _xmlDoc__tmp = xmlDtd(_obj = ret)
        return _xmlDoc__tmp

    
    def newCDataBlock(self, content, len):
        ret = libxml2mod.xmlNewCDataBlock(self._o, content, len)
        if ret is None:
            raise treeError('xmlNewCDataBlock() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newCharRef(self, name):
        ret = libxml2mod.xmlNewCharRef(self._o, name)
        if ret is None:
            raise treeError('xmlNewCharRef() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocComment(self, content):
        ret = libxml2mod.xmlNewDocComment(self._o, content)
        if ret is None:
            raise treeError('xmlNewDocComment() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocFragment(self):
        ret = libxml2mod.xmlNewDocFragment(self._o)
        if ret is None:
            raise treeError('xmlNewDocFragment() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocNode(self, ns, name, content):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlNewDocNode(self._o, ns__o, name, content)
        if ret is None:
            raise treeError('xmlNewDocNode() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocNodeEatName(self, ns, name, content):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlNewDocNodeEatName(self._o, ns__o, name, content)
        if ret is None:
            raise treeError('xmlNewDocNodeEatName() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocPI(self, name, content):
        ret = libxml2mod.xmlNewDocPI(self._o, name, content)
        if ret is None:
            raise treeError('xmlNewDocPI() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocProp(self, name, value):
        ret = libxml2mod.xmlNewDocProp(self._o, name, value)
        if ret is None:
            raise treeError('xmlNewDocProp() failed')
        
        _xmlDoc__tmp = xmlAttr(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocRawNode(self, ns, name, content):
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlNewDocRawNode(self._o, ns__o, name, content)
        if ret is None:
            raise treeError('xmlNewDocRawNode() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocText(self, content):
        ret = libxml2mod.xmlNewDocText(self._o, content)
        if ret is None:
            raise treeError('xmlNewDocText() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDocTextLen(self, content, len):
        ret = libxml2mod.xmlNewDocTextLen(self._o, content, len)
        if ret is None:
            raise treeError('xmlNewDocTextLen() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def newDtd(self, name, ExternalID, SystemID):
        ret = libxml2mod.xmlNewDtd(self._o, name, ExternalID, SystemID)
        if ret is None:
            raise treeError('xmlNewDtd() failed')
        
        _xmlDoc__tmp = xmlDtd(_obj = ret)
        return _xmlDoc__tmp

    
    def newGlobalNs(self, href, prefix):
        ret = libxml2mod.xmlNewGlobalNs(self._o, href, prefix)
        if ret is None:
            raise treeError('xmlNewGlobalNs() failed')
        
        _xmlDoc__tmp = xmlNs(_obj = ret)
        return _xmlDoc__tmp

    
    def newReference(self, name):
        ret = libxml2mod.xmlNewReference(self._o, name)
        if ret is None:
            raise treeError('xmlNewReference() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def nodeDumpOutput(self, buf, cur, level, format, encoding):
        if buf is None:
            buf__o = None
        else:
            buf__o = buf._o
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.xmlNodeDumpOutput(buf__o, self._o, cur__o, level, format, encoding)

    
    def nodeGetBase(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlNodeGetBase(self._o, cur__o)
        return ret

    
    def nodeListGetRawString(self, list, inLine):
        if list is None:
            list__o = None
        else:
            list__o = list._o
        ret = libxml2mod.xmlNodeListGetRawString(self._o, list__o, inLine)
        return ret

    
    def nodeListGetString(self, list, inLine):
        if list is None:
            list__o = None
        else:
            list__o = list._o
        ret = libxml2mod.xmlNodeListGetString(self._o, list__o, inLine)
        return ret

    
    def reconciliateNs(self, tree):
        if tree is None:
            tree__o = None
        else:
            tree__o = tree._o
        ret = libxml2mod.xmlReconciliateNs(self._o, tree__o)
        return ret

    
    def saveFile(self, filename):
        ret = libxml2mod.xmlSaveFile(filename, self._o)
        return ret

    
    def saveFileEnc(self, filename, encoding):
        ret = libxml2mod.xmlSaveFileEnc(filename, self._o, encoding)
        return ret

    
    def saveFileTo(self, buf, encoding):
        if buf is None:
            buf__o = None
        else:
            buf__o = buf._o
        ret = libxml2mod.xmlSaveFileTo(buf__o, self._o, encoding)
        return ret

    
    def saveFormatFile(self, filename, format):
        ret = libxml2mod.xmlSaveFormatFile(filename, self._o, format)
        return ret

    
    def saveFormatFileEnc(self, filename, encoding, format):
        ret = libxml2mod.xmlSaveFormatFileEnc(filename, self._o, encoding, format)
        return ret

    
    def saveFormatFileTo(self, buf, encoding, format):
        if buf is None:
            buf__o = None
        else:
            buf__o = buf._o
        ret = libxml2mod.xmlSaveFormatFileTo(buf__o, self._o, encoding, format)
        return ret

    
    def searchNs(self, node, nameSpace):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        ret = libxml2mod.xmlSearchNs(self._o, node__o, nameSpace)
        if ret is None:
            raise treeError('xmlSearchNs() failed')
        
        _xmlDoc__tmp = xmlNs(_obj = ret)
        return _xmlDoc__tmp

    
    def searchNsByHref(self, node, href):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        ret = libxml2mod.xmlSearchNsByHref(self._o, node__o, href)
        if ret is None:
            raise treeError('xmlSearchNsByHref() failed')
        
        _xmlDoc__tmp = xmlNs(_obj = ret)
        return _xmlDoc__tmp

    
    def setDocCompressMode(self, mode):
        libxml2mod.xmlSetDocCompressMode(self._o, mode)

    
    def setListDoc(self, list):
        if list is None:
            list__o = None
        else:
            list__o = list._o
        libxml2mod.xmlSetListDoc(list__o, self._o)

    
    def setRootElement(self, root):
        if root is None:
            root__o = None
        else:
            root__o = root._o
        ret = libxml2mod.xmlDocSetRootElement(self._o, root__o)
        if ret is None:
            return None
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def setTreeDoc(self, tree):
        if tree is None:
            tree__o = None
        else:
            tree__o = tree._o
        libxml2mod.xmlSetTreeDoc(tree__o, self._o)

    
    def stringGetNodeList(self, value):
        ret = libxml2mod.xmlStringGetNodeList(self._o, value)
        if ret is None:
            raise treeError('xmlStringGetNodeList() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def stringLenGetNodeList(self, value, len):
        ret = libxml2mod.xmlStringLenGetNodeList(self._o, value, len)
        if ret is None:
            raise treeError('xmlStringLenGetNodeList() failed')
        
        _xmlDoc__tmp = xmlNode(_obj = ret)
        return _xmlDoc__tmp

    
    def ID(self, ID):
        ret = libxml2mod.xmlGetID(self._o, ID)
        if ret is None:
            raise treeError('xmlGetID() failed')
        
        _xmlDoc__tmp = xmlAttr(_obj = ret)
        return _xmlDoc__tmp

    
    def isID(self, elem, attr):
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        if attr is None:
            attr__o = None
        else:
            attr__o = attr._o
        ret = libxml2mod.xmlIsID(self._o, elem__o, attr__o)
        return ret

    
    def isMixedElement(self, name):
        ret = libxml2mod.xmlIsMixedElement(self._o, name)
        return ret

    
    def isRef(self, elem, attr):
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        if attr is None:
            attr__o = None
        else:
            attr__o = attr._o
        ret = libxml2mod.xmlIsRef(self._o, elem__o, attr__o)
        return ret

    
    def removeID(self, attr):
        if attr is None:
            attr__o = None
        else:
            attr__o = attr._o
        ret = libxml2mod.xmlRemoveID(self._o, attr__o)
        return ret

    
    def removeRef(self, attr):
        if attr is None:
            attr__o = None
        else:
            attr__o = attr._o
        ret = libxml2mod.xmlRemoveRef(self._o, attr__o)
        return ret

    
    def validCtxtNormalizeAttributeValue(self, ctxt, elem, name, value):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidCtxtNormalizeAttributeValue(ctxt__o, self._o, elem__o, name, value)
        return ret

    
    def validNormalizeAttributeValue(self, elem, name, value):
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidNormalizeAttributeValue(self._o, elem__o, name, value)
        return ret

    
    def validateDocument(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlValidateDocument(ctxt__o, self._o)
        return ret

    
    def validateDocumentFinal(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlValidateDocumentFinal(ctxt__o, self._o)
        return ret

    
    def validateDtd(self, ctxt, dtd):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if dtd is None:
            dtd__o = None
        else:
            dtd__o = dtd._o
        ret = libxml2mod.xmlValidateDtd(ctxt__o, self._o, dtd__o)
        return ret

    
    def validateDtdFinal(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlValidateDtdFinal(ctxt__o, self._o)
        return ret

    
    def validateElement(self, ctxt, elem):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidateElement(ctxt__o, self._o, elem__o)
        return ret

    
    def validateNotationUse(self, ctxt, notationName):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlValidateNotationUse(ctxt__o, self._o, notationName)
        return ret

    
    def validateOneAttribute(self, ctxt, elem, attr, value):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        if attr is None:
            attr__o = None
        else:
            attr__o = attr._o
        ret = libxml2mod.xmlValidateOneAttribute(ctxt__o, self._o, elem__o, attr__o, value)
        return ret

    
    def validateOneElement(self, ctxt, elem):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidateOneElement(ctxt__o, self._o, elem__o)
        return ret

    
    def validateOneNamespace(self, ctxt, elem, prefix, ns, value):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlValidateOneNamespace(ctxt__o, self._o, elem__o, prefix, ns__o, value)
        return ret

    
    def validatePopElement(self, ctxt, elem, qname):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidatePopElement(ctxt__o, self._o, elem__o, qname)
        return ret

    
    def validatePushElement(self, ctxt, elem, qname):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidatePushElement(ctxt__o, self._o, elem__o, qname)
        return ret

    
    def validateRoot(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlValidateRoot(ctxt__o, self._o)
        return ret

    
    def xincludeProcess(self):
        ret = libxml2mod.xmlXIncludeProcess(self._o)
        return ret

    
    def xincludeProcessFlags(self, flags):
        ret = libxml2mod.xmlXIncludeProcessFlags(self._o, flags)
        return ret

    
    def NewWalker(self, reader):
        if reader is None:
            reader__o = None
        else:
            reader__o = reader._o
        ret = libxml2mod.xmlReaderNewWalker(reader__o, self._o)
        return ret

    
    def readerWalker(self):
        ret = libxml2mod.xmlReaderWalker(self._o)
        if ret is None:
            raise treeError('xmlReaderWalker() failed')
        
        _xmlDoc__tmp = xmlTextReader(_obj = ret)
        return _xmlDoc__tmp

    
    def schemaNewDocParserCtxt(self):
        ret = libxml2mod.xmlSchemaNewDocParserCtxt(self._o)
        if ret is None:
            raise parserError('xmlSchemaNewDocParserCtxt() failed')
        
        _xmlDoc__tmp = SchemaParserCtxt(_obj = ret)
        return _xmlDoc__tmp

    
    def schemaValidateDoc(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlSchemaValidateDoc(ctxt__o, self._o)
        return ret

    
    def xpathNewContext(self):
        ret = libxml2mod.xmlXPathNewContext(self._o)
        if ret is None:
            raise xpathError('xmlXPathNewContext() failed')
        
        _xmlDoc__tmp = xpathContext(_obj = ret)
        return _xmlDoc__tmp

    
    def xpathOrderDocElems(self):
        ret = libxml2mod.xmlXPathOrderDocElems(self._o)
        return ret

    
    def xpointerNewContext(self, here, origin):
        if here is None:
            here__o = None
        else:
            here__o = here._o
        if origin is None:
            origin__o = None
        else:
            origin__o = origin._o
        ret = libxml2mod.xmlXPtrNewContext(self._o, here__o, origin__o)
        if ret is None:
            raise treeError('xmlXPtrNewContext() failed')
        
        _xmlDoc__tmp = xpathContext(_obj = ret)
        return _xmlDoc__tmp



class xmlAttr(xmlNode):
    
    def __init__(self, _obj = None):
        if type(_obj).__name__ != 'PyCObject':
            raise TypeError, 'xmlAttr needs a PyCObject argument'
        
        self._o = _obj
        xmlNode.__init__(self, _obj = _obj)

    
    def __repr__(self):
        return '<xmlAttr object at 0x%x>' % long(pos_id(self))

    
    def debugDumpAttr(self, output, depth):
        libxml2mod.xmlDebugDumpAttr(output, self._o, depth)

    
    def debugDumpAttrList(self, output, depth):
        libxml2mod.xmlDebugDumpAttrList(output, self._o, depth)

    
    def copyProp(self, target):
        if target is None:
            target__o = None
        else:
            target__o = target._o
        ret = libxml2mod.xmlCopyProp(target__o, self._o)
        if ret is None:
            raise treeError('xmlCopyProp() failed')
        
        _xmlAttr__tmp = xmlAttr(_obj = ret)
        return _xmlAttr__tmp

    
    def copyPropList(self, target):
        if target is None:
            target__o = None
        else:
            target__o = target._o
        ret = libxml2mod.xmlCopyPropList(target__o, self._o)
        if ret is None:
            raise treeError('xmlCopyPropList() failed')
        
        _xmlAttr__tmp = xmlAttr(_obj = ret)
        return _xmlAttr__tmp

    
    def freeProp(self):
        libxml2mod.xmlFreeProp(self._o)

    
    def freePropList(self):
        libxml2mod.xmlFreePropList(self._o)

    
    def removeProp(self):
        ret = libxml2mod.xmlRemoveProp(self._o)
        return ret

    
    def removeID(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlRemoveID(doc__o, self._o)
        return ret

    
    def removeRef(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlRemoveRef(doc__o, self._o)
        return ret



class xmlReg:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlRegFreeRegexp(self._o)
        
        self._o = None

    
    def regexpExec(self, content):
        ret = libxml2mod.xmlRegexpExec(self._o, content)
        return ret

    
    def regexpIsDeterminist(self):
        ret = libxml2mod.xmlRegexpIsDeterminist(self._o)
        return ret

    
    def regexpPrint(self, output):
        libxml2mod.xmlRegexpPrint(output, self._o)



class relaxNgValidCtxt(relaxNgValidCtxtCore):
    
    def __init__(self, _obj = None):
        self.schema = None
        self._o = _obj
        relaxNgValidCtxtCore.__init__(self, _obj = _obj)

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlRelaxNGFreeValidCtxt(self._o)
        
        self._o = None

    
    def relaxNGValidateDoc(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlRelaxNGValidateDoc(self._o, doc__o)
        return ret

    
    def relaxNGValidateFullElement(self, doc, elem):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlRelaxNGValidateFullElement(self._o, doc__o, elem__o)
        return ret

    
    def relaxNGValidatePopElement(self, doc, elem):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlRelaxNGValidatePopElement(self._o, doc__o, elem__o)
        return ret

    
    def relaxNGValidatePushCData(self, data, len):
        ret = libxml2mod.xmlRelaxNGValidatePushCData(self._o, data, len)
        return ret

    
    def relaxNGValidatePushElement(self, doc, elem):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlRelaxNGValidatePushElement(self._o, doc__o, elem__o)
        return ret



class parserCtxt(parserCtxtCore):
    
    def __init__(self, _obj = None):
        self._o = _obj
        parserCtxtCore.__init__(self, _obj = _obj)

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlFreeParserCtxt(self._o)
        
        self._o = None

    
    def doc(self):
        ret = libxml2mod.xmlParserGetDoc(self._o)
        if ret is None:
            raise parserError('xmlParserGetDoc() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def isValid(self):
        ret = libxml2mod.xmlParserGetIsValid(self._o)
        return ret

    
    def lineNumbers(self, linenumbers):
        libxml2mod.xmlParserSetLineNumbers(self._o, linenumbers)

    
    def loadSubset(self, loadsubset):
        libxml2mod.xmlParserSetLoadSubset(self._o, loadsubset)

    
    def pedantic(self, pedantic):
        libxml2mod.xmlParserSetPedantic(self._o, pedantic)

    
    def replaceEntities(self, replaceEntities):
        libxml2mod.xmlParserSetReplaceEntities(self._o, replaceEntities)

    
    def validate(self, validate):
        libxml2mod.xmlParserSetValidate(self._o, validate)

    
    def wellFormed(self):
        ret = libxml2mod.xmlParserGetWellFormed(self._o)
        return ret

    
    def htmlCtxtReadDoc(self, cur, URL, encoding, options):
        ret = libxml2mod.htmlCtxtReadDoc(self._o, cur, URL, encoding, options)
        if ret is None:
            raise treeError('htmlCtxtReadDoc() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def htmlCtxtReadFd(self, fd, URL, encoding, options):
        ret = libxml2mod.htmlCtxtReadFd(self._o, fd, URL, encoding, options)
        if ret is None:
            raise treeError('htmlCtxtReadFd() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def htmlCtxtReadFile(self, filename, encoding, options):
        ret = libxml2mod.htmlCtxtReadFile(self._o, filename, encoding, options)
        if ret is None:
            raise treeError('htmlCtxtReadFile() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def htmlCtxtReadMemory(self, buffer, size, URL, encoding, options):
        ret = libxml2mod.htmlCtxtReadMemory(self._o, buffer, size, URL, encoding, options)
        if ret is None:
            raise treeError('htmlCtxtReadMemory() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def htmlCtxtReset(self):
        libxml2mod.htmlCtxtReset(self._o)

    
    def htmlCtxtUseOptions(self, options):
        ret = libxml2mod.htmlCtxtUseOptions(self._o, options)
        return ret

    
    def htmlFreeParserCtxt(self):
        libxml2mod.htmlFreeParserCtxt(self._o)

    
    def htmlParseCharRef(self):
        ret = libxml2mod.htmlParseCharRef(self._o)
        return ret

    
    def htmlParseChunk(self, chunk, size, terminate):
        ret = libxml2mod.htmlParseChunk(self._o, chunk, size, terminate)
        return ret

    
    def htmlParseDocument(self):
        ret = libxml2mod.htmlParseDocument(self._o)
        return ret

    
    def htmlParseElement(self):
        libxml2mod.htmlParseElement(self._o)

    
    def byteConsumed(self):
        ret = libxml2mod.xmlByteConsumed(self._o)
        return ret

    
    def clearParserCtxt(self):
        libxml2mod.xmlClearParserCtxt(self._o)

    
    def ctxtReadDoc(self, cur, URL, encoding, options):
        ret = libxml2mod.xmlCtxtReadDoc(self._o, cur, URL, encoding, options)
        if ret is None:
            raise treeError('xmlCtxtReadDoc() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def ctxtReadFd(self, fd, URL, encoding, options):
        ret = libxml2mod.xmlCtxtReadFd(self._o, fd, URL, encoding, options)
        if ret is None:
            raise treeError('xmlCtxtReadFd() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def ctxtReadFile(self, filename, encoding, options):
        ret = libxml2mod.xmlCtxtReadFile(self._o, filename, encoding, options)
        if ret is None:
            raise treeError('xmlCtxtReadFile() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def ctxtReadMemory(self, buffer, size, URL, encoding, options):
        ret = libxml2mod.xmlCtxtReadMemory(self._o, buffer, size, URL, encoding, options)
        if ret is None:
            raise treeError('xmlCtxtReadMemory() failed')
        
        _parserCtxt__tmp = xmlDoc(_obj = ret)
        return _parserCtxt__tmp

    
    def ctxtReset(self):
        libxml2mod.xmlCtxtReset(self._o)

    
    def ctxtResetPush(self, chunk, size, filename, encoding):
        ret = libxml2mod.xmlCtxtResetPush(self._o, chunk, size, filename, encoding)
        return ret

    
    def ctxtUseOptions(self, options):
        ret = libxml2mod.xmlCtxtUseOptions(self._o, options)
        return ret

    
    def initParserCtxt(self):
        ret = libxml2mod.xmlInitParserCtxt(self._o)
        return ret

    
    def parseChunk(self, chunk, size, terminate):
        ret = libxml2mod.xmlParseChunk(self._o, chunk, size, terminate)
        return ret

    
    def parseDocument(self):
        ret = libxml2mod.xmlParseDocument(self._o)
        return ret

    
    def parseExtParsedEnt(self):
        ret = libxml2mod.xmlParseExtParsedEnt(self._o)
        return ret

    
    def setupParserForBuffer(self, buffer, filename):
        libxml2mod.xmlSetupParserForBuffer(self._o, buffer, filename)

    
    def stopParser(self):
        libxml2mod.xmlStopParser(self._o)

    
    def decodeEntities(self, len, what, end, end2, end3):
        ret = libxml2mod.xmlDecodeEntities(self._o, len, what, end, end2, end3)
        return ret

    
    def handleEntity(self, entity):
        if entity is None:
            entity__o = None
        else:
            entity__o = entity._o
        libxml2mod.xmlHandleEntity(self._o, entity__o)

    
    def namespaceParseNCName(self):
        ret = libxml2mod.xmlNamespaceParseNCName(self._o)
        return ret

    
    def namespaceParseNSDef(self):
        ret = libxml2mod.xmlNamespaceParseNSDef(self._o)
        return ret

    
    def nextChar(self):
        libxml2mod.xmlNextChar(self._o)

    
    def parseAttValue(self):
        ret = libxml2mod.xmlParseAttValue(self._o)
        return ret

    
    def parseAttributeListDecl(self):
        libxml2mod.xmlParseAttributeListDecl(self._o)

    
    def parseCDSect(self):
        libxml2mod.xmlParseCDSect(self._o)

    
    def parseCharData(self, cdata):
        libxml2mod.xmlParseCharData(self._o, cdata)

    
    def parseCharRef(self):
        ret = libxml2mod.xmlParseCharRef(self._o)
        return ret

    
    def parseComment(self):
        libxml2mod.xmlParseComment(self._o)

    
    def parseContent(self):
        libxml2mod.xmlParseContent(self._o)

    
    def parseDocTypeDecl(self):
        libxml2mod.xmlParseDocTypeDecl(self._o)

    
    def parseElement(self):
        libxml2mod.xmlParseElement(self._o)

    
    def parseElementDecl(self):
        ret = libxml2mod.xmlParseElementDecl(self._o)
        return ret

    
    def parseEncName(self):
        ret = libxml2mod.xmlParseEncName(self._o)
        return ret

    
    def parseEncodingDecl(self):
        ret = libxml2mod.xmlParseEncodingDecl(self._o)
        return ret

    
    def parseEndTag(self):
        libxml2mod.xmlParseEndTag(self._o)

    
    def parseEntityDecl(self):
        libxml2mod.xmlParseEntityDecl(self._o)

    
    def parseEntityRef(self):
        ret = libxml2mod.xmlParseEntityRef(self._o)
        if ret is None:
            raise parserError('xmlParseEntityRef() failed')
        
        _parserCtxt__tmp = xmlEntity(_obj = ret)
        return _parserCtxt__tmp

    
    def parseExternalSubset(self, ExternalID, SystemID):
        libxml2mod.xmlParseExternalSubset(self._o, ExternalID, SystemID)

    
    def parseMarkupDecl(self):
        libxml2mod.xmlParseMarkupDecl(self._o)

    
    def parseMisc(self):
        libxml2mod.xmlParseMisc(self._o)

    
    def parseName(self):
        ret = libxml2mod.xmlParseName(self._o)
        return ret

    
    def parseNamespace(self):
        libxml2mod.xmlParseNamespace(self._o)

    
    def parseNmtoken(self):
        ret = libxml2mod.xmlParseNmtoken(self._o)
        return ret

    
    def parseNotationDecl(self):
        libxml2mod.xmlParseNotationDecl(self._o)

    
    def parsePEReference(self):
        libxml2mod.xmlParsePEReference(self._o)

    
    def parsePI(self):
        libxml2mod.xmlParsePI(self._o)

    
    def parsePITarget(self):
        ret = libxml2mod.xmlParsePITarget(self._o)
        return ret

    
    def parsePubidLiteral(self):
        ret = libxml2mod.xmlParsePubidLiteral(self._o)
        return ret

    
    def parseQuotedString(self):
        ret = libxml2mod.xmlParseQuotedString(self._o)
        return ret

    
    def parseReference(self):
        libxml2mod.xmlParseReference(self._o)

    
    def parseSDDecl(self):
        ret = libxml2mod.xmlParseSDDecl(self._o)
        return ret

    
    def parseStartTag(self):
        ret = libxml2mod.xmlParseStartTag(self._o)
        return ret

    
    def parseSystemLiteral(self):
        ret = libxml2mod.xmlParseSystemLiteral(self._o)
        return ret

    
    def parseTextDecl(self):
        libxml2mod.xmlParseTextDecl(self._o)

    
    def parseVersionInfo(self):
        ret = libxml2mod.xmlParseVersionInfo(self._o)
        return ret

    
    def parseVersionNum(self):
        ret = libxml2mod.xmlParseVersionNum(self._o)
        return ret

    
    def parseXMLDecl(self):
        libxml2mod.xmlParseXMLDecl(self._o)

    
    def parserHandlePEReference(self):
        libxml2mod.xmlParserHandlePEReference(self._o)

    
    def parserHandleReference(self):
        libxml2mod.xmlParserHandleReference(self._o)

    
    def popInput(self):
        ret = libxml2mod.xmlPopInput(self._o)
        return ret

    
    def scanName(self):
        ret = libxml2mod.xmlScanName(self._o)
        return ret

    
    def skipBlankChars(self):
        ret = libxml2mod.xmlSkipBlankChars(self._o)
        return ret

    
    def stringDecodeEntities(self, str, what, end, end2, end3):
        ret = libxml2mod.xmlStringDecodeEntities(self._o, str, what, end, end2, end3)
        return ret

    
    def stringLenDecodeEntities(self, str, len, what, end, end2, end3):
        ret = libxml2mod.xmlStringLenDecodeEntities(self._o, str, len, what, end, end2, end3)
        return ret



class xmlDtd(xmlNode):
    
    def __init__(self, _obj = None):
        if type(_obj).__name__ != 'PyCObject':
            raise TypeError, 'xmlDtd needs a PyCObject argument'
        
        self._o = _obj
        xmlNode.__init__(self, _obj = _obj)

    
    def __repr__(self):
        return '<xmlDtd object at 0x%x>' % long(pos_id(self))

    
    def debugDumpDTD(self, output):
        libxml2mod.xmlDebugDumpDTD(output, self._o)

    
    def copyDtd(self):
        ret = libxml2mod.xmlCopyDtd(self._o)
        if ret is None:
            raise treeError('xmlCopyDtd() failed')
        
        _xmlDtd__tmp = xmlDtd(_obj = ret)
        return _xmlDtd__tmp

    
    def freeDtd(self):
        libxml2mod.xmlFreeDtd(self._o)

    
    def dtdAttrDesc(self, elem, name):
        ret = libxml2mod.xmlGetDtdAttrDesc(self._o, elem, name)
        if ret is None:
            raise treeError('xmlGetDtdAttrDesc() failed')
        
        _xmlDtd__tmp = xmlAttribute(_obj = ret)
        return _xmlDtd__tmp

    
    def dtdElementDesc(self, name):
        ret = libxml2mod.xmlGetDtdElementDesc(self._o, name)
        if ret is None:
            raise treeError('xmlGetDtdElementDesc() failed')
        
        _xmlDtd__tmp = xmlElement(_obj = ret)
        return _xmlDtd__tmp

    
    def dtdQAttrDesc(self, elem, name, prefix):
        ret = libxml2mod.xmlGetDtdQAttrDesc(self._o, elem, name, prefix)
        if ret is None:
            raise treeError('xmlGetDtdQAttrDesc() failed')
        
        _xmlDtd__tmp = xmlAttribute(_obj = ret)
        return _xmlDtd__tmp

    
    def dtdQElementDesc(self, name, prefix):
        ret = libxml2mod.xmlGetDtdQElementDesc(self._o, name, prefix)
        if ret is None:
            raise treeError('xmlGetDtdQElementDesc() failed')
        
        _xmlDtd__tmp = xmlElement(_obj = ret)
        return _xmlDtd__tmp



class relaxNgParserCtxt:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlRelaxNGFreeParserCtxt(self._o)
        
        self._o = None

    
    def relaxNGParse(self):
        ret = libxml2mod.xmlRelaxNGParse(self._o)
        if ret is None:
            raise parserError('xmlRelaxNGParse() failed')
        
        _relaxNgParserCtxt__tmp = relaxNgSchema(_obj = ret)
        return _relaxNgParserCtxt__tmp

    
    def relaxParserSetFlag(self, flags):
        ret = libxml2mod.xmlRelaxParserSetFlag(self._o, flags)
        return ret



class xpathParserContext:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def context(self):
        ret = libxml2mod.xmlXPathParserGetContext(self._o)
        if ret is None:
            raise xpathError('xmlXPathParserGetContext() failed')
        
        _xpathParserContext__tmp = xpathContext(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathAddValues(self):
        libxml2mod.xmlXPathAddValues(self._o)

    
    def xpathBooleanFunction(self, nargs):
        libxml2mod.xmlXPathBooleanFunction(self._o, nargs)

    
    def xpathCeilingFunction(self, nargs):
        libxml2mod.xmlXPathCeilingFunction(self._o, nargs)

    
    def xpathCompareValues(self, inf, strict):
        ret = libxml2mod.xmlXPathCompareValues(self._o, inf, strict)
        return ret

    
    def xpathConcatFunction(self, nargs):
        libxml2mod.xmlXPathConcatFunction(self._o, nargs)

    
    def xpathContainsFunction(self, nargs):
        libxml2mod.xmlXPathContainsFunction(self._o, nargs)

    
    def xpathCountFunction(self, nargs):
        libxml2mod.xmlXPathCountFunction(self._o, nargs)

    
    def xpathDivValues(self):
        libxml2mod.xmlXPathDivValues(self._o)

    
    def xpathEqualValues(self):
        ret = libxml2mod.xmlXPathEqualValues(self._o)
        return ret

    
    def xpathErr(self, error):
        libxml2mod.xmlXPathErr(self._o, error)

    
    def xpathEvalExpr(self):
        libxml2mod.xmlXPathEvalExpr(self._o)

    
    def xpathFalseFunction(self, nargs):
        libxml2mod.xmlXPathFalseFunction(self._o, nargs)

    
    def xpathFloorFunction(self, nargs):
        libxml2mod.xmlXPathFloorFunction(self._o, nargs)

    
    def xpathFreeParserContext(self):
        libxml2mod.xmlXPathFreeParserContext(self._o)

    
    def xpathIdFunction(self, nargs):
        libxml2mod.xmlXPathIdFunction(self._o, nargs)

    
    def xpathLangFunction(self, nargs):
        libxml2mod.xmlXPathLangFunction(self._o, nargs)

    
    def xpathLastFunction(self, nargs):
        libxml2mod.xmlXPathLastFunction(self._o, nargs)

    
    def xpathLocalNameFunction(self, nargs):
        libxml2mod.xmlXPathLocalNameFunction(self._o, nargs)

    
    def xpathModValues(self):
        libxml2mod.xmlXPathModValues(self._o)

    
    def xpathMultValues(self):
        libxml2mod.xmlXPathMultValues(self._o)

    
    def xpathNamespaceURIFunction(self, nargs):
        libxml2mod.xmlXPathNamespaceURIFunction(self._o, nargs)

    
    def xpathNextAncestor(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextAncestor(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextAncestor() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextAncestorOrSelf(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextAncestorOrSelf(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextAncestorOrSelf() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextAttribute(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextAttribute(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextAttribute() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextChild(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextChild(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextChild() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextDescendant(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextDescendant(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextDescendant() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextDescendantOrSelf(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextDescendantOrSelf(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextDescendantOrSelf() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextFollowing(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextFollowing(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextFollowing() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextFollowingSibling(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextFollowingSibling(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextFollowingSibling() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextNamespace(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextNamespace(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextNamespace() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextParent(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextParent(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextParent() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextPreceding(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextPreceding(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextPreceding() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextPrecedingSibling(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextPrecedingSibling(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextPrecedingSibling() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNextSelf(self, cur):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlXPathNextSelf(self._o, cur__o)
        if ret is None:
            raise xpathError('xmlXPathNextSelf() failed')
        
        _xpathParserContext__tmp = xmlNode(_obj = ret)
        return _xpathParserContext__tmp

    
    def xpathNormalizeFunction(self, nargs):
        libxml2mod.xmlXPathNormalizeFunction(self._o, nargs)

    
    def xpathNotEqualValues(self):
        ret = libxml2mod.xmlXPathNotEqualValues(self._o)
        return ret

    
    def xpathNotFunction(self, nargs):
        libxml2mod.xmlXPathNotFunction(self._o, nargs)

    
    def xpathNumberFunction(self, nargs):
        libxml2mod.xmlXPathNumberFunction(self._o, nargs)

    
    def xpathParseNCName(self):
        ret = libxml2mod.xmlXPathParseNCName(self._o)
        return ret

    
    def xpathParseName(self):
        ret = libxml2mod.xmlXPathParseName(self._o)
        return ret

    
    def xpathPopBoolean(self):
        ret = libxml2mod.xmlXPathPopBoolean(self._o)
        return ret

    
    def xpathPopNumber(self):
        ret = libxml2mod.xmlXPathPopNumber(self._o)
        return ret

    
    def xpathPopString(self):
        ret = libxml2mod.xmlXPathPopString(self._o)
        return ret

    
    def xpathPositionFunction(self, nargs):
        libxml2mod.xmlXPathPositionFunction(self._o, nargs)

    
    def xpathRoot(self):
        libxml2mod.xmlXPathRoot(self._o)

    
    def xpathRoundFunction(self, nargs):
        libxml2mod.xmlXPathRoundFunction(self._o, nargs)

    
    def xpathStartsWithFunction(self, nargs):
        libxml2mod.xmlXPathStartsWithFunction(self._o, nargs)

    
    def xpathStringFunction(self, nargs):
        libxml2mod.xmlXPathStringFunction(self._o, nargs)

    
    def xpathStringLengthFunction(self, nargs):
        libxml2mod.xmlXPathStringLengthFunction(self._o, nargs)

    
    def xpathSubValues(self):
        libxml2mod.xmlXPathSubValues(self._o)

    
    def xpathSubstringAfterFunction(self, nargs):
        libxml2mod.xmlXPathSubstringAfterFunction(self._o, nargs)

    
    def xpathSubstringBeforeFunction(self, nargs):
        libxml2mod.xmlXPathSubstringBeforeFunction(self._o, nargs)

    
    def xpathSubstringFunction(self, nargs):
        libxml2mod.xmlXPathSubstringFunction(self._o, nargs)

    
    def xpathSumFunction(self, nargs):
        libxml2mod.xmlXPathSumFunction(self._o, nargs)

    
    def xpathTranslateFunction(self, nargs):
        libxml2mod.xmlXPathTranslateFunction(self._o, nargs)

    
    def xpathTrueFunction(self, nargs):
        libxml2mod.xmlXPathTrueFunction(self._o, nargs)

    
    def xpathValueFlipSign(self):
        libxml2mod.xmlXPathValueFlipSign(self._o)

    
    def xpatherror(self, file, line, no):
        libxml2mod.xmlXPatherror(self._o, file, line, no)

    
    def xpointerEvalRangePredicate(self):
        libxml2mod.xmlXPtrEvalRangePredicate(self._o)

    
    def xpointerRangeToFunction(self, nargs):
        libxml2mod.xmlXPtrRangeToFunction(self._o, nargs)



class SchemaParserCtxt:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlSchemaFreeParserCtxt(self._o)
        
        self._o = None

    
    def schemaParse(self):
        ret = libxml2mod.xmlSchemaParse(self._o)
        if ret is None:
            raise parserError('xmlSchemaParse() failed')
        
        _SchemaParserCtxt__tmp = Schema(_obj = ret)
        return _SchemaParserCtxt__tmp



class ValidCtxt(ValidCtxtCore):
    
    def __init__(self, _obj = None):
        self._o = _obj
        ValidCtxtCore.__init__(self, _obj = _obj)

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlFreeValidCtxt(self._o)
        
        self._o = None

    
    def validCtxtNormalizeAttributeValue(self, doc, elem, name, value):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidCtxtNormalizeAttributeValue(self._o, doc__o, elem__o, name, value)
        return ret

    
    def validateDocument(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlValidateDocument(self._o, doc__o)
        return ret

    
    def validateDocumentFinal(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlValidateDocumentFinal(self._o, doc__o)
        return ret

    
    def validateDtd(self, doc, dtd):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if dtd is None:
            dtd__o = None
        else:
            dtd__o = dtd._o
        ret = libxml2mod.xmlValidateDtd(self._o, doc__o, dtd__o)
        return ret

    
    def validateDtdFinal(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlValidateDtdFinal(self._o, doc__o)
        return ret

    
    def validateElement(self, doc, elem):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidateElement(self._o, doc__o, elem__o)
        return ret

    
    def validateNotationUse(self, doc, notationName):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlValidateNotationUse(self._o, doc__o, notationName)
        return ret

    
    def validateOneAttribute(self, doc, elem, attr, value):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        if attr is None:
            attr__o = None
        else:
            attr__o = attr._o
        ret = libxml2mod.xmlValidateOneAttribute(self._o, doc__o, elem__o, attr__o, value)
        return ret

    
    def validateOneElement(self, doc, elem):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidateOneElement(self._o, doc__o, elem__o)
        return ret

    
    def validateOneNamespace(self, doc, elem, prefix, ns, value):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        if ns is None:
            ns__o = None
        else:
            ns__o = ns._o
        ret = libxml2mod.xmlValidateOneNamespace(self._o, doc__o, elem__o, prefix, ns__o, value)
        return ret

    
    def validatePopElement(self, doc, elem, qname):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidatePopElement(self._o, doc__o, elem__o, qname)
        return ret

    
    def validatePushCData(self, data, len):
        ret = libxml2mod.xmlValidatePushCData(self._o, data, len)
        return ret

    
    def validatePushElement(self, doc, elem, qname):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlValidatePushElement(self._o, doc__o, elem__o, qname)
        return ret

    
    def validateRoot(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlValidateRoot(self._o, doc__o)
        return ret



class xmlNs(xmlNode):
    
    def __init__(self, _obj = None):
        if type(_obj).__name__ != 'PyCObject':
            raise TypeError, 'xmlNs needs a PyCObject argument'
        
        self._o = _obj
        xmlNode.__init__(self, _obj = _obj)

    
    def __repr__(self):
        return '<xmlNs object at 0x%x>' % long(pos_id(self))

    
    def copyNamespace(self):
        ret = libxml2mod.xmlCopyNamespace(self._o)
        if ret is None:
            raise treeError('xmlCopyNamespace() failed')
        
        _xmlNs__tmp = xmlNs(_obj = ret)
        return _xmlNs__tmp

    
    def copyNamespaceList(self):
        ret = libxml2mod.xmlCopyNamespaceList(self._o)
        if ret is None:
            raise treeError('xmlCopyNamespaceList() failed')
        
        _xmlNs__tmp = xmlNs(_obj = ret)
        return _xmlNs__tmp

    
    def freeNs(self):
        libxml2mod.xmlFreeNs(self._o)

    
    def freeNsList(self):
        libxml2mod.xmlFreeNsList(self._o)

    
    def newChild(self, parent, name, content):
        if parent is None:
            parent__o = None
        else:
            parent__o = parent._o
        ret = libxml2mod.xmlNewChild(parent__o, self._o, name, content)
        if ret is None:
            raise treeError('xmlNewChild() failed')
        
        _xmlNs__tmp = xmlNode(_obj = ret)
        return _xmlNs__tmp

    
    def newDocNode(self, doc, name, content):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlNewDocNode(doc__o, self._o, name, content)
        if ret is None:
            raise treeError('xmlNewDocNode() failed')
        
        _xmlNs__tmp = xmlNode(_obj = ret)
        return _xmlNs__tmp

    
    def newDocNodeEatName(self, doc, name, content):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlNewDocNodeEatName(doc__o, self._o, name, content)
        if ret is None:
            raise treeError('xmlNewDocNodeEatName() failed')
        
        _xmlNs__tmp = xmlNode(_obj = ret)
        return _xmlNs__tmp

    
    def newDocRawNode(self, doc, name, content):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlNewDocRawNode(doc__o, self._o, name, content)
        if ret is None:
            raise treeError('xmlNewDocRawNode() failed')
        
        _xmlNs__tmp = xmlNode(_obj = ret)
        return _xmlNs__tmp

    
    def newNodeEatName(self, name):
        ret = libxml2mod.xmlNewNodeEatName(self._o, name)
        if ret is None:
            raise treeError('xmlNewNodeEatName() failed')
        
        _xmlNs__tmp = xmlNode(_obj = ret)
        return _xmlNs__tmp

    
    def newNsProp(self, node, name, value):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        ret = libxml2mod.xmlNewNsProp(node__o, self._o, name, value)
        if ret is None:
            raise treeError('xmlNewNsProp() failed')
        
        _xmlNs__tmp = xmlAttr(_obj = ret)
        return _xmlNs__tmp

    
    def newNsPropEatName(self, node, name, value):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        ret = libxml2mod.xmlNewNsPropEatName(node__o, self._o, name, value)
        if ret is None:
            raise treeError('xmlNewNsPropEatName() failed')
        
        _xmlNs__tmp = xmlAttr(_obj = ret)
        return _xmlNs__tmp

    
    def newTextChild(self, parent, name, content):
        if parent is None:
            parent__o = None
        else:
            parent__o = parent._o
        ret = libxml2mod.xmlNewTextChild(parent__o, self._o, name, content)
        if ret is None:
            raise treeError('xmlNewTextChild() failed')
        
        _xmlNs__tmp = xmlNode(_obj = ret)
        return _xmlNs__tmp

    
    def setNs(self, node):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        libxml2mod.xmlSetNs(node__o, self._o)

    
    def setNsProp(self, node, name, value):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        ret = libxml2mod.xmlSetNsProp(node__o, self._o, name, value)
        if ret is None:
            raise treeError('xmlSetNsProp() failed')
        
        _xmlNs__tmp = xmlAttr(_obj = ret)
        return _xmlNs__tmp

    
    def unsetNsProp(self, node, name):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        ret = libxml2mod.xmlUnsetNsProp(node__o, self._o, name)
        return ret

    
    def xpathNodeSetFreeNs(self):
        libxml2mod.xmlXPathNodeSetFreeNs(self._o)



class xmlTextReaderLocator:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def BaseURI(self):
        ret = libxml2mod.xmlTextReaderLocatorBaseURI(self._o)
        return ret

    
    def LineNumber(self):
        ret = libxml2mod.xmlTextReaderLocatorLineNumber(self._o)
        return ret



class URI:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlFreeURI(self._o)
        
        self._o = None

    
    def authority(self):
        ret = libxml2mod.xmlURIGetAuthority(self._o)
        return ret

    
    def fragment(self):
        ret = libxml2mod.xmlURIGetFragment(self._o)
        return ret

    
    def opaque(self):
        ret = libxml2mod.xmlURIGetOpaque(self._o)
        return ret

    
    def path(self):
        ret = libxml2mod.xmlURIGetPath(self._o)
        return ret

    
    def port(self):
        ret = libxml2mod.xmlURIGetPort(self._o)
        return ret

    
    def query(self):
        ret = libxml2mod.xmlURIGetQuery(self._o)
        return ret

    
    def queryRaw(self):
        ret = libxml2mod.xmlURIGetQueryRaw(self._o)
        return ret

    
    def scheme(self):
        ret = libxml2mod.xmlURIGetScheme(self._o)
        return ret

    
    def server(self):
        ret = libxml2mod.xmlURIGetServer(self._o)
        return ret

    
    def setAuthority(self, authority):
        libxml2mod.xmlURISetAuthority(self._o, authority)

    
    def setFragment(self, fragment):
        libxml2mod.xmlURISetFragment(self._o, fragment)

    
    def setOpaque(self, opaque):
        libxml2mod.xmlURISetOpaque(self._o, opaque)

    
    def setPath(self, path):
        libxml2mod.xmlURISetPath(self._o, path)

    
    def setPort(self, port):
        libxml2mod.xmlURISetPort(self._o, port)

    
    def setQuery(self, query):
        libxml2mod.xmlURISetQuery(self._o, query)

    
    def setQueryRaw(self, query_raw):
        libxml2mod.xmlURISetQueryRaw(self._o, query_raw)

    
    def setScheme(self, scheme):
        libxml2mod.xmlURISetScheme(self._o, scheme)

    
    def setServer(self, server):
        libxml2mod.xmlURISetServer(self._o, server)

    
    def setUser(self, user):
        libxml2mod.xmlURISetUser(self._o, user)

    
    def user(self):
        ret = libxml2mod.xmlURIGetUser(self._o)
        return ret

    
    def parseURIReference(self, str):
        ret = libxml2mod.xmlParseURIReference(self._o, str)
        return ret

    
    def printURI(self, stream):
        libxml2mod.xmlPrintURI(stream, self._o)

    
    def saveUri(self):
        ret = libxml2mod.xmlSaveUri(self._o)
        return ret



class xmlAttribute(xmlNode):
    
    def __init__(self, _obj = None):
        if type(_obj).__name__ != 'PyCObject':
            raise TypeError, 'xmlAttribute needs a PyCObject argument'
        
        self._o = _obj
        xmlNode.__init__(self, _obj = _obj)

    
    def __repr__(self):
        return '<xmlAttribute object at 0x%x>' % long(pos_id(self))



class catalog:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlFreeCatalog(self._o)
        
        self._o = None

    
    def add(self, type, orig, replace):
        ret = libxml2mod.xmlACatalogAdd(self._o, type, orig, replace)
        return ret

    
    def catalogIsEmpty(self):
        ret = libxml2mod.xmlCatalogIsEmpty(self._o)
        return ret

    
    def convertSGMLCatalog(self):
        ret = libxml2mod.xmlConvertSGMLCatalog(self._o)
        return ret

    
    def dump(self, out):
        libxml2mod.xmlACatalogDump(self._o, out)

    
    def remove(self, value):
        ret = libxml2mod.xmlACatalogRemove(self._o, value)
        return ret

    
    def resolve(self, pubID, sysID):
        ret = libxml2mod.xmlACatalogResolve(self._o, pubID, sysID)
        return ret

    
    def resolvePublic(self, pubID):
        ret = libxml2mod.xmlACatalogResolvePublic(self._o, pubID)
        return ret

    
    def resolveSystem(self, sysID):
        ret = libxml2mod.xmlACatalogResolveSystem(self._o, sysID)
        return ret

    
    def resolveURI(self, URI):
        ret = libxml2mod.xmlACatalogResolveURI(self._o, URI)
        return ret



class xpathContext:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def contextDoc(self):
        ret = libxml2mod.xmlXPathGetContextDoc(self._o)
        if ret is None:
            raise xpathError('xmlXPathGetContextDoc() failed')
        
        _xpathContext__tmp = xmlDoc(_obj = ret)
        return _xpathContext__tmp

    
    def contextNode(self):
        ret = libxml2mod.xmlXPathGetContextNode(self._o)
        if ret is None:
            raise xpathError('xmlXPathGetContextNode() failed')
        
        _xpathContext__tmp = xmlNode(_obj = ret)
        return _xpathContext__tmp

    
    def contextPosition(self):
        ret = libxml2mod.xmlXPathGetContextPosition(self._o)
        return ret

    
    def contextSize(self):
        ret = libxml2mod.xmlXPathGetContextSize(self._o)
        return ret

    
    def function(self):
        ret = libxml2mod.xmlXPathGetFunction(self._o)
        return ret

    
    def functionURI(self):
        ret = libxml2mod.xmlXPathGetFunctionURI(self._o)
        return ret

    
    def setContextDoc(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        libxml2mod.xmlXPathSetContextDoc(self._o, doc__o)

    
    def setContextNode(self, node):
        if node is None:
            node__o = None
        else:
            node__o = node._o
        libxml2mod.xmlXPathSetContextNode(self._o, node__o)

    
    def registerXPathFunction(self, name, ns_uri, f):
        ret = libxml2mod.xmlRegisterXPathFunction(self._o, name, ns_uri, f)
        return ret

    
    def xpathContextSetCache(self, active, value, options):
        ret = libxml2mod.xmlXPathContextSetCache(self._o, active, value, options)
        return ret

    
    def xpathEval(self, str):
        ret = libxml2mod.xmlXPathEval(str, self._o)
        if ret is None:
            raise xpathError('xmlXPathEval() failed')
        
        return xpathObjectRet(ret)

    
    def xpathEvalExpression(self, str):
        ret = libxml2mod.xmlXPathEvalExpression(str, self._o)
        if ret is None:
            raise xpathError('xmlXPathEvalExpression() failed')
        
        return xpathObjectRet(ret)

    
    def xpathFreeContext(self):
        libxml2mod.xmlXPathFreeContext(self._o)

    
    def xpathNewParserContext(self, str):
        ret = libxml2mod.xmlXPathNewParserContext(str, self._o)
        if ret is None:
            raise xpathError('xmlXPathNewParserContext() failed')
        
        _xpathContext__tmp = xpathParserContext(_obj = ret)
        return _xpathContext__tmp

    
    def xpathNsLookup(self, prefix):
        ret = libxml2mod.xmlXPathNsLookup(self._o, prefix)
        return ret

    
    def xpathRegisterAllFunctions(self):
        libxml2mod.xmlXPathRegisterAllFunctions(self._o)

    
    def xpathRegisterNs(self, prefix, ns_uri):
        ret = libxml2mod.xmlXPathRegisterNs(self._o, prefix, ns_uri)
        return ret

    
    def xpathRegisteredFuncsCleanup(self):
        libxml2mod.xmlXPathRegisteredFuncsCleanup(self._o)

    
    def xpathRegisteredNsCleanup(self):
        libxml2mod.xmlXPathRegisteredNsCleanup(self._o)

    
    def xpathRegisteredVariablesCleanup(self):
        libxml2mod.xmlXPathRegisteredVariablesCleanup(self._o)

    
    def xpathVariableLookup(self, name):
        ret = libxml2mod.xmlXPathVariableLookup(self._o, name)
        if ret is None:
            raise xpathError('xmlXPathVariableLookup() failed')
        
        return xpathObjectRet(ret)

    
    def xpathVariableLookupNS(self, name, ns_uri):
        ret = libxml2mod.xmlXPathVariableLookupNS(self._o, name, ns_uri)
        if ret is None:
            raise xpathError('xmlXPathVariableLookupNS() failed')
        
        return xpathObjectRet(ret)

    
    def xpointerEval(self, str):
        ret = libxml2mod.xmlXPtrEval(str, self._o)
        if ret is None:
            raise treeError('xmlXPtrEval() failed')
        
        return xpathObjectRet(ret)



class xmlElement(xmlNode):
    
    def __init__(self, _obj = None):
        if type(_obj).__name__ != 'PyCObject':
            raise TypeError, 'xmlElement needs a PyCObject argument'
        
        self._o = _obj
        xmlNode.__init__(self, _obj = _obj)

    
    def __repr__(self):
        return '<xmlElement object at 0x%x>' % long(pos_id(self))



class xmlTextReader(xmlTextReaderCore):
    
    def __init__(self, _obj = None):
        self.input = None
        self._o = _obj
        xmlTextReaderCore.__init__(self, _obj = _obj)

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlFreeTextReader(self._o)
        
        self._o = None

    
    def AttributeCount(self):
        ret = libxml2mod.xmlTextReaderAttributeCount(self._o)
        return ret

    
    def BaseUri(self):
        ret = libxml2mod.xmlTextReaderConstBaseUri(self._o)
        return ret

    
    def ByteConsumed(self):
        ret = libxml2mod.xmlTextReaderByteConsumed(self._o)
        return ret

    
    def Close(self):
        ret = libxml2mod.xmlTextReaderClose(self._o)
        return ret

    
    def CurrentDoc(self):
        ret = libxml2mod.xmlTextReaderCurrentDoc(self._o)
        if ret is None:
            raise treeError('xmlTextReaderCurrentDoc() failed')
        
        _xmlTextReader__tmp = xmlDoc(_obj = ret)
        return _xmlTextReader__tmp

    
    def CurrentNode(self):
        ret = libxml2mod.xmlTextReaderCurrentNode(self._o)
        if ret is None:
            raise treeError('xmlTextReaderCurrentNode() failed')
        
        _xmlTextReader__tmp = xmlNode(_obj = ret)
        return _xmlTextReader__tmp

    
    def Depth(self):
        ret = libxml2mod.xmlTextReaderDepth(self._o)
        return ret

    
    def Encoding(self):
        ret = libxml2mod.xmlTextReaderConstEncoding(self._o)
        return ret

    
    def Expand(self):
        ret = libxml2mod.xmlTextReaderExpand(self._o)
        if ret is None:
            raise treeError('xmlTextReaderExpand() failed')
        
        _xmlTextReader__tmp = xmlNode(_obj = ret)
        return _xmlTextReader__tmp

    
    def GetAttribute(self, name):
        ret = libxml2mod.xmlTextReaderGetAttribute(self._o, name)
        return ret

    
    def GetAttributeNo(self, no):
        ret = libxml2mod.xmlTextReaderGetAttributeNo(self._o, no)
        return ret

    
    def GetAttributeNs(self, localName, namespaceURI):
        ret = libxml2mod.xmlTextReaderGetAttributeNs(self._o, localName, namespaceURI)
        return ret

    
    def GetParserColumnNumber(self):
        ret = libxml2mod.xmlTextReaderGetParserColumnNumber(self._o)
        return ret

    
    def GetParserLineNumber(self):
        ret = libxml2mod.xmlTextReaderGetParserLineNumber(self._o)
        return ret

    
    def GetParserProp(self, prop):
        ret = libxml2mod.xmlTextReaderGetParserProp(self._o, prop)
        return ret

    
    def GetRemainder(self):
        ret = libxml2mod.xmlTextReaderGetRemainder(self._o)
        if ret is None:
            raise treeError('xmlTextReaderGetRemainder() failed')
        
        _xmlTextReader__tmp = inputBuffer(_obj = ret)
        return _xmlTextReader__tmp

    
    def HasAttributes(self):
        ret = libxml2mod.xmlTextReaderHasAttributes(self._o)
        return ret

    
    def HasValue(self):
        ret = libxml2mod.xmlTextReaderHasValue(self._o)
        return ret

    
    def IsDefault(self):
        ret = libxml2mod.xmlTextReaderIsDefault(self._o)
        return ret

    
    def IsEmptyElement(self):
        ret = libxml2mod.xmlTextReaderIsEmptyElement(self._o)
        return ret

    
    def IsNamespaceDecl(self):
        ret = libxml2mod.xmlTextReaderIsNamespaceDecl(self._o)
        return ret

    
    def IsValid(self):
        ret = libxml2mod.xmlTextReaderIsValid(self._o)
        return ret

    
    def LocalName(self):
        ret = libxml2mod.xmlTextReaderConstLocalName(self._o)
        return ret

    
    def LookupNamespace(self, prefix):
        ret = libxml2mod.xmlTextReaderLookupNamespace(self._o, prefix)
        return ret

    
    def MoveToAttribute(self, name):
        ret = libxml2mod.xmlTextReaderMoveToAttribute(self._o, name)
        return ret

    
    def MoveToAttributeNo(self, no):
        ret = libxml2mod.xmlTextReaderMoveToAttributeNo(self._o, no)
        return ret

    
    def MoveToAttributeNs(self, localName, namespaceURI):
        ret = libxml2mod.xmlTextReaderMoveToAttributeNs(self._o, localName, namespaceURI)
        return ret

    
    def MoveToElement(self):
        ret = libxml2mod.xmlTextReaderMoveToElement(self._o)
        return ret

    
    def MoveToFirstAttribute(self):
        ret = libxml2mod.xmlTextReaderMoveToFirstAttribute(self._o)
        return ret

    
    def MoveToNextAttribute(self):
        ret = libxml2mod.xmlTextReaderMoveToNextAttribute(self._o)
        return ret

    
    def Name(self):
        ret = libxml2mod.xmlTextReaderConstName(self._o)
        return ret

    
    def NamespaceUri(self):
        ret = libxml2mod.xmlTextReaderConstNamespaceUri(self._o)
        return ret

    
    def NewDoc(self, cur, URL, encoding, options):
        ret = libxml2mod.xmlReaderNewDoc(self._o, cur, URL, encoding, options)
        return ret

    
    def NewFd(self, fd, URL, encoding, options):
        ret = libxml2mod.xmlReaderNewFd(self._o, fd, URL, encoding, options)
        return ret

    
    def NewFile(self, filename, encoding, options):
        ret = libxml2mod.xmlReaderNewFile(self._o, filename, encoding, options)
        return ret

    
    def NewMemory(self, buffer, size, URL, encoding, options):
        ret = libxml2mod.xmlReaderNewMemory(self._o, buffer, size, URL, encoding, options)
        return ret

    
    def NewWalker(self, doc):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        ret = libxml2mod.xmlReaderNewWalker(self._o, doc__o)
        return ret

    
    def Next(self):
        ret = libxml2mod.xmlTextReaderNext(self._o)
        return ret

    
    def NextSibling(self):
        ret = libxml2mod.xmlTextReaderNextSibling(self._o)
        return ret

    
    def NodeType(self):
        ret = libxml2mod.xmlTextReaderNodeType(self._o)
        return ret

    
    def Normalization(self):
        ret = libxml2mod.xmlTextReaderNormalization(self._o)
        return ret

    
    def Prefix(self):
        ret = libxml2mod.xmlTextReaderConstPrefix(self._o)
        return ret

    
    def Preserve(self):
        ret = libxml2mod.xmlTextReaderPreserve(self._o)
        if ret is None:
            raise treeError('xmlTextReaderPreserve() failed')
        
        _xmlTextReader__tmp = xmlNode(_obj = ret)
        return _xmlTextReader__tmp

    
    def QuoteChar(self):
        ret = libxml2mod.xmlTextReaderQuoteChar(self._o)
        return ret

    
    def Read(self):
        ret = libxml2mod.xmlTextReaderRead(self._o)
        return ret

    
    def ReadAttributeValue(self):
        ret = libxml2mod.xmlTextReaderReadAttributeValue(self._o)
        return ret

    
    def ReadInnerXml(self):
        ret = libxml2mod.xmlTextReaderReadInnerXml(self._o)
        return ret

    
    def ReadOuterXml(self):
        ret = libxml2mod.xmlTextReaderReadOuterXml(self._o)
        return ret

    
    def ReadState(self):
        ret = libxml2mod.xmlTextReaderReadState(self._o)
        return ret

    
    def ReadString(self):
        ret = libxml2mod.xmlTextReaderReadString(self._o)
        return ret

    
    def RelaxNGSetSchema(self, schema):
        if schema is None:
            schema__o = None
        else:
            schema__o = schema._o
        ret = libxml2mod.xmlTextReaderRelaxNGSetSchema(self._o, schema__o)
        return ret

    
    def RelaxNGValidate(self, rng):
        ret = libxml2mod.xmlTextReaderRelaxNGValidate(self._o, rng)
        return ret

    
    def SchemaValidate(self, xsd):
        ret = libxml2mod.xmlTextReaderSchemaValidate(self._o, xsd)
        return ret

    
    def SchemaValidateCtxt(self, ctxt, options):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        ret = libxml2mod.xmlTextReaderSchemaValidateCtxt(self._o, ctxt__o, options)
        return ret

    
    def SetParserProp(self, prop, value):
        ret = libxml2mod.xmlTextReaderSetParserProp(self._o, prop, value)
        return ret

    
    def SetSchema(self, schema):
        if schema is None:
            schema__o = None
        else:
            schema__o = schema._o
        ret = libxml2mod.xmlTextReaderSetSchema(self._o, schema__o)
        return ret

    
    def Setup(self, input, URL, encoding, options):
        if input is None:
            input__o = None
        else:
            input__o = input._o
        ret = libxml2mod.xmlTextReaderSetup(self._o, input__o, URL, encoding, options)
        return ret

    
    def Standalone(self):
        ret = libxml2mod.xmlTextReaderStandalone(self._o)
        return ret

    
    def String(self, str):
        ret = libxml2mod.xmlTextReaderConstString(self._o, str)
        return ret

    
    def Value(self):
        ret = libxml2mod.xmlTextReaderConstValue(self._o)
        return ret

    
    def XmlLang(self):
        ret = libxml2mod.xmlTextReaderConstXmlLang(self._o)
        return ret

    
    def XmlVersion(self):
        ret = libxml2mod.xmlTextReaderConstXmlVersion(self._o)
        return ret



class xmlEntity(xmlNode):
    
    def __init__(self, _obj = None):
        if type(_obj).__name__ != 'PyCObject':
            raise TypeError, 'xmlEntity needs a PyCObject argument'
        
        self._o = _obj
        xmlNode.__init__(self, _obj = _obj)

    
    def __repr__(self):
        return '<xmlEntity object at 0x%x>' % long(pos_id(self))

    
    def handleEntity(self, ctxt):
        if ctxt is None:
            ctxt__o = None
        else:
            ctxt__o = ctxt._o
        libxml2mod.xmlHandleEntity(ctxt__o, self._o)



class Schema:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlSchemaFree(self._o)
        
        self._o = None

    
    def SetSchema(self, reader):
        if reader is None:
            reader__o = None
        else:
            reader__o = reader._o
        ret = libxml2mod.xmlTextReaderSetSchema(reader__o, self._o)
        return ret

    
    def schemaDump(self, output):
        libxml2mod.xmlSchemaDump(output, self._o)

    
    def schemaNewValidCtxt(self):
        ret = libxml2mod.xmlSchemaNewValidCtxt(self._o)
        if ret is None:
            raise treeError('xmlSchemaNewValidCtxt() failed')
        
        _Schema__tmp = SchemaValidCtxt(_obj = ret)
        _Schema__tmp.schema = self
        return _Schema__tmp



class Error:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def code(self):
        ret = libxml2mod.xmlErrorGetCode(self._o)
        return ret

    
    def domain(self):
        ret = libxml2mod.xmlErrorGetDomain(self._o)
        return ret

    
    def file(self):
        ret = libxml2mod.xmlErrorGetFile(self._o)
        return ret

    
    def level(self):
        ret = libxml2mod.xmlErrorGetLevel(self._o)
        return ret

    
    def line(self):
        ret = libxml2mod.xmlErrorGetLine(self._o)
        return ret

    
    def message(self):
        ret = libxml2mod.xmlErrorGetMessage(self._o)
        return ret

    
    def copyError(self, to):
        if to is None:
            to__o = None
        else:
            to__o = to._o
        ret = libxml2mod.xmlCopyError(self._o, to__o)
        return ret

    
    def resetError(self):
        libxml2mod.xmlResetError(self._o)



class relaxNgSchema:
    
    def __init__(self, _obj = None):
        if _obj != None:
            self._o = _obj
            return None
        
        self._o = None

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlRelaxNGFree(self._o)
        
        self._o = None

    
    def relaxNGDump(self, output):
        libxml2mod.xmlRelaxNGDump(output, self._o)

    
    def relaxNGDumpTree(self, output):
        libxml2mod.xmlRelaxNGDumpTree(output, self._o)

    
    def relaxNGNewValidCtxt(self):
        ret = libxml2mod.xmlRelaxNGNewValidCtxt(self._o)
        if ret is None:
            raise treeError('xmlRelaxNGNewValidCtxt() failed')
        
        _relaxNgSchema__tmp = relaxNgValidCtxt(_obj = ret)
        _relaxNgSchema__tmp.schema = self
        return _relaxNgSchema__tmp

    
    def RelaxNGSetSchema(self, reader):
        if reader is None:
            reader__o = None
        else:
            reader__o = reader._o
        ret = libxml2mod.xmlTextReaderRelaxNGSetSchema(reader__o, self._o)
        return ret



class inputBuffer(ioReadWrapper):
    
    def __init__(self, _obj = None):
        self._o = _obj
        ioReadWrapper.__init__(self, _obj = _obj)

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlFreeParserInputBuffer(self._o)
        
        self._o = None

    
    def grow(self, len):
        ret = libxml2mod.xmlParserInputBufferGrow(self._o, len)
        return ret

    
    def push(self, len, buf):
        ret = libxml2mod.xmlParserInputBufferPush(self._o, len, buf)
        return ret

    
    def read(self, len):
        ret = libxml2mod.xmlParserInputBufferRead(self._o, len)
        return ret

    
    def Setup(self, reader, URL, encoding, options):
        if reader is None:
            reader__o = None
        else:
            reader__o = reader._o
        ret = libxml2mod.xmlTextReaderSetup(reader__o, self._o, URL, encoding, options)
        return ret

    
    def newTextReader(self, URI):
        ret = libxml2mod.xmlNewTextReader(self._o, URI)
        if ret is None:
            raise treeError('xmlNewTextReader() failed')
        
        _inputBuffer__tmp = xmlTextReader(_obj = ret)
        _inputBuffer__tmp.input = self
        return _inputBuffer__tmp



class SchemaValidCtxt(SchemaValidCtxtCore):
    
    def __init__(self, _obj = None):
        self.schema = None
        self._o = _obj
        SchemaValidCtxtCore.__init__(self, _obj = _obj)

    
    def __del__(self):
        if self._o != None:
            libxml2mod.xmlSchemaFreeValidCtxt(self._o)
        
        self._o = None

    
    def SchemaValidateCtxt(self, reader, options):
        if reader is None:
            reader__o = None
        else:
            reader__o = reader._o
        ret = libxml2mod.xmlTextReaderSchemaValidateCtxt(reader__o, self._o, options)
        return ret

    
    def schemaIsValid(self):
        ret = libxml2mod.xmlSchemaIsValid(self._o)
        return ret

    
    def schemaSetValidOptions(self, options):
        ret = libxml2mod.xmlSchemaSetValidOptions(self._o, options)
        return ret

    
    def schemaValidCtxtGetOptions(self):
        ret = libxml2mod.xmlSchemaValidCtxtGetOptions(self._o)
        return ret

    
    def schemaValidateDoc(self, instance):
        if instance is None:
            instance__o = None
        else:
            instance__o = instance._o
        ret = libxml2mod.xmlSchemaValidateDoc(self._o, instance__o)
        return ret

    
    def schemaValidateFile(self, filename, options):
        ret = libxml2mod.xmlSchemaValidateFile(self._o, filename, options)
        return ret

    
    def schemaValidateOneElement(self, elem):
        if elem is None:
            elem__o = None
        else:
            elem__o = elem._o
        ret = libxml2mod.xmlSchemaValidateOneElement(self._o, elem__o)
        return ret



class outputBuffer(ioWriteWrapper):
    
    def __init__(self, _obj = None):
        self._o = _obj
        ioWriteWrapper.__init__(self, _obj = _obj)

    
    def htmlDocContentDumpFormatOutput(self, cur, encoding, format):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.htmlDocContentDumpFormatOutput(self._o, cur__o, encoding, format)

    
    def htmlDocContentDumpOutput(self, cur, encoding):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.htmlDocContentDumpOutput(self._o, cur__o, encoding)

    
    def htmlNodeDumpFormatOutput(self, doc, cur, encoding, format):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.htmlNodeDumpFormatOutput(self._o, doc__o, cur__o, encoding, format)

    
    def htmlNodeDumpOutput(self, doc, cur, encoding):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.htmlNodeDumpOutput(self._o, doc__o, cur__o, encoding)

    
    def nodeDumpOutput(self, doc, cur, level, format, encoding):
        if doc is None:
            doc__o = None
        else:
            doc__o = doc._o
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        libxml2mod.xmlNodeDumpOutput(self._o, doc__o, cur__o, level, format, encoding)

    
    def saveFileTo(self, cur, encoding):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlSaveFileTo(self._o, cur__o, encoding)
        return ret

    
    def saveFormatFileTo(self, cur, encoding, format):
        if cur is None:
            cur__o = None
        else:
            cur__o = cur._o
        ret = libxml2mod.xmlSaveFormatFileTo(self._o, cur__o, encoding, format)
        return ret

    
    def write(self, len, buf):
        ret = libxml2mod.xmlOutputBufferWrite(self._o, len, buf)
        return ret

    
    def writeString(self, str):
        ret = libxml2mod.xmlOutputBufferWriteString(self._o, str)
        return ret


XLINK_SHOW_NONE = 0
XLINK_SHOW_NEW = 1
XLINK_SHOW_EMBED = 2
XLINK_SHOW_REPLACE = 3
XML_RELAXNGP_NONE = 0
XML_RELAXNGP_FREE_DOC = 1
XML_RELAXNGP_CRNG = 2
XML_BUFFER_ALLOC_DOUBLEIT = 1
XML_BUFFER_ALLOC_EXACT = 2
XML_BUFFER_ALLOC_IMMUTABLE = 3
XML_PARSER_SEVERITY_VALIDITY_WARNING = 1
XML_PARSER_SEVERITY_VALIDITY_ERROR = 2
XML_PARSER_SEVERITY_WARNING = 3
XML_PARSER_SEVERITY_ERROR = 4
XML_ATTRIBUTE_NONE = 1
XML_ATTRIBUTE_REQUIRED = 2
XML_ATTRIBUTE_IMPLIED = 3
XML_ATTRIBUTE_FIXED = 4
XML_SCHEMAS_UNKNOWN = 0
XML_SCHEMAS_STRING = 1
XML_SCHEMAS_NORMSTRING = 2
XML_SCHEMAS_DECIMAL = 3
XML_SCHEMAS_TIME = 4
XML_SCHEMAS_GDAY = 5
XML_SCHEMAS_GMONTH = 6
XML_SCHEMAS_GMONTHDAY = 7
XML_SCHEMAS_GYEAR = 8
XML_SCHEMAS_GYEARMONTH = 9
XML_SCHEMAS_DATE = 10
XML_SCHEMAS_DATETIME = 11
XML_SCHEMAS_DURATION = 12
XML_SCHEMAS_FLOAT = 13
XML_SCHEMAS_DOUBLE = 14
XML_SCHEMAS_BOOLEAN = 15
XML_SCHEMAS_TOKEN = 16
XML_SCHEMAS_LANGUAGE = 17
XML_SCHEMAS_NMTOKEN = 18
XML_SCHEMAS_NMTOKENS = 19
XML_SCHEMAS_NAME = 20
XML_SCHEMAS_QNAME = 21
XML_SCHEMAS_NCNAME = 22
XML_SCHEMAS_ID = 23
XML_SCHEMAS_IDREF = 24
XML_SCHEMAS_IDREFS = 25
XML_SCHEMAS_ENTITY = 26
XML_SCHEMAS_ENTITIES = 27
XML_SCHEMAS_NOTATION = 28
XML_SCHEMAS_ANYURI = 29
XML_SCHEMAS_INTEGER = 30
XML_SCHEMAS_NPINTEGER = 31
XML_SCHEMAS_NINTEGER = 32
XML_SCHEMAS_NNINTEGER = 33
XML_SCHEMAS_PINTEGER = 34
XML_SCHEMAS_INT = 35
XML_SCHEMAS_UINT = 36
XML_SCHEMAS_LONG = 37
XML_SCHEMAS_ULONG = 38
XML_SCHEMAS_SHORT = 39
XML_SCHEMAS_USHORT = 40
XML_SCHEMAS_BYTE = 41
XML_SCHEMAS_UBYTE = 42
XML_SCHEMAS_HEXBINARY = 43
XML_SCHEMAS_BASE64BINARY = 44
XML_SCHEMAS_ANYTYPE = 45
XML_SCHEMAS_ANYSIMPLETYPE = 46
XML_PARSER_EOF = -1
XML_PARSER_START = 0
XML_PARSER_MISC = 1
XML_PARSER_PI = 2
XML_PARSER_DTD = 3
XML_PARSER_PROLOG = 4
XML_PARSER_COMMENT = 5
XML_PARSER_START_TAG = 6
XML_PARSER_CONTENT = 7
XML_PARSER_CDATA_SECTION = 8
XML_PARSER_END_TAG = 9
XML_PARSER_ENTITY_DECL = 10
XML_PARSER_ENTITY_VALUE = 11
XML_PARSER_ATTRIBUTE_VALUE = 12
XML_PARSER_SYSTEM_LITERAL = 13
XML_PARSER_EPILOG = 14
XML_PARSER_IGNORE = 15
XML_PARSER_PUBLIC_LITERAL = 16
XML_INTERNAL_GENERAL_ENTITY = 1
XML_EXTERNAL_GENERAL_PARSED_ENTITY = 2
XML_EXTERNAL_GENERAL_UNPARSED_ENTITY = 3
XML_INTERNAL_PARAMETER_ENTITY = 4
XML_EXTERNAL_PARAMETER_ENTITY = 5
XML_INTERNAL_PREDEFINED_ENTITY = 6
XML_SAVE_FORMAT = 1
XML_SAVE_NO_DECL = 2
XML_SAVE_NO_EMPTY = 4
XML_SAVE_NO_XHTML = 8
XML_PATTERN_DEFAULT = 0
XML_PATTERN_XPATH = 1
XML_PATTERN_XSSEL = 2
XML_PATTERN_XSFIELD = 4
XML_ERR_OK = 0
XML_ERR_INTERNAL_ERROR = 1
XML_ERR_NO_MEMORY = 2
XML_ERR_DOCUMENT_START = 3
XML_ERR_DOCUMENT_EMPTY = 4
XML_ERR_DOCUMENT_END = 5
XML_ERR_INVALID_HEX_CHARREF = 6
XML_ERR_INVALID_DEC_CHARREF = 7
XML_ERR_INVALID_CHARREF = 8
XML_ERR_INVALID_CHAR = 9
XML_ERR_CHARREF_AT_EOF = 10
XML_ERR_CHARREF_IN_PROLOG = 11
XML_ERR_CHARREF_IN_EPILOG = 12
XML_ERR_CHARREF_IN_DTD = 13
XML_ERR_ENTITYREF_AT_EOF = 14
XML_ERR_ENTITYREF_IN_PROLOG = 15
XML_ERR_ENTITYREF_IN_EPILOG = 16
XML_ERR_ENTITYREF_IN_DTD = 17
XML_ERR_PEREF_AT_EOF = 18
XML_ERR_PEREF_IN_PROLOG = 19
XML_ERR_PEREF_IN_EPILOG = 20
XML_ERR_PEREF_IN_INT_SUBSET = 21
XML_ERR_ENTITYREF_NO_NAME = 22
XML_ERR_ENTITYREF_SEMICOL_MISSING = 23
XML_ERR_PEREF_NO_NAME = 24
XML_ERR_PEREF_SEMICOL_MISSING = 25
XML_ERR_UNDECLARED_ENTITY = 26
XML_WAR_UNDECLARED_ENTITY = 27
XML_ERR_UNPARSED_ENTITY = 28
XML_ERR_ENTITY_IS_EXTERNAL = 29
XML_ERR_ENTITY_IS_PARAMETER = 30
XML_ERR_UNKNOWN_ENCODING = 31
XML_ERR_UNSUPPORTED_ENCODING = 32
XML_ERR_STRING_NOT_STARTED = 33
XML_ERR_STRING_NOT_CLOSED = 34
XML_ERR_NS_DECL_ERROR = 35
XML_ERR_ENTITY_NOT_STARTED = 36
XML_ERR_ENTITY_NOT_FINISHED = 37
XML_ERR_LT_IN_ATTRIBUTE = 38
XML_ERR_ATTRIBUTE_NOT_STARTED = 39
XML_ERR_ATTRIBUTE_NOT_FINISHED = 40
XML_ERR_ATTRIBUTE_WITHOUT_VALUE = 41
XML_ERR_ATTRIBUTE_REDEFINED = 42
XML_ERR_LITERAL_NOT_STARTED = 43
XML_ERR_LITERAL_NOT_FINISHED = 44
XML_ERR_COMMENT_NOT_FINISHED = 45
XML_ERR_PI_NOT_STARTED = 46
XML_ERR_PI_NOT_FINISHED = 47
XML_ERR_NOTATION_NOT_STARTED = 48
XML_ERR_NOTATION_NOT_FINISHED = 49
XML_ERR_ATTLIST_NOT_STARTED = 50
XML_ERR_ATTLIST_NOT_FINISHED = 51
XML_ERR_MIXED_NOT_STARTED = 52
XML_ERR_MIXED_NOT_FINISHED = 53
XML_ERR_ELEMCONTENT_NOT_STARTED = 54
XML_ERR_ELEMCONTENT_NOT_FINISHED = 55
XML_ERR_XMLDECL_NOT_STARTED = 56
XML_ERR_XMLDECL_NOT_FINISHED = 57
XML_ERR_CONDSEC_NOT_STARTED = 58
XML_ERR_CONDSEC_NOT_FINISHED = 59
XML_ERR_EXT_SUBSET_NOT_FINISHED = 60
XML_ERR_DOCTYPE_NOT_FINISHED = 61
XML_ERR_MISPLACED_CDATA_END = 62
XML_ERR_CDATA_NOT_FINISHED = 63
XML_ERR_RESERVED_XML_NAME = 64
XML_ERR_SPACE_REQUIRED = 65
XML_ERR_SEPARATOR_REQUIRED = 66
XML_ERR_NMTOKEN_REQUIRED = 67
XML_ERR_NAME_REQUIRED = 68
XML_ERR_PCDATA_REQUIRED = 69
XML_ERR_URI_REQUIRED = 70
XML_ERR_PUBID_REQUIRED = 71
XML_ERR_LT_REQUIRED = 72
XML_ERR_GT_REQUIRED = 73
XML_ERR_LTSLASH_REQUIRED = 74
XML_ERR_EQUAL_REQUIRED = 75
XML_ERR_TAG_NAME_MISMATCH = 76
XML_ERR_TAG_NOT_FINISHED = 77
XML_ERR_STANDALONE_VALUE = 78
XML_ERR_ENCODING_NAME = 79
XML_ERR_HYPHEN_IN_COMMENT = 80
XML_ERR_INVALID_ENCODING = 81
XML_ERR_EXT_ENTITY_STANDALONE = 82
XML_ERR_CONDSEC_INVALID = 83
XML_ERR_VALUE_REQUIRED = 84
XML_ERR_NOT_WELL_BALANCED = 85
XML_ERR_EXTRA_CONTENT = 86
XML_ERR_ENTITY_CHAR_ERROR = 87
XML_ERR_ENTITY_PE_INTERNAL = 88
XML_ERR_ENTITY_LOOP = 89
XML_ERR_ENTITY_BOUNDARY = 90
XML_ERR_INVALID_URI = 91
XML_ERR_URI_FRAGMENT = 92
XML_WAR_CATALOG_PI = 93
XML_ERR_NO_DTD = 94
XML_ERR_CONDSEC_INVALID_KEYWORD = 95
XML_ERR_VERSION_MISSING = 96
XML_WAR_UNKNOWN_VERSION = 97
XML_WAR_LANG_VALUE = 98
XML_WAR_NS_URI = 99
XML_WAR_NS_URI_RELATIVE = 100
XML_ERR_MISSING_ENCODING = 101
XML_WAR_SPACE_VALUE = 102
XML_ERR_NOT_STANDALONE = 103
XML_ERR_ENTITY_PROCESSING = 104
XML_ERR_NOTATION_PROCESSING = 105
XML_WAR_NS_COLUMN = 106
XML_WAR_ENTITY_REDEFINED = 107
XML_NS_ERR_XML_NAMESPACE = 200
XML_NS_ERR_UNDEFINED_NAMESPACE = 201
XML_NS_ERR_QNAME = 202
XML_NS_ERR_ATTRIBUTE_REDEFINED = 203
XML_NS_ERR_EMPTY = 204
XML_DTD_ATTRIBUTE_DEFAULT = 500
XML_DTD_ATTRIBUTE_REDEFINED = 501
XML_DTD_ATTRIBUTE_VALUE = 502
XML_DTD_CONTENT_ERROR = 503
XML_DTD_CONTENT_MODEL = 504
XML_DTD_CONTENT_NOT_DETERMINIST = 505
XML_DTD_DIFFERENT_PREFIX = 506
XML_DTD_ELEM_DEFAULT_NAMESPACE = 507
XML_DTD_ELEM_NAMESPACE = 508
XML_DTD_ELEM_REDEFINED = 509
XML_DTD_EMPTY_NOTATION = 510
XML_DTD_ENTITY_TYPE = 511
XML_DTD_ID_FIXED = 512
XML_DTD_ID_REDEFINED = 513
XML_DTD_ID_SUBSET = 514
XML_DTD_INVALID_CHILD = 515
XML_DTD_INVALID_DEFAULT = 516
XML_DTD_LOAD_ERROR = 517
XML_DTD_MISSING_ATTRIBUTE = 518
XML_DTD_MIXED_CORRUPT = 519
XML_DTD_MULTIPLE_ID = 520
XML_DTD_NO_DOC = 521
XML_DTD_NO_DTD = 522
XML_DTD_NO_ELEM_NAME = 523
XML_DTD_NO_PREFIX = 524
XML_DTD_NO_ROOT = 525
XML_DTD_NOTATION_REDEFINED = 526
XML_DTD_NOTATION_VALUE = 527
XML_DTD_NOT_EMPTY = 528
XML_DTD_NOT_PCDATA = 529
XML_DTD_NOT_STANDALONE = 530
XML_DTD_ROOT_NAME = 531
XML_DTD_STANDALONE_WHITE_SPACE = 532
XML_DTD_UNKNOWN_ATTRIBUTE = 533
XML_DTD_UNKNOWN_ELEM = 534
XML_DTD_UNKNOWN_ENTITY = 535
XML_DTD_UNKNOWN_ID = 536
XML_DTD_UNKNOWN_NOTATION = 537
XML_DTD_STANDALONE_DEFAULTED = 538
XML_DTD_XMLID_VALUE = 539
XML_DTD_XMLID_TYPE = 540
XML_HTML_STRUCURE_ERROR = 800
XML_HTML_UNKNOWN_TAG = 801
XML_RNGP_ANYNAME_ATTR_ANCESTOR = 1000
XML_RNGP_ATTR_CONFLICT = 1001
XML_RNGP_ATTRIBUTE_CHILDREN = 1002
XML_RNGP_ATTRIBUTE_CONTENT = 1003
XML_RNGP_ATTRIBUTE_EMPTY = 1004
XML_RNGP_ATTRIBUTE_NOOP = 1005
XML_RNGP_CHOICE_CONTENT = 1006
XML_RNGP_CHOICE_EMPTY = 1007
XML_RNGP_CREATE_FAILURE = 1008
XML_RNGP_DATA_CONTENT = 1009
XML_RNGP_DEF_CHOICE_AND_INTERLEAVE = 1010
XML_RNGP_DEFINE_CREATE_FAILED = 1011
XML_RNGP_DEFINE_EMPTY = 1012
XML_RNGP_DEFINE_MISSING = 1013
XML_RNGP_DEFINE_NAME_MISSING = 1014
XML_RNGP_ELEM_CONTENT_EMPTY = 1015
XML_RNGP_ELEM_CONTENT_ERROR = 1016
XML_RNGP_ELEMENT_EMPTY = 1017
XML_RNGP_ELEMENT_CONTENT = 1018
XML_RNGP_ELEMENT_NAME = 1019
XML_RNGP_ELEMENT_NO_CONTENT = 1020
XML_RNGP_ELEM_TEXT_CONFLICT = 1021
XML_RNGP_EMPTY = 1022
XML_RNGP_EMPTY_CONSTRUCT = 1023
XML_RNGP_EMPTY_CONTENT = 1024
XML_RNGP_EMPTY_NOT_EMPTY = 1025
XML_RNGP_ERROR_TYPE_LIB = 1026
XML_RNGP_EXCEPT_EMPTY = 1027
XML_RNGP_EXCEPT_MISSING = 1028
XML_RNGP_EXCEPT_MULTIPLE = 1029
XML_RNGP_EXCEPT_NO_CONTENT = 1030
XML_RNGP_EXTERNALREF_EMTPY = 1031
XML_RNGP_EXTERNAL_REF_FAILURE = 1032
XML_RNGP_EXTERNALREF_RECURSE = 1033
XML_RNGP_FORBIDDEN_ATTRIBUTE = 1034
XML_RNGP_FOREIGN_ELEMENT = 1035
XML_RNGP_GRAMMAR_CONTENT = 1036
XML_RNGP_GRAMMAR_EMPTY = 1037
XML_RNGP_GRAMMAR_MISSING = 1038
XML_RNGP_GRAMMAR_NO_START = 1039
XML_RNGP_GROUP_ATTR_CONFLICT = 1040
XML_RNGP_HREF_ERROR = 1041
XML_RNGP_INCLUDE_EMPTY = 1042
XML_RNGP_INCLUDE_FAILURE = 1043
XML_RNGP_INCLUDE_RECURSE = 1044
XML_RNGP_INTERLEAVE_ADD = 1045
XML_RNGP_INTERLEAVE_CREATE_FAILED = 1046
XML_RNGP_INTERLEAVE_EMPTY = 1047
XML_RNGP_INTERLEAVE_NO_CONTENT = 1048
XML_RNGP_INVALID_DEFINE_NAME = 1049
XML_RNGP_INVALID_URI = 1050
XML_RNGP_INVALID_VALUE = 1051
XML_RNGP_MISSING_HREF = 1052
XML_RNGP_NAME_MISSING = 1053
XML_RNGP_NEED_COMBINE = 1054
XML_RNGP_NOTALLOWED_NOT_EMPTY = 1055
XML_RNGP_NSNAME_ATTR_ANCESTOR = 1056
XML_RNGP_NSNAME_NO_NS = 1057
XML_RNGP_PARAM_FORBIDDEN = 1058
XML_RNGP_PARAM_NAME_MISSING = 1059
XML_RNGP_PARENTREF_CREATE_FAILED = 1060
XML_RNGP_PARENTREF_NAME_INVALID = 1061
XML_RNGP_PARENTREF_NO_NAME = 1062
XML_RNGP_PARENTREF_NO_PARENT = 1063
XML_RNGP_PARENTREF_NOT_EMPTY = 1064
XML_RNGP_PARSE_ERROR = 1065
XML_RNGP_PAT_ANYNAME_EXCEPT_ANYNAME = 1066
XML_RNGP_PAT_ATTR_ATTR = 1067
XML_RNGP_PAT_ATTR_ELEM = 1068
XML_RNGP_PAT_DATA_EXCEPT_ATTR = 1069
XML_RNGP_PAT_DATA_EXCEPT_ELEM = 1070
XML_RNGP_PAT_DATA_EXCEPT_EMPTY = 1071
XML_RNGP_PAT_DATA_EXCEPT_GROUP = 1072
XML_RNGP_PAT_DATA_EXCEPT_INTERLEAVE = 1073
XML_RNGP_PAT_DATA_EXCEPT_LIST = 1074
XML_RNGP_PAT_DATA_EXCEPT_ONEMORE = 1075
XML_RNGP_PAT_DATA_EXCEPT_REF = 1076
XML_RNGP_PAT_DATA_EXCEPT_TEXT = 1077
XML_RNGP_PAT_LIST_ATTR = 1078
XML_RNGP_PAT_LIST_ELEM = 1079
XML_RNGP_PAT_LIST_INTERLEAVE = 1080
XML_RNGP_PAT_LIST_LIST = 1081
XML_RNGP_PAT_LIST_REF = 1082
XML_RNGP_PAT_LIST_TEXT = 1083
XML_RNGP_PAT_NSNAME_EXCEPT_ANYNAME = 1084
XML_RNGP_PAT_NSNAME_EXCEPT_NSNAME = 1085
XML_RNGP_PAT_ONEMORE_GROUP_ATTR = 1086
XML_RNGP_PAT_ONEMORE_INTERLEAVE_ATTR = 1087
XML_RNGP_PAT_START_ATTR = 1088
XML_RNGP_PAT_START_DATA = 1089
XML_RNGP_PAT_START_EMPTY = 1090
XML_RNGP_PAT_START_GROUP = 1091
XML_RNGP_PAT_START_INTERLEAVE = 1092
XML_RNGP_PAT_START_LIST = 1093
XML_RNGP_PAT_START_ONEMORE = 1094
XML_RNGP_PAT_START_TEXT = 1095
XML_RNGP_PAT_START_VALUE = 1096
XML_RNGP_PREFIX_UNDEFINED = 1097
XML_RNGP_REF_CREATE_FAILED = 1098
XML_RNGP_REF_CYCLE = 1099
XML_RNGP_REF_NAME_INVALID = 1100
XML_RNGP_REF_NO_DEF = 1101
XML_RNGP_REF_NO_NAME = 1102
XML_RNGP_REF_NOT_EMPTY = 1103
XML_RNGP_START_CHOICE_AND_INTERLEAVE = 1104
XML_RNGP_START_CONTENT = 1105
XML_RNGP_START_EMPTY = 1106
XML_RNGP_START_MISSING = 1107
XML_RNGP_TEXT_EXPECTED = 1108
XML_RNGP_TEXT_HAS_CHILD = 1109
XML_RNGP_TYPE_MISSING = 1110
XML_RNGP_TYPE_NOT_FOUND = 1111
XML_RNGP_TYPE_VALUE = 1112
XML_RNGP_UNKNOWN_ATTRIBUTE = 1113
XML_RNGP_UNKNOWN_COMBINE = 1114
XML_RNGP_UNKNOWN_CONSTRUCT = 1115
XML_RNGP_UNKNOWN_TYPE_LIB = 1116
XML_RNGP_URI_FRAGMENT = 1117
XML_RNGP_URI_NOT_ABSOLUTE = 1118
XML_RNGP_VALUE_EMPTY = 1119
XML_RNGP_VALUE_NO_CONTENT = 1120
XML_RNGP_XMLNS_NAME = 1121
XML_RNGP_XML_NS = 1122
XML_XPATH_EXPRESSION_OK = 1200
XML_XPATH_NUMBER_ERROR = 1201
XML_XPATH_UNFINISHED_LITERAL_ERROR = 1202
XML_XPATH_START_LITERAL_ERROR = 1203
XML_XPATH_VARIABLE_REF_ERROR = 1204
XML_XPATH_UNDEF_VARIABLE_ERROR = 1205
XML_XPATH_INVALID_PREDICATE_ERROR = 1206
XML_XPATH_EXPR_ERROR = 1207
XML_XPATH_UNCLOSED_ERROR = 1208
XML_XPATH_UNKNOWN_FUNC_ERROR = 1209
XML_XPATH_INVALID_OPERAND = 1210
XML_XPATH_INVALID_TYPE = 1211
XML_XPATH_INVALID_ARITY = 1212
XML_XPATH_INVALID_CTXT_SIZE = 1213
XML_XPATH_INVALID_CTXT_POSITION = 1214
XML_XPATH_MEMORY_ERROR = 1215
XML_XPTR_SYNTAX_ERROR = 1216
XML_XPTR_RESOURCE_ERROR = 1217
XML_XPTR_SUB_RESOURCE_ERROR = 1218
XML_XPATH_UNDEF_PREFIX_ERROR = 1219
XML_XPATH_ENCODING_ERROR = 1220
XML_XPATH_INVALID_CHAR_ERROR = 1221
XML_TREE_INVALID_HEX = 1300
XML_TREE_INVALID_DEC = 1301
XML_TREE_UNTERMINATED_ENTITY = 1302
XML_SAVE_NOT_UTF8 = 1400
XML_SAVE_CHAR_INVALID = 1401
XML_SAVE_NO_DOCTYPE = 1402
XML_SAVE_UNKNOWN_ENCODING = 1403
XML_REGEXP_COMPILE_ERROR = 1450
XML_IO_UNKNOWN = 1500
XML_IO_EACCES = 1501
XML_IO_EAGAIN = 1502
XML_IO_EBADF = 1503
XML_IO_EBADMSG = 1504
XML_IO_EBUSY = 1505
XML_IO_ECANCELED = 1506
XML_IO_ECHILD = 1507
XML_IO_EDEADLK = 1508
XML_IO_EDOM = 1509
XML_IO_EEXIST = 1510
XML_IO_EFAULT = 1511
XML_IO_EFBIG = 1512
XML_IO_EINPROGRESS = 1513
XML_IO_EINTR = 1514
XML_IO_EINVAL = 1515
XML_IO_EIO = 1516
XML_IO_EISDIR = 1517
XML_IO_EMFILE = 1518
XML_IO_EMLINK = 1519
XML_IO_EMSGSIZE = 1520
XML_IO_ENAMETOOLONG = 1521
XML_IO_ENFILE = 1522
XML_IO_ENODEV = 1523
XML_IO_ENOENT = 1524
XML_IO_ENOEXEC = 1525
XML_IO_ENOLCK = 1526
XML_IO_ENOMEM = 1527
XML_IO_ENOSPC = 1528
XML_IO_ENOSYS = 1529
XML_IO_ENOTDIR = 1530
XML_IO_ENOTEMPTY = 1531
XML_IO_ENOTSUP = 1532
XML_IO_ENOTTY = 1533
XML_IO_ENXIO = 1534
XML_IO_EPERM = 1535
XML_IO_EPIPE = 1536
XML_IO_ERANGE = 1537
XML_IO_EROFS = 1538
XML_IO_ESPIPE = 1539
XML_IO_ESRCH = 1540
XML_IO_ETIMEDOUT = 1541
XML_IO_EXDEV = 1542
XML_IO_NETWORK_ATTEMPT = 1543
XML_IO_ENCODER = 1544
XML_IO_FLUSH = 1545
XML_IO_WRITE = 1546
XML_IO_NO_INPUT = 1547
XML_IO_BUFFER_FULL = 1548
XML_IO_LOAD_ERROR = 1549
XML_IO_ENOTSOCK = 1550
XML_IO_EISCONN = 1551
XML_IO_ECONNREFUSED = 1552
XML_IO_ENETUNREACH = 1553
XML_IO_EADDRINUSE = 1554
XML_IO_EALREADY = 1555
XML_IO_EAFNOSUPPORT = 1556
XML_XINCLUDE_RECURSION = 1600
XML_XINCLUDE_PARSE_VALUE = 1601
XML_XINCLUDE_ENTITY_DEF_MISMATCH = 1602
XML_XINCLUDE_NO_HREF = 1603
XML_XINCLUDE_NO_FALLBACK = 1604
XML_XINCLUDE_HREF_URI = 1605
XML_XINCLUDE_TEXT_FRAGMENT = 1606
XML_XINCLUDE_TEXT_DOCUMENT = 1607
XML_XINCLUDE_INVALID_CHAR = 1608
XML_XINCLUDE_BUILD_FAILED = 1609
XML_XINCLUDE_UNKNOWN_ENCODING = 1610
XML_XINCLUDE_MULTIPLE_ROOT = 1611
XML_XINCLUDE_XPTR_FAILED = 1612
XML_XINCLUDE_XPTR_RESULT = 1613
XML_XINCLUDE_INCLUDE_IN_INCLUDE = 1614
XML_XINCLUDE_FALLBACKS_IN_INCLUDE = 1615
XML_XINCLUDE_FALLBACK_NOT_IN_INCLUDE = 1616
XML_XINCLUDE_DEPRECATED_NS = 1617
XML_XINCLUDE_FRAGMENT_ID = 1618
XML_CATALOG_MISSING_ATTR = 1650
XML_CATALOG_ENTRY_BROKEN = 1651
XML_CATALOG_PREFER_VALUE = 1652
XML_CATALOG_NOT_CATALOG = 1653
XML_CATALOG_RECURSION = 1654
XML_SCHEMAP_PREFIX_UNDEFINED = 1700
XML_SCHEMAP_ATTRFORMDEFAULT_VALUE = 1701
XML_SCHEMAP_ATTRGRP_NONAME_NOREF = 1702
XML_SCHEMAP_ATTR_NONAME_NOREF = 1703
XML_SCHEMAP_COMPLEXTYPE_NONAME_NOREF = 1704
XML_SCHEMAP_ELEMFORMDEFAULT_VALUE = 1705
XML_SCHEMAP_ELEM_NONAME_NOREF = 1706
XML_SCHEMAP_EXTENSION_NO_BASE = 1707
XML_SCHEMAP_FACET_NO_VALUE = 1708
XML_SCHEMAP_FAILED_BUILD_IMPORT = 1709
XML_SCHEMAP_GROUP_NONAME_NOREF = 1710
XML_SCHEMAP_IMPORT_NAMESPACE_NOT_URI = 1711
XML_SCHEMAP_IMPORT_REDEFINE_NSNAME = 1712
XML_SCHEMAP_IMPORT_SCHEMA_NOT_URI = 1713
XML_SCHEMAP_INVALID_BOOLEAN = 1714
XML_SCHEMAP_INVALID_ENUM = 1715
XML_SCHEMAP_INVALID_FACET = 1716
XML_SCHEMAP_INVALID_FACET_VALUE = 1717
XML_SCHEMAP_INVALID_MAXOCCURS = 1718
XML_SCHEMAP_INVALID_MINOCCURS = 1719
XML_SCHEMAP_INVALID_REF_AND_SUBTYPE = 1720
XML_SCHEMAP_INVALID_WHITE_SPACE = 1721
XML_SCHEMAP_NOATTR_NOREF = 1722
XML_SCHEMAP_NOTATION_NO_NAME = 1723
XML_SCHEMAP_NOTYPE_NOREF = 1724
XML_SCHEMAP_REF_AND_SUBTYPE = 1725
XML_SCHEMAP_RESTRICTION_NONAME_NOREF = 1726
XML_SCHEMAP_SIMPLETYPE_NONAME = 1727
XML_SCHEMAP_TYPE_AND_SUBTYPE = 1728
XML_SCHEMAP_UNKNOWN_ALL_CHILD = 1729
XML_SCHEMAP_UNKNOWN_ANYATTRIBUTE_CHILD = 1730
XML_SCHEMAP_UNKNOWN_ATTR_CHILD = 1731
XML_SCHEMAP_UNKNOWN_ATTRGRP_CHILD = 1732
XML_SCHEMAP_UNKNOWN_ATTRIBUTE_GROUP = 1733
XML_SCHEMAP_UNKNOWN_BASE_TYPE = 1734
XML_SCHEMAP_UNKNOWN_CHOICE_CHILD = 1735
XML_SCHEMAP_UNKNOWN_COMPLEXCONTENT_CHILD = 1736
XML_SCHEMAP_UNKNOWN_COMPLEXTYPE_CHILD = 1737
XML_SCHEMAP_UNKNOWN_ELEM_CHILD = 1738
XML_SCHEMAP_UNKNOWN_EXTENSION_CHILD = 1739
XML_SCHEMAP_UNKNOWN_FACET_CHILD = 1740
XML_SCHEMAP_UNKNOWN_FACET_TYPE = 1741
XML_SCHEMAP_UNKNOWN_GROUP_CHILD = 1742
XML_SCHEMAP_UNKNOWN_IMPORT_CHILD = 1743
XML_SCHEMAP_UNKNOWN_LIST_CHILD = 1744
XML_SCHEMAP_UNKNOWN_NOTATION_CHILD = 1745
XML_SCHEMAP_UNKNOWN_PROCESSCONTENT_CHILD = 1746
XML_SCHEMAP_UNKNOWN_REF = 1747
XML_SCHEMAP_UNKNOWN_RESTRICTION_CHILD = 1748
XML_SCHEMAP_UNKNOWN_SCHEMAS_CHILD = 1749
XML_SCHEMAP_UNKNOWN_SEQUENCE_CHILD = 1750
XML_SCHEMAP_UNKNOWN_SIMPLECONTENT_CHILD = 1751
XML_SCHEMAP_UNKNOWN_SIMPLETYPE_CHILD = 1752
XML_SCHEMAP_UNKNOWN_TYPE = 1753
XML_SCHEMAP_UNKNOWN_UNION_CHILD = 1754
XML_SCHEMAP_ELEM_DEFAULT_FIXED = 1755
XML_SCHEMAP_REGEXP_INVALID = 1756
XML_SCHEMAP_FAILED_LOAD = 1757
XML_SCHEMAP_NOTHING_TO_PARSE = 1758
XML_SCHEMAP_NOROOT = 1759
XML_SCHEMAP_REDEFINED_GROUP = 1760
XML_SCHEMAP_REDEFINED_TYPE = 1761
XML_SCHEMAP_REDEFINED_ELEMENT = 1762
XML_SCHEMAP_REDEFINED_ATTRGROUP = 1763
XML_SCHEMAP_REDEFINED_ATTR = 1764
XML_SCHEMAP_REDEFINED_NOTATION = 1765
XML_SCHEMAP_FAILED_PARSE = 1766
XML_SCHEMAP_UNKNOWN_PREFIX = 1767
XML_SCHEMAP_DEF_AND_PREFIX = 1768
XML_SCHEMAP_UNKNOWN_INCLUDE_CHILD = 1769
XML_SCHEMAP_INCLUDE_SCHEMA_NOT_URI = 1770
XML_SCHEMAP_INCLUDE_SCHEMA_NO_URI = 1771
XML_SCHEMAP_NOT_SCHEMA = 1772
XML_SCHEMAP_UNKNOWN_MEMBER_TYPE = 1773
XML_SCHEMAP_INVALID_ATTR_USE = 1774
XML_SCHEMAP_RECURSIVE = 1775
XML_SCHEMAP_SUPERNUMEROUS_LIST_ITEM_TYPE = 1776
XML_SCHEMAP_INVALID_ATTR_COMBINATION = 1777
XML_SCHEMAP_INVALID_ATTR_INLINE_COMBINATION = 1778
XML_SCHEMAP_MISSING_SIMPLETYPE_CHILD = 1779
XML_SCHEMAP_INVALID_ATTR_NAME = 1780
XML_SCHEMAP_REF_AND_CONTENT = 1781
XML_SCHEMAP_CT_PROPS_CORRECT_1 = 1782
XML_SCHEMAP_CT_PROPS_CORRECT_2 = 1783
XML_SCHEMAP_CT_PROPS_CORRECT_3 = 1784
XML_SCHEMAP_CT_PROPS_CORRECT_4 = 1785
XML_SCHEMAP_CT_PROPS_CORRECT_5 = 1786
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_1 = 1787
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_2_1_1 = 1788
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_2_1_2 = 1789
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_2_2 = 1790
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_3 = 1791
XML_SCHEMAP_WILDCARD_INVALID_NS_MEMBER = 1792
XML_SCHEMAP_INTERSECTION_NOT_EXPRESSIBLE = 1793
XML_SCHEMAP_UNION_NOT_EXPRESSIBLE = 1794
XML_SCHEMAP_SRC_IMPORT_3_1 = 1795
XML_SCHEMAP_SRC_IMPORT_3_2 = 1796
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_4_1 = 1797
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_4_2 = 1798
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_4_3 = 1799
XML_SCHEMAP_COS_CT_EXTENDS_1_3 = 1800
XML_SCHEMAV_NOROOT = 1801
XML_SCHEMAV_UNDECLAREDELEM = 1802
XML_SCHEMAV_NOTTOPLEVEL = 1803
XML_SCHEMAV_MISSING = 1804
XML_SCHEMAV_WRONGELEM = 1805
XML_SCHEMAV_NOTYPE = 1806
XML_SCHEMAV_NOROLLBACK = 1807
XML_SCHEMAV_ISABSTRACT = 1808
XML_SCHEMAV_NOTEMPTY = 1809
XML_SCHEMAV_ELEMCONT = 1810
XML_SCHEMAV_HAVEDEFAULT = 1811
XML_SCHEMAV_NOTNILLABLE = 1812
XML_SCHEMAV_EXTRACONTENT = 1813
XML_SCHEMAV_INVALIDATTR = 1814
XML_SCHEMAV_INVALIDELEM = 1815
XML_SCHEMAV_NOTDETERMINIST = 1816
XML_SCHEMAV_CONSTRUCT = 1817
XML_SCHEMAV_INTERNAL = 1818
XML_SCHEMAV_NOTSIMPLE = 1819
XML_SCHEMAV_ATTRUNKNOWN = 1820
XML_SCHEMAV_ATTRINVALID = 1821
XML_SCHEMAV_VALUE = 1822
XML_SCHEMAV_FACET = 1823
XML_SCHEMAV_CVC_DATATYPE_VALID_1_2_1 = 1824
XML_SCHEMAV_CVC_DATATYPE_VALID_1_2_2 = 1825
XML_SCHEMAV_CVC_DATATYPE_VALID_1_2_3 = 1826
XML_SCHEMAV_CVC_TYPE_3_1_1 = 1827
XML_SCHEMAV_CVC_TYPE_3_1_2 = 1828
XML_SCHEMAV_CVC_FACET_VALID = 1829
XML_SCHEMAV_CVC_LENGTH_VALID = 1830
XML_SCHEMAV_CVC_MINLENGTH_VALID = 1831
XML_SCHEMAV_CVC_MAXLENGTH_VALID = 1832
XML_SCHEMAV_CVC_MININCLUSIVE_VALID = 1833
XML_SCHEMAV_CVC_MAXINCLUSIVE_VALID = 1834
XML_SCHEMAV_CVC_MINEXCLUSIVE_VALID = 1835
XML_SCHEMAV_CVC_MAXEXCLUSIVE_VALID = 1836
XML_SCHEMAV_CVC_TOTALDIGITS_VALID = 1837
XML_SCHEMAV_CVC_FRACTIONDIGITS_VALID = 1838
XML_SCHEMAV_CVC_PATTERN_VALID = 1839
XML_SCHEMAV_CVC_ENUMERATION_VALID = 1840
XML_SCHEMAV_CVC_COMPLEX_TYPE_2_1 = 1841
XML_SCHEMAV_CVC_COMPLEX_TYPE_2_2 = 1842
XML_SCHEMAV_CVC_COMPLEX_TYPE_2_3 = 1843
XML_SCHEMAV_CVC_COMPLEX_TYPE_2_4 = 1844
XML_SCHEMAV_CVC_ELT_1 = 1845
XML_SCHEMAV_CVC_ELT_2 = 1846
XML_SCHEMAV_CVC_ELT_3_1 = 1847
XML_SCHEMAV_CVC_ELT_3_2_1 = 1848
XML_SCHEMAV_CVC_ELT_3_2_2 = 1849
XML_SCHEMAV_CVC_ELT_4_1 = 1850
XML_SCHEMAV_CVC_ELT_4_2 = 1851
XML_SCHEMAV_CVC_ELT_4_3 = 1852
XML_SCHEMAV_CVC_ELT_5_1_1 = 1853
XML_SCHEMAV_CVC_ELT_5_1_2 = 1854
XML_SCHEMAV_CVC_ELT_5_2_1 = 1855
XML_SCHEMAV_CVC_ELT_5_2_2_1 = 1856
XML_SCHEMAV_CVC_ELT_5_2_2_2_1 = 1857
XML_SCHEMAV_CVC_ELT_5_2_2_2_2 = 1858
XML_SCHEMAV_CVC_ELT_6 = 1859
XML_SCHEMAV_CVC_ELT_7 = 1860
XML_SCHEMAV_CVC_ATTRIBUTE_1 = 1861
XML_SCHEMAV_CVC_ATTRIBUTE_2 = 1862
XML_SCHEMAV_CVC_ATTRIBUTE_3 = 1863
XML_SCHEMAV_CVC_ATTRIBUTE_4 = 1864
XML_SCHEMAV_CVC_COMPLEX_TYPE_3_1 = 1865
XML_SCHEMAV_CVC_COMPLEX_TYPE_3_2_1 = 1866
XML_SCHEMAV_CVC_COMPLEX_TYPE_3_2_2 = 1867
XML_SCHEMAV_CVC_COMPLEX_TYPE_4 = 1868
XML_SCHEMAV_CVC_COMPLEX_TYPE_5_1 = 1869
XML_SCHEMAV_CVC_COMPLEX_TYPE_5_2 = 1870
XML_SCHEMAV_ELEMENT_CONTENT = 1871
XML_SCHEMAV_DOCUMENT_ELEMENT_MISSING = 1872
XML_SCHEMAV_CVC_COMPLEX_TYPE_1 = 1873
XML_SCHEMAV_CVC_AU = 1874
XML_SCHEMAV_CVC_TYPE_1 = 1875
XML_SCHEMAV_CVC_TYPE_2 = 1876
XML_SCHEMAV_CVC_IDC = 1877
XML_SCHEMAV_CVC_WILDCARD = 1878
XML_SCHEMAV_MISC = 1879
XML_XPTR_UNKNOWN_SCHEME = 1900
XML_XPTR_CHILDSEQ_START = 1901
XML_XPTR_EVAL_FAILED = 1902
XML_XPTR_EXTRA_OBJECTS = 1903
XML_C14N_CREATE_CTXT = 1950
XML_C14N_REQUIRES_UTF8 = 1951
XML_C14N_CREATE_STACK = 1952
XML_C14N_INVALID_NODE = 1953
XML_C14N_UNKNOW_NODE = 1954
XML_C14N_RELATIVE_NAMESPACE = 1955
XML_FTP_PASV_ANSWER = 2000
XML_FTP_EPSV_ANSWER = 2001
XML_FTP_ACCNT = 2002
XML_FTP_URL_SYNTAX = 2003
XML_HTTP_URL_SYNTAX = 2020
XML_HTTP_USE_IP = 2021
XML_HTTP_UNKNOWN_HOST = 2022
XML_SCHEMAP_SRC_SIMPLE_TYPE_1 = 3000
XML_SCHEMAP_SRC_SIMPLE_TYPE_2 = 3001
XML_SCHEMAP_SRC_SIMPLE_TYPE_3 = 3002
XML_SCHEMAP_SRC_SIMPLE_TYPE_4 = 3003
XML_SCHEMAP_SRC_RESOLVE = 3004
XML_SCHEMAP_SRC_RESTRICTION_BASE_OR_SIMPLETYPE = 3005
XML_SCHEMAP_SRC_LIST_ITEMTYPE_OR_SIMPLETYPE = 3006
XML_SCHEMAP_SRC_UNION_MEMBERTYPES_OR_SIMPLETYPES = 3007
XML_SCHEMAP_ST_PROPS_CORRECT_1 = 3008
XML_SCHEMAP_ST_PROPS_CORRECT_2 = 3009
XML_SCHEMAP_ST_PROPS_CORRECT_3 = 3010
XML_SCHEMAP_COS_ST_RESTRICTS_1_1 = 3011
XML_SCHEMAP_COS_ST_RESTRICTS_1_2 = 3012
XML_SCHEMAP_COS_ST_RESTRICTS_1_3_1 = 3013
XML_SCHEMAP_COS_ST_RESTRICTS_1_3_2 = 3014
XML_SCHEMAP_COS_ST_RESTRICTS_2_1 = 3015
XML_SCHEMAP_COS_ST_RESTRICTS_2_3_1_1 = 3016
XML_SCHEMAP_COS_ST_RESTRICTS_2_3_1_2 = 3017
XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_1 = 3018
XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_2 = 3019
XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_3 = 3020
XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_4 = 3021
XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_5 = 3022
XML_SCHEMAP_COS_ST_RESTRICTS_3_1 = 3023
XML_SCHEMAP_COS_ST_RESTRICTS_3_3_1 = 3024
XML_SCHEMAP_COS_ST_RESTRICTS_3_3_1_2 = 3025
XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_2 = 3026
XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_1 = 3027
XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_3 = 3028
XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_4 = 3029
XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_5 = 3030
XML_SCHEMAP_COS_ST_DERIVED_OK_2_1 = 3031
XML_SCHEMAP_COS_ST_DERIVED_OK_2_2 = 3032
XML_SCHEMAP_S4S_ELEM_NOT_ALLOWED = 3033
XML_SCHEMAP_S4S_ELEM_MISSING = 3034
XML_SCHEMAP_S4S_ATTR_NOT_ALLOWED = 3035
XML_SCHEMAP_S4S_ATTR_MISSING = 3036
XML_SCHEMAP_S4S_ATTR_INVALID_VALUE = 3037
XML_SCHEMAP_SRC_ELEMENT_1 = 3038
XML_SCHEMAP_SRC_ELEMENT_2_1 = 3039
XML_SCHEMAP_SRC_ELEMENT_2_2 = 3040
XML_SCHEMAP_SRC_ELEMENT_3 = 3041
XML_SCHEMAP_P_PROPS_CORRECT_1 = 3042
XML_SCHEMAP_P_PROPS_CORRECT_2_1 = 3043
XML_SCHEMAP_P_PROPS_CORRECT_2_2 = 3044
XML_SCHEMAP_E_PROPS_CORRECT_2 = 3045
XML_SCHEMAP_E_PROPS_CORRECT_3 = 3046
XML_SCHEMAP_E_PROPS_CORRECT_4 = 3047
XML_SCHEMAP_E_PROPS_CORRECT_5 = 3048
XML_SCHEMAP_E_PROPS_CORRECT_6 = 3049
XML_SCHEMAP_SRC_INCLUDE = 3050
XML_SCHEMAP_SRC_ATTRIBUTE_1 = 3051
XML_SCHEMAP_SRC_ATTRIBUTE_2 = 3052
XML_SCHEMAP_SRC_ATTRIBUTE_3_1 = 3053
XML_SCHEMAP_SRC_ATTRIBUTE_3_2 = 3054
XML_SCHEMAP_SRC_ATTRIBUTE_4 = 3055
XML_SCHEMAP_NO_XMLNS = 3056
XML_SCHEMAP_NO_XSI = 3057
XML_SCHEMAP_COS_VALID_DEFAULT_1 = 3058
XML_SCHEMAP_COS_VALID_DEFAULT_2_1 = 3059
XML_SCHEMAP_COS_VALID_DEFAULT_2_2_1 = 3060
XML_SCHEMAP_COS_VALID_DEFAULT_2_2_2 = 3061
XML_SCHEMAP_CVC_SIMPLE_TYPE = 3062
XML_SCHEMAP_COS_CT_EXTENDS_1_1 = 3063
XML_SCHEMAP_SRC_IMPORT_1_1 = 3064
XML_SCHEMAP_SRC_IMPORT_1_2 = 3065
XML_SCHEMAP_SRC_IMPORT_2 = 3066
XML_SCHEMAP_SRC_IMPORT_2_1 = 3067
XML_SCHEMAP_SRC_IMPORT_2_2 = 3068
XML_SCHEMAP_INTERNAL = 3069
XML_SCHEMAP_NOT_DETERMINISTIC = 3070
XML_SCHEMAP_SRC_ATTRIBUTE_GROUP_1 = 3071
XML_SCHEMAP_SRC_ATTRIBUTE_GROUP_2 = 3072
XML_SCHEMAP_SRC_ATTRIBUTE_GROUP_3 = 3073
XML_SCHEMAP_MG_PROPS_CORRECT_1 = 3074
XML_SCHEMAP_MG_PROPS_CORRECT_2 = 3075
XML_SCHEMAP_SRC_CT_1 = 3076
XML_SCHEMAP_DERIVATION_OK_RESTRICTION_2_1_3 = 3077
XML_SCHEMAP_AU_PROPS_CORRECT_2 = 3078
XML_SCHEMAP_A_PROPS_CORRECT_2 = 3079
XML_SCHEMAP_C_PROPS_CORRECT = 3080
XML_SCHEMAP_SRC_REDEFINE = 3081
XML_SCHEMAP_SRC_IMPORT = 3082
XML_SCHEMAP_WARN_SKIP_SCHEMA = 3083
XML_SCHEMAP_WARN_UNLOCATED_SCHEMA = 3084
XML_SCHEMAP_WARN_ATTR_REDECL_PROH = 3085
XML_SCHEMAP_WARN_ATTR_POINTLESS_PROH = 3086
XML_SCHEMAP_AG_PROPS_CORRECT = 3087
XML_SCHEMAP_COS_CT_EXTENDS_1_2 = 3088
XML_SCHEMAP_AU_PROPS_CORRECT = 3089
XML_SCHEMAP_A_PROPS_CORRECT_3 = 3090
XML_SCHEMAP_COS_ALL_LIMITED = 3091
XML_MODULE_OPEN = 4900
XML_MODULE_CLOSE = 4901
XML_CHECK_FOUND_ELEMENT = 5000
XML_CHECK_FOUND_ATTRIBUTE = 5001
XML_CHECK_FOUND_TEXT = 5002
XML_CHECK_FOUND_CDATA = 5003
XML_CHECK_FOUND_ENTITYREF = 5004
XML_CHECK_FOUND_ENTITY = 5005
XML_CHECK_FOUND_PI = 5006
XML_CHECK_FOUND_COMMENT = 5007
XML_CHECK_FOUND_DOCTYPE = 5008
XML_CHECK_FOUND_FRAGMENT = 5009
XML_CHECK_FOUND_NOTATION = 5010
XML_CHECK_UNKNOWN_NODE = 5011
XML_CHECK_ENTITY_TYPE = 5012
XML_CHECK_NO_PARENT = 5013
XML_CHECK_NO_DOC = 5014
XML_CHECK_NO_NAME = 5015
XML_CHECK_NO_ELEM = 5016
XML_CHECK_WRONG_DOC = 5017
XML_CHECK_NO_PREV = 5018
XML_CHECK_WRONG_PREV = 5019
XML_CHECK_NO_NEXT = 5020
XML_CHECK_WRONG_NEXT = 5021
XML_CHECK_NOT_DTD = 5022
XML_CHECK_NOT_ATTR = 5023
XML_CHECK_NOT_ATTR_DECL = 5024
XML_CHECK_NOT_ELEM_DECL = 5025
XML_CHECK_NOT_ENTITY_DECL = 5026
XML_CHECK_NOT_NS_DECL = 5027
XML_CHECK_NO_HREF = 5028
XML_CHECK_WRONG_PARENT = 5029
XML_CHECK_NS_SCOPE = 5030
XML_CHECK_NS_ANCESTOR = 5031
XML_CHECK_NOT_UTF8 = 5032
XML_CHECK_NO_DICT = 5033
XML_CHECK_NOT_NCNAME = 5034
XML_CHECK_OUTSIDE_DICT = 5035
XML_CHECK_WRONG_NAME = 5036
XML_CHECK_NAME_NOT_NULL = 5037
XML_I18N_NO_NAME = 6000
XML_I18N_NO_HANDLER = 6001
XML_I18N_EXCESS_HANDLER = 6002
XML_I18N_CONV_FAILED = 6003
XML_I18N_NO_OUTPUT = 6004
XML_CHECK_ = 6005
XML_CHECK_X = 6006
XML_EXP_EMPTY = 0
XML_EXP_FORBID = 1
XML_EXP_ATOM = 2
XML_EXP_SEQ = 3
XML_EXP_OR = 4
XML_EXP_COUNT = 5
XML_MODULE_LAZY = 1
XML_MODULE_LOCAL = 2
XML_PARSER_LOADDTD = 1
XML_PARSER_DEFAULTATTRS = 2
XML_PARSER_VALIDATE = 3
XML_PARSER_SUBST_ENTITIES = 4
XML_READER_TYPE_NONE = 0
XML_READER_TYPE_ELEMENT = 1
XML_READER_TYPE_ATTRIBUTE = 2
XML_READER_TYPE_TEXT = 3
XML_READER_TYPE_CDATA = 4
XML_READER_TYPE_ENTITY_REFERENCE = 5
XML_READER_TYPE_ENTITY = 6
XML_READER_TYPE_PROCESSING_INSTRUCTION = 7
XML_READER_TYPE_COMMENT = 8
XML_READER_TYPE_DOCUMENT = 9
XML_READER_TYPE_DOCUMENT_TYPE = 10
XML_READER_TYPE_DOCUMENT_FRAGMENT = 11
XML_READER_TYPE_NOTATION = 12
XML_READER_TYPE_WHITESPACE = 13
XML_READER_TYPE_SIGNIFICANT_WHITESPACE = 14
XML_READER_TYPE_END_ELEMENT = 15
XML_READER_TYPE_END_ENTITY = 16
XML_READER_TYPE_XML_DECLARATION = 17
XML_CATA_PREFER_NONE = 0
XML_CATA_PREFER_PUBLIC = 1
XML_CATA_PREFER_SYSTEM = 2
XML_ELEMENT_NODE = 1
XML_ATTRIBUTE_NODE = 2
XML_TEXT_NODE = 3
XML_CDATA_SECTION_NODE = 4
XML_ENTITY_REF_NODE = 5
XML_ENTITY_NODE = 6
XML_PI_NODE = 7
XML_COMMENT_NODE = 8
XML_DOCUMENT_NODE = 9
XML_DOCUMENT_TYPE_NODE = 10
XML_DOCUMENT_FRAG_NODE = 11
XML_NOTATION_NODE = 12
XML_HTML_DOCUMENT_NODE = 13
XML_DTD_NODE = 14
XML_ELEMENT_DECL = 15
XML_ATTRIBUTE_DECL = 16
XML_ENTITY_DECL = 17
XML_NAMESPACE_DECL = 18
XML_XINCLUDE_START = 19
XML_XINCLUDE_END = 20
XML_DOCB_DOCUMENT_NODE = 21
XLINK_ACTUATE_NONE = 0
XLINK_ACTUATE_AUTO = 1
XLINK_ACTUATE_ONREQUEST = 2
XML_WITH_THREAD = 1
XML_WITH_TREE = 2
XML_WITH_OUTPUT = 3
XML_WITH_PUSH = 4
XML_WITH_READER = 5
XML_WITH_PATTERN = 6
XML_WITH_WRITER = 7
XML_WITH_SAX1 = 8
XML_WITH_FTP = 9
XML_WITH_HTTP = 10
XML_WITH_VALID = 11
XML_WITH_HTML = 12
XML_WITH_LEGACY = 13
XML_WITH_C14N = 14
XML_WITH_CATALOG = 15
XML_WITH_XPATH = 16
XML_WITH_XPTR = 17
XML_WITH_XINCLUDE = 18
XML_WITH_ICONV = 19
XML_WITH_ISO8859X = 20
XML_WITH_UNICODE = 21
XML_WITH_REGEXP = 22
XML_WITH_AUTOMATA = 23
XML_WITH_EXPR = 24
XML_WITH_SCHEMAS = 25
XML_WITH_SCHEMATRON = 26
XML_WITH_MODULES = 27
XML_WITH_DEBUG = 28
XML_WITH_DEBUG_MEM = 29
XML_WITH_DEBUG_RUN = 30
XML_WITH_ZLIB = 31
XML_WITH_NONE = 99999
XML_ELEMENT_CONTENT_ONCE = 1
XML_ELEMENT_CONTENT_OPT = 2
XML_ELEMENT_CONTENT_MULT = 3
XML_ELEMENT_CONTENT_PLUS = 4
XPATH_EXPRESSION_OK = 0
XPATH_NUMBER_ERROR = 1
XPATH_UNFINISHED_LITERAL_ERROR = 2
XPATH_START_LITERAL_ERROR = 3
XPATH_VARIABLE_REF_ERROR = 4
XPATH_UNDEF_VARIABLE_ERROR = 5
XPATH_INVALID_PREDICATE_ERROR = 6
XPATH_EXPR_ERROR = 7
XPATH_UNCLOSED_ERROR = 8
XPATH_UNKNOWN_FUNC_ERROR = 9
XPATH_INVALID_OPERAND = 10
XPATH_INVALID_TYPE = 11
XPATH_INVALID_ARITY = 12
XPATH_INVALID_CTXT_SIZE = 13
XPATH_INVALID_CTXT_POSITION = 14
XPATH_MEMORY_ERROR = 15
XPTR_SYNTAX_ERROR = 16
XPTR_RESOURCE_ERROR = 17
XPTR_SUB_RESOURCE_ERROR = 18
XPATH_UNDEF_PREFIX_ERROR = 19
XPATH_ENCODING_ERROR = 20
XPATH_INVALID_CHAR_ERROR = 21
XPATH_INVALID_CTXT = 22
XML_ELEMENT_CONTENT_PCDATA = 1
XML_ELEMENT_CONTENT_ELEMENT = 2
XML_ELEMENT_CONTENT_SEQ = 3
XML_ELEMENT_CONTENT_OR = 4
XML_TEXTREADER_MODE_INITIAL = 0
XML_TEXTREADER_MODE_INTERACTIVE = 1
XML_TEXTREADER_MODE_ERROR = 2
XML_TEXTREADER_MODE_EOF = 3
XML_TEXTREADER_MODE_CLOSED = 4
XML_TEXTREADER_MODE_READING = 5
XML_ERR_NONE = 0
XML_ERR_WARNING = 1
XML_ERR_ERROR = 2
XML_ERR_FATAL = 3
XML_CHAR_ENCODING_ERROR = -1
XML_CHAR_ENCODING_NONE = 0
XML_CHAR_ENCODING_UTF8 = 1
XML_CHAR_ENCODING_UTF16LE = 2
XML_CHAR_ENCODING_UTF16BE = 3
XML_CHAR_ENCODING_UCS4LE = 4
XML_CHAR_ENCODING_UCS4BE = 5
XML_CHAR_ENCODING_EBCDIC = 6
XML_CHAR_ENCODING_UCS4_2143 = 7
XML_CHAR_ENCODING_UCS4_3412 = 8
XML_CHAR_ENCODING_UCS2 = 9
XML_CHAR_ENCODING_8859_1 = 10
XML_CHAR_ENCODING_8859_2 = 11
XML_CHAR_ENCODING_8859_3 = 12
XML_CHAR_ENCODING_8859_4 = 13
XML_CHAR_ENCODING_8859_5 = 14
XML_CHAR_ENCODING_8859_6 = 15
XML_CHAR_ENCODING_8859_7 = 16
XML_CHAR_ENCODING_8859_8 = 17
XML_CHAR_ENCODING_8859_9 = 18
XML_CHAR_ENCODING_2022_JP = 19
XML_CHAR_ENCODING_SHIFT_JIS = 20
XML_CHAR_ENCODING_EUC_JP = 21
XML_CHAR_ENCODING_ASCII = 22
XML_FROM_NONE = 0
XML_FROM_PARSER = 1
XML_FROM_TREE = 2
XML_FROM_NAMESPACE = 3
XML_FROM_DTD = 4
XML_FROM_HTML = 5
XML_FROM_MEMORY = 6
XML_FROM_OUTPUT = 7
XML_FROM_IO = 8
XML_FROM_FTP = 9
XML_FROM_HTTP = 10
XML_FROM_XINCLUDE = 11
XML_FROM_XPATH = 12
XML_FROM_XPOINTER = 13
XML_FROM_REGEXP = 14
XML_FROM_DATATYPE = 15
XML_FROM_SCHEMASP = 16
XML_FROM_SCHEMASV = 17
XML_FROM_RELAXNGP = 18
XML_FROM_RELAXNGV = 19
XML_FROM_CATALOG = 20
XML_FROM_C14N = 21
XML_FROM_XSLT = 22
XML_FROM_VALID = 23
XML_FROM_CHECK = 24
XML_FROM_WRITER = 25
XML_FROM_MODULE = 26
XML_FROM_I18N = 27
HTML_NA = 0
HTML_INVALID = 1
HTML_DEPRECATED = 2
HTML_VALID = 4
HTML_REQUIRED = 12
XML_SCHEMA_VAL_VC_I_CREATE = 1
XML_SCHEMA_WHITESPACE_UNKNOWN = 0
XML_SCHEMA_WHITESPACE_PRESERVE = 1
XML_SCHEMA_WHITESPACE_REPLACE = 2
XML_SCHEMA_WHITESPACE_COLLAPSE = 3
HTML_PARSE_RECOVER = 1
HTML_PARSE_NOERROR = 32
HTML_PARSE_NOWARNING = 64
HTML_PARSE_PEDANTIC = 128
HTML_PARSE_NOBLANKS = 256
HTML_PARSE_NONET = 2048
HTML_PARSE_COMPACT = 65536
XML_RELAXNG_OK = 0
XML_RELAXNG_ERR_MEMORY = 1
XML_RELAXNG_ERR_TYPE = 2
XML_RELAXNG_ERR_TYPEVAL = 3
XML_RELAXNG_ERR_DUPID = 4
XML_RELAXNG_ERR_TYPECMP = 5
XML_RELAXNG_ERR_NOSTATE = 6
XML_RELAXNG_ERR_NODEFINE = 7
XML_RELAXNG_ERR_LISTEXTRA = 8
XML_RELAXNG_ERR_LISTEMPTY = 9
XML_RELAXNG_ERR_INTERNODATA = 10
XML_RELAXNG_ERR_INTERSEQ = 11
XML_RELAXNG_ERR_INTEREXTRA = 12
XML_RELAXNG_ERR_ELEMNAME = 13
XML_RELAXNG_ERR_ATTRNAME = 14
XML_RELAXNG_ERR_ELEMNONS = 15
XML_RELAXNG_ERR_ATTRNONS = 16
XML_RELAXNG_ERR_ELEMWRONGNS = 17
XML_RELAXNG_ERR_ATTRWRONGNS = 18
XML_RELAXNG_ERR_ELEMEXTRANS = 19
XML_RELAXNG_ERR_ATTREXTRANS = 20
XML_RELAXNG_ERR_ELEMNOTEMPTY = 21
XML_RELAXNG_ERR_NOELEM = 22
XML_RELAXNG_ERR_NOTELEM = 23
XML_RELAXNG_ERR_ATTRVALID = 24
XML_RELAXNG_ERR_CONTENTVALID = 25
XML_RELAXNG_ERR_EXTRACONTENT = 26
XML_RELAXNG_ERR_INVALIDATTR = 27
XML_RELAXNG_ERR_DATAELEM = 28
XML_RELAXNG_ERR_VALELEM = 29
XML_RELAXNG_ERR_LISTELEM = 30
XML_RELAXNG_ERR_DATATYPE = 31
XML_RELAXNG_ERR_VALUE = 32
XML_RELAXNG_ERR_LIST = 33
XML_RELAXNG_ERR_NOGRAMMAR = 34
XML_RELAXNG_ERR_EXTRADATA = 35
XML_RELAXNG_ERR_LACKDATA = 36
XML_RELAXNG_ERR_INTERNAL = 37
XML_RELAXNG_ERR_ELEMWRONG = 38
XML_RELAXNG_ERR_TEXTWRONG = 39
XML_CATA_ALLOW_NONE = 0
XML_CATA_ALLOW_GLOBAL = 1
XML_CATA_ALLOW_DOCUMENT = 2
XML_CATA_ALLOW_ALL = 3
XML_ATTRIBUTE_CDATA = 1
XML_ATTRIBUTE_ID = 2
XML_ATTRIBUTE_IDREF = 3
XML_ATTRIBUTE_IDREFS = 4
XML_ATTRIBUTE_ENTITY = 5
XML_ATTRIBUTE_ENTITIES = 6
XML_ATTRIBUTE_NMTOKEN = 7
XML_ATTRIBUTE_NMTOKENS = 8
XML_ATTRIBUTE_ENUMERATION = 9
XML_ATTRIBUTE_NOTATION = 10
XML_SCHEMATRON_OUT_QUIET = 1
XML_SCHEMATRON_OUT_TEXT = 2
XML_SCHEMATRON_OUT_XML = 4
XML_SCHEMATRON_OUT_FILE = 256
XML_SCHEMATRON_OUT_BUFFER = 512
XML_SCHEMATRON_OUT_IO = 1024
XML_SCHEMA_CONTENT_UNKNOWN = 0
XML_SCHEMA_CONTENT_EMPTY = 1
XML_SCHEMA_CONTENT_ELEMENTS = 2
XML_SCHEMA_CONTENT_MIXED = 3
XML_SCHEMA_CONTENT_SIMPLE = 4
XML_SCHEMA_CONTENT_MIXED_OR_ELEMENTS = 5
XML_SCHEMA_CONTENT_BASIC = 6
XML_SCHEMA_CONTENT_ANY = 7
XML_SCHEMA_TYPE_BASIC = 1
XML_SCHEMA_TYPE_ANY = 2
XML_SCHEMA_TYPE_FACET = 3
XML_SCHEMA_TYPE_SIMPLE = 4
XML_SCHEMA_TYPE_COMPLEX = 5
XML_SCHEMA_TYPE_SEQUENCE = 6
XML_SCHEMA_TYPE_CHOICE = 7
XML_SCHEMA_TYPE_ALL = 8
XML_SCHEMA_TYPE_SIMPLE_CONTENT = 9
XML_SCHEMA_TYPE_COMPLEX_CONTENT = 10
XML_SCHEMA_TYPE_UR = 11
XML_SCHEMA_TYPE_RESTRICTION = 12
XML_SCHEMA_TYPE_EXTENSION = 13
XML_SCHEMA_TYPE_ELEMENT = 14
XML_SCHEMA_TYPE_ATTRIBUTE = 15
XML_SCHEMA_TYPE_ATTRIBUTEGROUP = 16
XML_SCHEMA_TYPE_GROUP = 17
XML_SCHEMA_TYPE_NOTATION = 18
XML_SCHEMA_TYPE_LIST = 19
XML_SCHEMA_TYPE_UNION = 20
XML_SCHEMA_TYPE_ANY_ATTRIBUTE = 21
XML_SCHEMA_TYPE_IDC_UNIQUE = 22
XML_SCHEMA_TYPE_IDC_KEY = 23
XML_SCHEMA_TYPE_IDC_KEYREF = 24
XML_SCHEMA_TYPE_PARTICLE = 25
XML_SCHEMA_TYPE_ATTRIBUTE_USE = 26
XML_SCHEMA_FACET_MININCLUSIVE = 1000
XML_SCHEMA_FACET_MINEXCLUSIVE = 1001
XML_SCHEMA_FACET_MAXINCLUSIVE = 1002
XML_SCHEMA_FACET_MAXEXCLUSIVE = 1003
XML_SCHEMA_FACET_TOTALDIGITS = 1004
XML_SCHEMA_FACET_FRACTIONDIGITS = 1005
XML_SCHEMA_FACET_PATTERN = 1006
XML_SCHEMA_FACET_ENUMERATION = 1007
XML_SCHEMA_FACET_WHITESPACE = 1008
XML_SCHEMA_FACET_LENGTH = 1009
XML_SCHEMA_FACET_MAXLENGTH = 1010
XML_SCHEMA_FACET_MINLENGTH = 1011
XML_SCHEMA_EXTRA_QNAMEREF = 2000
XML_SCHEMA_EXTRA_ATTR_USE_PROHIB = 2001
XML_PARSE_UNKNOWN = 0
XML_PARSE_DOM = 1
XML_PARSE_SAX = 2
XML_PARSE_PUSH_DOM = 3
XML_PARSE_PUSH_SAX = 4
XML_PARSE_READER = 5
XML_PARSE_RECOVER = 1
XML_PARSE_NOENT = 2
XML_PARSE_DTDLOAD = 4
XML_PARSE_DTDATTR = 8
XML_PARSE_DTDVALID = 16
XML_PARSE_NOERROR = 32
XML_PARSE_NOWARNING = 64
XML_PARSE_PEDANTIC = 128
XML_PARSE_NOBLANKS = 256
XML_PARSE_SAX1 = 512
XML_PARSE_XINCLUDE = 1024
XML_PARSE_NONET = 2048
XML_PARSE_NODICT = 4096
XML_PARSE_NSCLEAN = 8192
XML_PARSE_NOCDATA = 16384
XML_PARSE_NOXINCNODE = 32768
XML_PARSE_COMPACT = 65536
XML_ELEMENT_TYPE_UNDEFINED = 0
XML_ELEMENT_TYPE_EMPTY = 1
XML_ELEMENT_TYPE_ANY = 2
XML_ELEMENT_TYPE_MIXED = 3
XML_ELEMENT_TYPE_ELEMENT = 4
XLINK_TYPE_NONE = 0
XLINK_TYPE_SIMPLE = 1
XLINK_TYPE_EXTENDED = 2
XLINK_TYPE_EXTENDED_SET = 3
XPATH_UNDEFINED = 0
XPATH_NODESET = 1
XPATH_BOOLEAN = 2
XPATH_NUMBER = 3
XPATH_STRING = 4
XPATH_POINT = 5
XPATH_RANGE = 6
XPATH_LOCATIONSET = 7
XPATH_USERS = 8
XPATH_XSLT_TREE = 9
XML_SCHEMAS_ERR_OK = 0
XML_SCHEMAS_ERR_NOROOT = 1
XML_SCHEMAS_ERR_UNDECLAREDELEM = 2
XML_SCHEMAS_ERR_NOTTOPLEVEL = 3
XML_SCHEMAS_ERR_MISSING = 4
XML_SCHEMAS_ERR_WRONGELEM = 5
XML_SCHEMAS_ERR_NOTYPE = 6
XML_SCHEMAS_ERR_NOROLLBACK = 7
XML_SCHEMAS_ERR_ISABSTRACT = 8
XML_SCHEMAS_ERR_NOTEMPTY = 9
XML_SCHEMAS_ERR_ELEMCONT = 10
XML_SCHEMAS_ERR_HAVEDEFAULT = 11
XML_SCHEMAS_ERR_NOTNILLABLE = 12
XML_SCHEMAS_ERR_EXTRACONTENT = 13
XML_SCHEMAS_ERR_INVALIDATTR = 14
XML_SCHEMAS_ERR_INVALIDELEM = 15
XML_SCHEMAS_ERR_NOTDETERMINIST = 16
XML_SCHEMAS_ERR_CONSTRUCT = 17
XML_SCHEMAS_ERR_INTERNAL = 18
XML_SCHEMAS_ERR_NOTSIMPLE = 19
XML_SCHEMAS_ERR_ATTRUNKNOWN = 20
XML_SCHEMAS_ERR_ATTRINVALID = 21
XML_SCHEMAS_ERR_VALUE = 22
XML_SCHEMAS_ERR_FACET = 23
XML_SCHEMAS_ERR_ = 24
XML_SCHEMAS_ERR_XXX = 25
